/**
 * Created by Li Hongwei on 2015-11-19.
 */
define(function(require,exports,module) {
    var $ = require("frozen"),
        frozenUi = require("frozen"),
        IScroll = require("iscroll"),
        RSAUtils = require('rsa'),
        md5 = require('md5'),
        rest = require('rest'),
        template = require('template'),
        store = require('store');
    //select = require("select");

    module.exports = {
        createScroll : function(container, option) {
            var scroll = new Scroll(container, option);
            scroll.init();
        },
        showErrorTip : showErrorTip,
        showLoading : showLoading,
        hideLoading :hideLoading,
        dateFormat : dateFormat,
        getNowDate : getNowDate,
        alert: alert,
        getMenu : getMenu,
        cleanSessionStorage : cleanSessionStorage,
        showLoginDialog : showLoginDialog
    };

    /**
     * 菜单获取
     * @param _menuList
     * @param type
     * @returns {string}
     */
    function getMenu(type) {
        var _menuList = JSON.parse(sessionStorage.getItem('menuList')),
            html = '',
            rowData = '',
            menuList = seajs.data.vars.menuList,
            count = 0;
        function menuOperation(value) {
            count++;
            rowData = menuList[type][value.yyfwDm];

            if(rowData) {
                if(rowData.ysbz) {
                    html += '<li class="ui-col ui-col-33" data-href="'+ rowData.url +'" data-mark="'+ rowData.appmark +'"><div><b><i class="iconfont icon-3x ' +  rowData.class + '"></i></b><span>' +  rowData.name +'</span></div></li>';
                } else {
                    html += '<li class="ui-col ui-col-33 ui-list-disabled" data-href="javascrpit:void(0);" data-mark="'+ rowData.appmark +'"><div><b><i class="iconfont icon-3x ' +  rowData.class + '"></i></b><span>' +  rowData.name +'</span></div></li>';
                }
            }
        }

        if(sessionStorage.getItem('t')) {
            if (_menuList) {
                _menuList.map(menuOperation);
                if(count == 0) {
                    html = '<div class="ui-list-full ui-whitespace"><div class="ui-row-flex"><div class="ui-col ui-col"><div class="ui-txt-info t-a-c">抱歉，您没有访问权限</div></div></div></div>';
                }
            } else {
                html = '<div class="ui-list-full ui-whitespace"><div class="ui-row-flex"><div class="ui-col ui-col"><div class="ui-txt-info t-a-c">抱歉，您没有访问权限</div></div></div></div>';
            }
        } else {
            var list = menuList[type];
            for (var key in list) {
                if(list[key].ysbz) {
                    html += '<li class="ui-col ui-col-33" data-href="javascrpit:void(0);" data-mark="'+ list[key].appmark +'"><div><b><i class="iconfont icon-3x ' +  list[key].class + '"></i></b><span>' +  list[key].name +'</span></div></li>';
                } else {
                    html += '<li class="ui-col ui-col-33 ui-list-disabled" data-href="javascrpit:void(0);" data-mark="'+ list[key].appmark +'"><div><b><i class="iconfont icon-3x ' +  list[key].class + '"></i></b><span>' +  list[key].name +'</span></div></li>';
                }
            }
        }
        return html;
    }

    //clean up sessionStorage
    function cleanSessionStorage() {
        for(var i=sessionStorage.length; i>0 ; i--){
            var key = sessionStorage.key(i-1);
            if(key != 'userName' && key != 'nsrmc' && key != 'menuList' && key != 't') {
                sessionStorage.removeItem(key);
            }
        }
    }



    /**
     * 对日期进行格式化，
     * @param date 要格式化的日期
     * @param format 进行格式化的模式字符串
     *     支持的模式字母有：
     *     y:年,
     *     M:年中的月份(1-12),
     *     d:月份中的天(1-31),
     *     h:小时(0-23),
     *     m:分(0-59),
     *     s:秒(0-59),
     *     S:毫秒(0-999),
     *     q:季度(1-4)
     * @return String
     * @author yanis.wang@gmail.com
     */
    function dateFormat(date, format) {
        //if(format === undefined){
        //    format = date;
        //    date = new Date();
        //}

        var map = {
            "M": date.getMonth() + 1, //月份
            "d": date.getDate(), //日
            "h": date.getHours(), //小时
            "m": date.getMinutes(), //分
            "s": date.getSeconds(), //秒
            "q": Math.floor((date.getMonth() + 3) / 3), //季度
            "S": date.getMilliseconds() //毫秒
        };
        format = format.replace(/([yMdhmsqS])+/g, function(all, t){
            var v = map[t];
            if(v !== undefined){
                if(all.length > 1){
                    v = '0' + v;
                    v = v.substr(v.length-2);
                }
                return v;
            }
            else if(t === 'y'){
                return (date.getFullYear() + '').substr(4 - all.length);
            }
            return all;
        });
        return format;
    }

    /**
     *
     * @param format
     * @returns {String}默认返回yyyy-MM-dd
     */
    function getNowDate(format) {
        var date = new Date();
        if(format) {
            return dateFormat(date, format);
        } else {
            return dateFormat(date, 'yyyy-MM-dd');
        }
    }

    //提示文字
    var pulldownText   =  '下拉可以刷新',
        pullupText =  '上拉加载更多',
        releasedownText  =  '松手可以刷新',
        releaseupText  =  '松手加载更多';



    function close(_$this) {
        hideLoading();
        _$this.prop("disabled", false);
    }

    function open(_$this) {
        showLoading("登录中...");
        _$this.prop("disabled", true);
    }



    $(function() {

        var nsrsbh =  localStorage.getItem('nsrsbh');
        if(nsrsbh) {
            $("#username").val(nsrsbh);
        }
        //select.select("#roleid");

        $('.login-dialog').find('[data-role="button"]').on('tap',function() {
            hideLoginDialog();
        });

        $('#btn-login').on('tap',function(e) {
            var _$this = $(this);
            var pwd = '';
            open(_$this);
            var timestamp =  (new Date()).valueOf();
            if($('#password').val()) {
                pwd = RSAUtils.encryptedString(key, encodeURIComponent(md5(md5($('#password').val()) + timestamp)));
            }
            rest.post({
                url: '/login',
                data : {
                    nsrsbh : $("#username").val(),
                    timestamp :  timestamp,
                    djm : pwd,
                    roleId : $('#roleid option').not(function(){ return !this.selected }).val(),
                    p : md5(Math.floor(Math.random()*6+1).toString())
                },
                isNeedToken : false,
                success: function(result) {
                    close(_$this);
                    if(result.code == '000' && result.token != '') {
                        sessionStorage.setItem('userName', result.userName);
                        sessionStorage.setItem('nsrmc', result.nsrmc);
                        sessionStorage.setItem('menuList', JSON.stringify(result.menuList));
                        sessionStorage.setItem('t', result.token);
                        localStorage.setItem('nsrsbh', $("#username").val());
                        $('.login-dialog').removeClass('show');
                        alert('success', '登录成功');
                    } else {
                        alert('warn', result.msg);
                    }
                },
                error: function() {
                    close(_$this);
                    return false;
                }
            });
            e.preventDefault();
        });

    });


    function showLoginDialog() {
        $('.login-dialog').addClass('show');
    }
    function hideLoginDialog() {
        $('.login-dialog').removeClass('show');
    }

    /**
     * 显示中间提示
     * @param text
     */
    function showLoading(text) {
        if(text) {
            $('#loading-text').html(text);
        } else {
            $('#loading-text').html('正在加载中...');
        }
        if(!$('.ui-loading-block').hasClass('show')) {
            $('.ui-loading-block').addClass('show');
            //$("body").css("overflow","hidden");
        }
    }

    /**
     * 关闭中间提示
     * @param text
     */
    function hideLoading() {
        if($('.ui-loading-block').hasClass('show')) {
            $('.ui-loading-block').removeClass('show');
            //$("body").css("overflow","visible");
        }
    }

    function showErrorTip(content){
        $.tips({
            content: content,
            stayTime:2000,
            type:"warn"
        });
    }

    /**
     *  顶部提示
     * @param type["success", "warn", "info"(default)]
     * @param msg
     */
    function alert(type, msg) {
        if(arguments.length === 1) {
            msg = arguments[0];
            type = 'info';
        }
        $.tips({
            content:msg,
            stayTime:2000,
            type:type
        });
    }

    var Scroll = function (container, option) {
        this.scroll = {};
        this.container = container;
        this.content = $(container+'>:first-child');
        this.defaults = {
            url:null,
            scrollOption :{
                mouseWheel:true,
                scrollbars:true,
                bounceLock:false,
                fadeScrollbars:true,
                momentum:false
            }
        };
        this.options = $.extend({}, this.defaults, option);
    };

    Scroll.prototype.init = function() {
        this._init();
        this._bind();
    };

    Scroll.prototype._init = function() {

        this.content.prepend('<div class="scroll_pulldown_icon"></div><div class="scroll_pulldown">'+pulldownText+'</div>');
        this.content.prepend('<div class="scroll_pullup_icon"></div><div class="scroll_pullup">'+pullupText+'</div>');
        this.fristLoad();
    };

    Scroll.prototype._bind = function() {
        var that = this;
        that.scroll = new IScroll(that.container, that.options.scrollOption);
        that.scroll.on('scrollMove',function(){
            if(this.y>50){
                $('.scroll_pulldown_icon').addClass('scroll_pulldown_flip');
                $('.scroll_pulldown').text(releasedownText);
            }
            else{
                $('.scroll_pulldown_icon').removeClass('scroll_pulldown_flip');
                $('.scroll_pulldown').text(pulldownText);
            }
            if(this.y<-that.content.height()+$(that.container).height()-50){
                $('.scroll_pullup_icon').addClass('scroll_pullup_flip');
                $('.scroll_pullup').text(releaseupText);
            } else{
                $('.scroll_pullup_icon').removeClass('scroll_pullup_flip');
                $('.scroll_pullup').text(pullupText);
            }
        });
        that.scroll.on('scrollEnd',function(){
            if($('.scroll_pulldown_icon').hasClass('scroll_pulldown_flip')){
                $('.scroll_pulldown_icon').removeClass('scroll_pulldown_flip');
                that.refresh();
            }
            if($('.scroll_pullup_icon').hasClass('scroll_pullup_flip')){
                $('.scroll_pullup_icon').removeClass('scroll_pullup_flip');
                that.more();
            }
        });
    };
    Scroll.prototype.more = function(){
        var that = this;
        showLoading();

        var countForEachPage = 10;
        var condition = JSON.parse(sessionStorage.getItem("condition"));

        try{
            var count = parseInt(sessionStorage.getItem("count"),0);
            if(isNaN(count)){
                hideLoading();
                return;
            }
            if(!condition.minNum){
                hideLoading();
                return;
            }
            if(condition.minNum+countForEachPage>count){
                hideLoading();
                return;
            }
        }catch(e){
            hideLoading();
            return;
        }
        condition.minNum = condition.minNum + countForEachPage;
        condition.maxNum = condition.maxNum + countForEachPage;
        sessionStorage.setItem("condition",JSON.stringify(condition));

        rest.get({
            url: sessionStorage.getItem("url"),
            urlParams: JSON.parse(sessionStorage.getItem("condition")),
            success: function(result) {
                hideLoading();
                if(result.code!="000"){
                    showErrorTip(result.msg);
                    return;
                }
                if(result.count==0){
                    alert("没有查询到更多数据");
                    return;
                }
                var html = template('test', result);
                sessionStorage.setItem("count",result.count);
                var pageData = JSON.parse(sessionStorage.getItem("data"));
                pageData.count = result.count;
                for(var p in pageData){
                    if(pageData[p] instanceof Array){
                        for(var sp in result){
                            if(result[sp] instanceof Array){
                                pageData[p] = pageData[p].concat(result[sp]);                            }
                            sessionStorage.setItem("data",JSON.stringify(pageData));
                        }
                    }
                }
                $("#content").append(html);
                that.scroll.refresh();
                $(that.options.itemBlock).on('tap',that.options.showDetails);
            },
            error: function() {
            }
        });
    };
    Scroll.prototype.refresh = function(){
        sessionStorage.removeItem("count");
        sessionStorage.removeItem("data");
        var condition = JSON.parse(sessionStorage.getItem("condition"));
        condition.minNum = 1;
        condition.maxNum = 10;
        sessionStorage.setItem("condition",JSON.stringify(condition));
        this.fristLoad();
    };

    Scroll.prototype.fristLoad = function() {
        var that = this;
        if(sessionStorage.getItem("data")){
            var data = JSON.parse(sessionStorage.getItem("data"));
            if(data.count==0){
                alert("没有查询到数据");
                return;
            }
            var html = template('test', data);
            $("#content").html(html);
            $(that.options.itemBlock).on('tap',that.options.showDetails);
        }else{
            showLoading();

            rest.get({
                url: sessionStorage.getItem("url")||that.options.url,
                urlParams: sessionStorage.getItem("condition")?JSON.parse(sessionStorage.getItem("condition")):that.options.urlParams,
                isNeedToken: this.options.isNeedToken,
                success: function(result) {
                    hideLoading();
                    if(result.code!="000"){
                        showErrorTip(result.msg);
                        return;
                    }
                    if(result.count==0){
                        alert("没有查询到数据");
                        return;
                    }
                    sessionStorage.setItem("count",result.count);
                    sessionStorage.setItem("data" , JSON.stringify(result));
                    var html = template('test', result);
                    $("#content").html(html);
                    that.scroll.refresh();
                    $(that.options.itemBlock).on('tap',that.options.showDetails);
                },
                error: that.options.error
            });
        }
    };
});