/**
 * Created by Li Hongwei on 2016/1/19.
 */
define(function(require, exports, module) {
    var Zepto = require("zepto");
    var jQuery = require('jquery');
    var A = require('agile');
    var rest = require('rest');
    var RSAUtils = require('rsa');
    var md5 = require('md5');
    //require('validator');


    var $login_section = Zepto('#login_section');
    var key;

    var $login_form_valid; //校验obj

    /**
     * 初始化表单校验
     */
    function initFormValid() {
        if (!$login_form_valid) {
            $login_form_valid = jQuery('#login_form').validator({
                stopOnError: true,
                fields: {
                    "username": {
                        rule: 'required;nsrsbh;',
                        msg: { required: "纳税人识别号不能为空" }
                    },
                    "password": {
                        rule: "required;password;",
                        msg: { required: "密码不能为空" }
                    }
                }
            });
        }
    }

    function getPK() {
        A.showMask();

        $("#btn_login").prop("disabled",true);
        $("#btn_login").text("请稍后");
        rest.get({
            url: '/pkparam',
            isNeedToken: false,
            success: function(result) {
                if (result.code == '000') {
                    key = RSAUtils.getKeyPair(result.exponent, '', result.modulus);
                    localStorage.setItem('e', result.exponent);
                    localStorage.setItem('m', result.modulus);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('网络连接失败');
                A.hideMask();
            },
            complete: function(){
                $("#btn_login").prop("disabled",false);
                $("#btn_login").text("登录");
            }
        });
    }

    /**
     * 初始化登录表单
     */
    function initForm() {
        $login_section.find('#password').attr('type', 'password').val('');
        var nsrsbh = localStorage.getItem('nsrsbh');
        if (nsrsbh) {
            $login_section.find("#username").val(nsrsbh);
        }
    }

    /**
     * 检查版本更新
     */
    function checkVers() {
        $login_section.find('.version').html(seajs.data.vars.version);
        if (seajs.data.vars.platform == "ANDROID") {
            $login_section.find('.btn-checkupdate').css('display', 'block');
            $login_section.find('.btn-checkupdate').show().off();
            $login_section.find('.btn-checkupdate').show().on(A.options.clickEvent, function() {
                A.showMask('检测中...');
                ABC.updateApp(function(success_result) {
                    A.hideMask();
                    if (success_result.update == 0)
                        A.showToast('当前版本已经是最新版本');
                }, function(fail_result) {
                    A.hideMask();
                    A.showToast(fail_result);
                });
                return false;
            });
        }
    }



    $login_section.on('sectionload', function() {
        //initFormValid();
        //checkVers();
    });

    $login_section.on('sectionshow', function() {

        $("#login_section").css("height", $("#login_section").get(0).scrollHeight + "px");

        getPK();
        checkVers();
        initFormValid();
        initForm();
    });

    //getPK();
    //checkVers();
    //initFormValid();
    //initForm();

    $login_section.on('sectionhide', function() {
        jQuery('#login_form').validator("cleanUp");
        $login_form_valid = null;
        key = null;
    });

    /**
     * 密码显示隐藏
     */
    $login_section.find('.pwdview').on(A.options.clickEvent, function() {
        var $password = $login_section.find('#password');
        if ($password.attr('type') == 'text') {
            $password.attr('type', 'password');
        } else {
            $password.attr('type', 'text');
        }
        return false;
    });

    /**
     * 缓存登录信息
     * @param _result
     */
    function cacheUserInfo(_result) {
        sessionStorage.setItem('userName', _result.userName);
        sessionStorage.setItem('nsrmc', _result.nsrmc);
        sessionStorage.setItem('menuList', JSON.stringify(_result.menuList));
        sessionStorage.setItem('t', _result.userToken);
        sessionStorage.setItem('djxh', _result.djxh);
        sessionStorage.setItem('roleId', _result.roleId);
        // 当前登录用户关联的实名认证用户，gxruuid不为空则已关联实名认证用户，实名认证用户的主键为gxruuid。
        sessionStorage.setItem('gxruuid', _result.gxruuid ? _result.gxruuid : '');
        // 主管税务机关
        sessionStorage.setItem('zgswjgDm', _result.zgswjDm ? _result.zgswjDm : '');
        sessionStorage.setItem("zgswskfjDm",_result.zgswskfjDm);
        localStorage.setItem('nsrsbh', _result.nsrsbh);
    }

    $login_section.find('#btn_login').on(A.options.clickEvent, function() {
        if ($login_form_valid.isValid()) {

            if (key == undefined) {
                getPK();
                return;
            }
            A.showMask('登录中');
            var timestamp = (new Date()).valueOf();
            var data = {
                // nsrsbh: $login_section.find("#username").val(),
                timestamp: timestamp,
                nsrsbh: RSAUtils.encryptedString(key, timestamp + encodeURIComponent($login_section.find("#username").val())),
                djm: RSAUtils.encryptedString(key, encodeURIComponent(md5(md5($login_section.find('#password').val()) + timestamp))),
                roleId: $login_section.find('#roleid option').not(function() { return !this.selected }).val(),
                p: md5(Math.floor(Math.random() * 6 + 1).toString())
            };
            rest.post({
                url: '/login',
                data: data,
                isNeedToken: false,
                success: function(result) {
                    if (result.code == '000' && result.token != '') {
                        cacheUserInfo(result);
                        A.hideMask();
                        A.showToast('登录成功');
                        A.Controller.back();
                    } else {
                        A.hideMask();
                        A.showToast(result.msg);
                    }
                },
                error: function() {
                    A.hideMask();
                    A.showToast('网络连接失败');
                    return false;
                }
            });
        }
        return false;
    });

});
