define(function(require,exports,module){
    var $ = require("zepto");
    var rest = require("rest");
    var A = require('agile');

    var initBtnEvent = function(){
        $(".addr-block button[name='del_btn']").on(A.options.clickEvent,function(e){
            var $node = $(this);
            A.confirm("提示","是否删除该地址",function(){
                var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
                rest.del({
                    url : "/fp/express/delete/{uuid}",
                    urlParams : {
                        uuid : uuid
                    },
                    success : function(data){
                        if(!data || $.isEmptyObject(data)){
                            A.showToast("删除收货地址失败");
                        }else if(data.code!="000"){
                            A.showToast(data.msg);
                        }else if(data.code=="000"){
                            A.showToast("删除收货地址成功");
                            queryAddr();
                        }else{
                            A.showToast("删除收货地址失败");
                        }
                    },
                    error : function(){
                        A.showToast("删除收货地址失败");
                    }
                });
            });
        });

        $(".addr-block button[name='update_btn']").on(A.options.clickEvent,function(e){
            var $node = $(this);
            var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            A.Controller.section("mine/addr/addr_add_section.html?uuid="+uuid);
        });

        $(".addr-block button[name='set_default_btn']").on(A.options.clickEvent,function(e){
            var $node = $(this);
            A.confirm("提示","是否设置该地址为默认地址",function(){
                var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
                var url = "/fp/express/updateMr/" + uuid;
                rest.post({
                    url : url,
                    success : function(data){
                        if(!data || $.isEmptyObject(data)){
                            A.showToast("设置默认收货地址失败");
                        }else if(data.code!="000"){
                            A.showToast(data.msg);
                        }else if(data.code=="000"){
                            queryAddr();
                        }else{
                            A.showToast("设置默认收货地址失败");
                        }
                    },
                    error : function(){
                        A.showToast("设置默认收货地址失败");
                    }
                });
            });
        });
    }

    var queryAddr = function(){
        A.showMask();
        rest.get({
            url : "/fp/express/select",
            success : function(data){
                A.hideMask();
                A.template("#tmpl_addr_list").renderReplace(data,function(){
                    initBtnEvent();
                });
            },
            error : function(){
                A.hideMask();
                A.showToast("查询收货地址失败");
            }
        });
    }

    $('#addr_article').on('articleshow', function () {
        queryAddr();
    });

});