/**
 * Created by Li Hongwei on 2016/1/19.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    $('#list_section').on('sectionshow',function(){
        $('#detail_modal_edit').text('编辑');

        $('#edit_footer').css('bottom','-56px');

        var nowrapLiController = A.ExList.liController('.nowrap_li',{
            swipeOptionOnTap : function(liElement,targetElement){
                if(targetElement.hasClass('detail_mark_div')){
                    A.alert('提示',liElement.find('small').html());
                    return false;
                }else if(targetElement.hasClass('delete_mark_div')){
                    A.confirm('提示','确定移除该活动吗？', function(){
                        var _$this = $(liElement);
                        _$this.remove();
                    });
                }

            },
            rightContent:'<div class="detail_mark_div">详情</div><div class="delete_mark_div">删除</div>'
        });

        var wrapLiController = A.ExList.liController('.wrap_li',{
            swipeOptionOnTap : function(liElement,targetElement){
                A.confirm('提示','确定移除该活动吗？', function(){
                    var _$this = $(liElement);
                    _$this.remove();
                });
            }
        });

        function showEditMenu(){
            $('#edit_footer').animate({
                bottom:'0px'
            },100);

            $('#list_article').css('bottom','56px');

            A.Scroll('#list_article').refresh();
        }

        function hideEditMenu(){
            $('#edit_footer').animate({
                bottom:'-56px'
            },100);

            $('#list_article').css('bottom','0px');

            A.Scroll('#list_article').refresh();
        }

        function edit(){
            nowrapLiController.showLeft();
            wrapLiController.showLeft();
            $('#detail_modal_edit').text('取消');
            showEditMenu();
            $('#detail_modal_edit').off(A.options.clickEvent).on(A.options.clickEvent,function(){
                nowrapLiController.hideLeft();
                wrapLiController.hideLeft();
                $('#detail_modal_edit').text('编辑');
                $('#detail_modal_edit').off(A.options.clickEvent).on(A.options.clickEvent,edit);
                hideEditMenu();
            });
        }

        $('#detail_modal_edit').off(A.options.clickEvent).on(A.options.clickEvent,edit);

        $('#delete_mark').off(A.options.clickEvent).on(A.options.clickEvent,function(){
            var number = 0;
            $('.exlist_checkbox').each(function(){
                var $li = $(this).parents('li');
                if($(this)[0].checked){
                    number++;
                }
            });

            if(number==0){
                A.alert("请选择待删除的活动");
                return;
            }

            A.confirm('提示','确定移除这'+number+'项活动吗？', function(){
                $('.exlist_checkbox').each(function(){
                    var _data_key , _date_string;
                    var $li = $(this).parents('li');
                    if($(this)[0].checked){
                        $li.remove();
                    }
                });
            });
        });

        $('#add_mark').off(A.options.clickEvent).on(A.options.clickEvent,function(){
            var $popup = A.popup({
                html: $('#add_template').html(),
                css : {width:'auto'},
                pos : 'center'
            });
            $popup.popup.find('button').on(A.options.clickEvent, function(){
                var name = $popup.popup.find('[name="name"]').val();
                var description = $popup.popup.find('[name="description"]').val();

                if (name == '') {
                    A.alert("请输入条目名称");
                    return false;
                }

                if (description == '') {
                    A.alert("请输入条目描述");
                    return false;
                }
                /*
                 A.confirm('提示', '确定添加吗？', function() {
                 });
                 */
                var html = '';

                html += '<li class="nowrap_li"><div class="text">';

                html += name;

                html += '<small class="nowrap" style="display:none;">' + description + '</small>';

                html += '</div></li>';

                $('#swipe_test').append(html);

                nowrapLiController.refresh();
                wrapLiController.refresh();

                nowrapLiController.showLeft();
                wrapLiController.showLeft();

                A.Scroll('#list_article').refresh();

                $popup.close();

            });
            return false;
        });
    });
});

