/**
 * Created by Li Hongwei on 2016/1/19.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var condition = {
        msgType : '',
        ydbz : "",
        minNum :'',
        maxNun : ''
    };

    /**
     * 根据cruPage获取templ显示名称
     * @param cruPage
     * @returns {*}
     */
    var getMsgTemplName= function(cruPage) {
        var _type;
        switch(cruPage) {
            case 0 : _type = "msg_qb"; break;
            case 1 : _type = "msg_yw"; break;
            case 2 : _type = "msg_fw"; break;
            case 3 : _type = "msg_xt"; break;
            default : break;
        }
        return _type;
    };

    /**
     * 获取消息列表
     * @param cruPage
     */
    var getMsg =function(cruPage) {
        A.showMask();

        if(cruPage==0) {//为全部
            condition.msgType = '';
        }else {
            condition.msgType =  cruPage;
        }

        rest.get({
            url: '/ggfw/msg/list?msgType={msgType}&ydbz={ydbz}&minNum={minNum}&maxNun={maxNun}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(result.msgList && result.msgList.length != 0) {
                        A.template('#' +getMsgTemplName(cruPage) + '_tmpl').renderReplace(result,function() {
                            setTimeout(function() {
                                A.Scroll('#msg_article').refresh();
                            },1);
                        });
                    } else {
                        A.showToast('未查询到相关记录');
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.hideMask();
                A.showToast('更新办税厅数据失败');
            }
        });
    };

    $('#msg_section').on('sectionload', function(){
        A.Slider('#msg_slider', {
            dots : 'hide',
            change:function(cruPage){
                getMsg(cruPage);
            }
        });
    });

    $('#msg_section').on('sectionshow', function() {
        getMsg(0);
    });
});

