define(function(require, exports, module) {
    var $ = require("zepto");
    var rest = require("rest");
    var A = require('agile');
    var utils = require('utils');

    var initBtnEvent = function() {
        // 删除按钮
        $(".addr-block button[name='del-btn']").on(A.options.clickEvent, function(e) {
            var $node = $(this);
            A.confirm("提示", "您确定要删除本条实名办税信息？", function() {
                var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
                A.showMask();
                rest.del({
                    url: "/smrz/deletegxr/{uuid}",
                    urlParams: {
                        uuid: uuid
                    },
                    success: function(json) {
                        if (json.code && json.code === "000") {
                            A.showToast("删除成功");
                            querySmrz();
                            // 删除附件资料
                            rest.del({
                                url: "/smrz/fjzl/deleteallfj/{uuid}",
                                urlParams: {
                                    uuid: uuid
                                },
                                success: function(json) {
                                    A.hideMask();
                                    if (json.code && json.code === "000") {
                                        A.showToast("删除附件成功");
                                    }
                                },
                                error: function() {
                                    A.hideMask();
                                    A.showToast("删除附件失败，请稍后重试！");
                                }
                            });
                        } else {
                            A.hideMask();
                            A.showToast("删除失败");
                        }
                    },
                    error: function() {
                        A.hideMask();
                        A.showToast("删除失败，请稍后重试！");
                    }
                });
            });
        });

        //// 不能删除提示
        //$(".addr-block button[name='undel-btn']").on(A.options.clickEvent, function(e) {
        //    A.alert("提示", "该办税人员已在税务征管系统中登记，请到主管税务机关办税服务厅申请变更？");
        //    return false;
        //});

        // 更新按钮
        $(".addr-block button[name='update-btn']").on(A.options.clickEvent, function() {

            if(!sessionStorage.getItem("zgswskfjDm")){
                A.showToast("请先到办税大厅办理管户分配，才能进行在线实名认证！");
                return;
            }

            var $node = $(this);
            var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            A.Controller.section("mine/realname/realname_edit_section.html?uuid=" + uuid);
        });

        // 有限更新按钮
        $(".addr-block button[name='limit-update-btn']").on(A.options.clickEvent, function() {

            if(!sessionStorage.getItem("zgswskfjDm")){
                A.showToast("请先到办税大厅办理管户分配，才能进行在线实名认证！");
                return;
            }

            var $node = $(this);
            var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            A.Controller.section("mine/realname/realname_edit_section.html?uuid=" + uuid);
        });

        // 认证按钮
        $(".addr-block button[name='check-btn']").on(A.options.clickEvent, function() {

            if(!sessionStorage.getItem("zgswskfjDm")){
                A.showToast("请先到办税大厅办理管户分配，才能进行在线实名认证！");
                return;
            }

            var $node = $(this);
            var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            var xm = $node.parents(".realname-opt").siblings(".addr-title").find("span[name='xm']").html();
            var gxrlxmc = $node.parents(".realname-opt").siblings(".addr-title").find("span[name='gxrlxmc']").html();
            var gxrlxDm = $node.data("gxrlxdm");
            var sfzjlxdm = $node.data("sfzjlxdm");
            var sfzjhm = $node.data("sfzjhm");
            A.Controller.section("mine/realname/realname_check_section.html?gxruuid=" + uuid + "&xm=" + xm + "&gxrlxmc=" + gxrlxmc + "&gxrlxDm=" + gxrlxDm + "&sfzjlxDm="+ sfzjlxdm + "&sfzjhm=" + sfzjhm);
        });

        // 绑定按钮
        $(".addr-block button[name='bind-btn']").on(A.options.clickEvent, function() {

            if(!sessionStorage.getItem("zgswskfjDm")){
                A.showToast("请先到办税大厅办理管户分配，才能进行在线实名认证！");
                return;
            }

            var $node = $(this);
            var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            var xm = $node.data("xm");
            var sfzjlxDm = $node.data("sfzjlxdm");
            var sfzjhm = $node.data("sfzjhm");
            var yddh = $node.data("yddh");
            var gddh = $node.data("gddh");

            A.confirm("提示", "您确定要绑定本办税员为当前用户的办税员？", function() {
                var uuid = $node.parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
                rest.post({
                    url: "/user/bind/smrz",
                    data: {
                        gxruuid: uuid,
                        xm: xm,
                        sfzjlxDm: sfzjlxDm,
                        sfzjhm: sfzjhm,
                        yddh: yddh,
                        gddh: gddh
                    },
                    success: function(json) {
                        if (json.code && json.code === "000") {
                            A.showToast("绑定成功");
                            sessionStorage.setItem("gxruuid",uuid);
                            sessionStorage.setItem("userName",xm);
                            querySmrz();
                        } else {
                            A.showToast("绑定失败");
                        }
                    },
                    error: function() {
                        A.showToast("绑定失败，请稍后重试！");
                    }
                });
            });
        });
    }

    var querySmrz = function() {
        A.showMask();
        rest.get({
            url: "/smrz/getgxrlist?nsrsbh=" + localStorage.getItem('nsrsbh'),
            success: function(json) {
                A.hideMask();
                if (json.code && json.code === '000') {
                    json.gxruuid = sessionStorage.getItem('gxruuid');
                    if (json.dataList && json.dataList.length > 0) {
                        //var fddbr_rzztbz = false; // 法定代表人默认认定状态标志
                        for (var i = 0, dataList = json.dataList; i < dataList.length; i++) {

                            if (dataList[i].rzztDm === '01') {
                                // 高亮显示未认证文本
                                json.dataList[i].rzztmc = '<span class="ui-txt-highlight">' + dataList[i].rzztmc + '</span>';
                            } else if (dataList[i].rzztDm === '02' || dataList[i].rzztDm === '03' || dataList[i].rzztDm === '04') {
                                // 绿色显示已认证文本
                                json.dataList[i].rzztmc = '<span style="color: green">' + dataList[i].rzztmc + '</span>';
                            } else {
                                // 警告显示认证失败文本
                                json.dataList[i].rzztmc = '<span class="ui-txt-warning">' + dataList[i].rzztmc + '</span>';
                            }
                        }
                    }

                    A.template("#tmpl_realname_list").renderReplace(json, function() {
                        initBtnEvent();
                    });
                } else {
                    A.showToast(json.msg);
                    A.Controller.back();
                }
            },
            error: function() {
                A.hideMask();
                A.showToast("获取实名认证信息失败，请稍后重试！");
                A.Controller.back();
            }
        });
    }

    $('#realname_section').on('sectionshow', function() {
        querySmrz();
    });

});