define(function(require, exports, module) {

    var $ = require("zepto");
    var rest = require("rest");
    var A = require('agile');

    var Valid_Suffix_Forms = [".jpg"];
    var Valid_Files_Size = 4 * 1024 * 1024;

    var $realname_check_article = $('#realname_check_article');

    var fbzl;

    var checkFile = function(file) {

        if (typeof file != "object") {
            return "请选择需要上传的文件";
        }

        var pos = file.name.lastIndexOf("\\");
        var fileSuffix = file.name.substring(pos + 1);
        var suffix = '';
        if (fileSuffix && fileSuffix.lastIndexOf('.') > -1) {   
            suffix = fileSuffix.substring(fileSuffix.lastIndexOf('.'));
        }
        var is_match = false; // 是否匹配成功，默认为false
        for (var i in Valid_Suffix_Forms) {
            // 匹配成功一次之后，不再匹配其他项
            if (is_match || Valid_Suffix_Forms[i] == suffix.toLowerCase()) {
                is_match = true;
                break;
            }
        }
        if (!is_match) {
            return "文件格式只能为.jpg格式";
        }

        if (Valid_Suffix_Forms.length == 0) {
            return "文件格式只能为.jpg格式";
        }

        var size = file.size;
        if (Valid_Files_Size < size) {
            return "文件大小不能超过4M";
        }

        return "success";
    }

    // 认证按钮事件
    $realname_check_article.find('#submit_btn').on(A.options.clickEvent, function(e) {

        var gxruuid = $("#gxruuid").val();
        $realname_check_article.find('.wrong').remove();
        $realname_check_article.find('.check').remove();

        A.showMask();
        rest.get({
            url: "/smrz/fjzl/selectfjzl/{gxruuid}",
            urlParams: {
                gxruuid: gxruuid
            },
            success: function(data) {
                A.hideMask();
                var count = 0;
                if (!$.isEmptyObject(data) && data.code == "000") {
                    for (var i in data.dataList) {
                        if (data.dataList[i].gxrfjzluuid && data.dataList[i].fjzllxDm) {
                            if($("#file" + data.dataList[i].fjzllxDm).siblings(".check").size()<=0){
                                $("#file" + data.dataList[i].fjzllxDm).after('<span class="check"></span>');
                                count++;
                            }
                        } else {
                            if($("#file" + data.dataList[i].fjzllxDm).siblings(".wrong").size()<=0)
                                $("#file" + data.dataList[i].fjzllxDm).after('<span class="wrong"></span>');
                        }
                    }
                    var card = $realname_check_article.find('.card').size();

                    if (count >= card) {
                        A.Controller.section('mine/realname/realname_complete_section.html');
                    } else {
                        A.showToast('请选择未上传的文件！');
                    }
                } else {
                    A.hideMask();
                    A.showToast(data.msg);
                }
            },
            error: function(err) {
                A.hideMask();
                A.showToast("查询失败，请重试！");
            }
        });
    });

    var getBase64Data = function(file, callback) {

        var reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = callback;
    }

    var compressImg = function(code,callback,type){

        var fileType = {
            width:770,
            height:1030,
            hwRatio:770/1030
        };
        var photoType = {
            width:770,
            height:1030,
            hwRatio:770/1030
        };
        var idCardType = {
            width:770,
            height:1030,
            hwRatio:770/1030
        };

        var canvas = document.createElement("canvas");
        var ctx = canvas.getContext("2d");

        var img = $("<img>");
        img.prop("src",code);
        img.get(0).onload = function(){
            //console.log("img size=="+img.get(0).src.length);
            var quality = 0.95;
            var scale;
            var hwRatio = img.prop("height")/img.prop("width");

            //图片压缩比例算法
            // if(type=="file"){
            //     if(hwRatio>fileType.hwRatio){//高度压缩
            //         if(img.prop("height")>fileType.height){
            //             scale = fileType.height / img.prop("height");
            //         }else{
            //             scale = 1;
            //         }
            //     } else {//宽度压缩
            //         if(img.prop("width")>fileType.width){
            //             scale = fileType.width / img.prop("width");
            //         }else{
            //             scale = 1;
            //         }
            //     }
            // }else if(type=="photo"){
            //     if(hwRatio>photoType.hwRatio){//高度压缩
            //         if(img.prop("height")>photoType.height){
            //             scale = photoType.height / img.prop("height");
            //         }else{
            //             scale = 1;
            //         }
            //     } else {//宽度压缩
            //         if(img.prop("width")>photoType.width){
            //             scale = photoType.width / img.prop("width");
            //         }else{
            //             scale = 1;
            //         }
            //     }
            // }else if(type=="idCard"){
            //     if(hwRatio>idCardType.hwRatio){//高度压缩
            //         if(img.prop("height")>idCardType.height){
            //             scale = idCardType.height / img.prop("height");
            //         }else{
            //             scale = 1;
            //         }
            //     } else {//宽度压缩
            //         if(img.prop("width")>idCardType.width){
            //             scale = idCardType.width / img.prop("width");
            //         }else{
            //             scale = 1;
            //         }
            //     }
            // }else{
            //     return;
            // }

            scale = 1;
            if(img.prop("height")>1030){
                A.showToast("附件高度不能超过1030像素");
                return;
            }
            if(img.prop("width")>770){
                A.showToast("附件宽度不能超过770像素");
                return;
            }

            canvas.width = img.prop("width")*scale;
            canvas.height = img.prop("height")*scale;
            ctx.scale(scale,scale);
            ctx.drawImage(img.get(0), 0, 0, img.prop("width"), img.prop("height"));

            var data = canvas.toDataURL("image/jpg",quality);
            if(data.length>Valid_Files_Size){
                A.showToast("文件大小压缩后超过4M，请选择其他图片");
                return;
            }

            callback(data);
            // if(scale<1) {
            //     A.confirm("注意", "当前附件已经压缩至" + (scale * 100).toFixed(0) + "%,是否提交?",function(){
            //         callback(data);
            //     },function(){
            //         return;
            //     })
            // }else {
            //     callback(data);
            // }
        }
    }

    var initBtnEvent = function() {
        $("#check_realname_form button[name='upload-btn']").on(A.options.clickEvent, function() {
            var fileFieldName = $(this).data("filename");
            var fileInput = $("#check_realname_form input[name='" + fileFieldName + "']");
            var validResult = checkFile(fileInput.get(0).files[0]);
            if (validResult == "success") {
                getBase64Data(fileInput.get(0).files[0], function() {
                    compressImg(this.result,function(data){

                        var vo = {
                            gxruuid: $("#gxruuid").val(),
                            fjzllxDm: fileInput.data("fjzllxdm"),
                            gxrfjzluuid: fileInput.data("gxrfjzluuid"),
                            gxrfjzl: data.replace(/^data:.*;base64,/, '')
                        }

                        A.showMask('正在上传');
                        rest.post({
                            url: "/smrz/fjzl/edit",
                            data: vo,
                            success: function(json) {
                                A.hideMask();
                                fileInput.next(".check").remove();
                                fileInput.next(".wrong").remove();
                                if (!$.isEmptyObject(json) && json.code == "000") {
                                    A.showToast('上传成功');
                                    fileInput.after('<span class="check"></span>');
                                } else {
                                    A.showToast(json.msg);
                                    fileInput.after('<span class="wrong"></span>');
                                }
                            },
                            error: function() {
                                A.hideMask();
                                A.showToast("上传失败,请稍后重试!");
                                fileInput.next(".check").remove();
                                fileInput.next(".wrong").remove();
                                fileInput.after('<span class="wrong"></span>');
                            }
                        });
                    },fileInput.attr("check-type"));
                });
            } else {
                fileInput.next(".check").remove();
                fileInput.next(".wrong").remove();
                fileInput.after('<span class="wrong"></span>');
                A.showToast(validResult);
            }
        });
    }

    $('#realname_check_section').on('sectionshow', function() {
        var params = A.Component.params(this);
        if (!$.isEmptyObject(params) && typeof params === 'object') {
            if (!params.gxruuid) {
                A.showToast("请选择认证办税员");
                A.Controller.back();
            }

            $("#gxruuid").val(params.gxruuid);
            setObject(params);
        } else {
            A.Controller.back();
        }
    });

    var setObject = function(params) {
        A.showMask();
        rest.get({
            url: "/smrz/fjzl/selectfjzl/{gxruuid}",
            urlParams: {
                gxruuid: params.gxruuid
            },
            success: function(data) {
                A.hideMask();
                if (!$.isEmptyObject(data) && data.code == "000") {
                    fbzl = data.dataList;
                    var tmplVal = {
                        xm: params.xm,
                        gxrlxmc: params.gxrlxmc,
                        wtsqs: {
                            gxrfjzluuid: "",
                            gxrfjzl: "",
                            fjzllxDm: "06"
                        },
                        sfzzm: {
                            gxrfjzluuid: "",
                            gxrfjzl: "",
                            fjzllxDm: "01"
                        },
                        sfzfm: {
                            gxrfjzluuid: "",
                            gxrfjzl: "",
                            fjzllxDm: "02"
                        },
                        bsy: {
                            gxrfjzluuid: "",
                            gxrfjzl: "",
                            fjzllxDm: "05"
                        }
                    }

                    for (var i in fbzl) {
                        if (fbzl[i].gxrfjzluuid) {
                            switch (fbzl[i].fjzllxDm) {
                                case "01":
                                    tmplVal.sfzzm.gxrfjzluuid = fbzl[i].gxrfjzluuid;
                                    tmplVal.sfzzm.gxrfjzl = fbzl[i].gxrfjzl;
                                    break;
                                case "02":
                                    tmplVal.sfzfm.gxrfjzluuid = fbzl[i].gxrfjzluuid;
                                    tmplVal.sfzfm.gxrfjzl = fbzl[i].gxrfjzl;
                                    break;
                                case "05":
                                    tmplVal.bsy.gxrfjzluuid = fbzl[i].gxrfjzluuid;
                                    tmplVal.bsy.gxrfjzl = fbzl[i].gxrfjzl;
                                    break;
                                case "06":
                                    tmplVal.wtsqs.gxrfjzluuid = fbzl[i].gxrfjzluuid;
                                    tmplVal.wtsqs.gxrfjzl = fbzl[i].gxrfjzl;
                                    break;
                            }
                        }
                    }
                    //法人代表不需要显示授权委托书
                    if(params.gxrlxDm && params.gxrlxDm=="01"){
                        delete tmplVal.wtsqs;
                        A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                            initBtnEvent();
                        });
                        $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');

                    }else{

                        rest.get({
                            url: "/smrz/getgxrlist?nsrsbh=" + localStorage.getItem('nsrsbh'),
                            success: function (gxrResult) {
                                if (gxrResult.code && gxrResult.code === '000') {
                                    if (gxrResult.dataList && gxrResult.dataList.length > 0) {
                                        var gxrList = gxrResult.dataList
                                        for (var i = 0; i < gxrList.length; i++) {
                                            if (gxrList[i].gxrlxDm == "01") {//找到法人
                                                if(gxrList[i].xm == params.xm && gxrList[i].sfzjlxDm==params.sfzjlxDm && gxrList[i].sfzjhm==params.sfzjhm){//判断操作的干系人是否是法人
                                                    delete tmplVal.wtsqs;
                                                    A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                                                        initBtnEvent();
                                                    });
                                                    $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');
                                                }else{
                                                    A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                                                        initBtnEvent();
                                                    });
                                                    $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');
                                                }
                                            }
                                            if(i==gxrList.length-1){//没有找到法人
                                                A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                                                    initBtnEvent();
                                                });
                                                $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');
                                            }
                                        }
                                    }else{
                                        A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                                            initBtnEvent();
                                        });
                                        $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');
                                    }
                                }else{
                                    A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                                        initBtnEvent();
                                    });
                                    $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');
                                }
                            },
                            error : function(){
                                A.template("#real_check_tmpl").renderReplace(tmplVal, function() {
                                    initBtnEvent();
                                });
                                $realname_check_article.find('#wts').attr('href', seajs.data.vars.baseurl + '/ggfw/download/fj/432');
                            }
                        });
                    }
                } else {
                    A.showToast(data.msg);
                    A.Controller.back();
                }
            },
            error: function(err) {
                A.hideMask();
                A.showToast("查询失败,请重试");
                A.Controller.back();
            }
        });
    }

});
