/**
 * Created by Li Hongwei on 2016/1/19.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var $userinfo_section = $('#userinfo_section');

    var clearSession = function() {
        //sessionStorage.removeItem('t');
        //sessionStorage.removeItem('nsrmc');
        //sessionStorage.removeItem('userName');
        sessionStorage.clear();
    };

    /**
     * 显示消息未读标记
     */
    function markMsg() {
        var data = {
            msgType : '',
            ydbz : "N",
            minNum :"",
            maxNun : ""
        };
        rest.get({
            url: '/ggfw/msg/list?msgType={msgType}&ydbz={ydbz}',
            urlParams : data,
            success: function(result) {
                if(result.code == '000') {
                    if(result.count > 0) {
                        $userinfo_section.find('.msgmark').show();
                    }
                }
            }
        });
    }

    var setSessionUserinfo = function(result) {
        sessionStorage.setItem('email', result.email);
        sessionStorage.setItem('phoneNum', result.phoneNum);
        sessionStorage.setItem('mobileNum', result.mobileNum);
    };

    var clearHistory = function() {
        var _controllers = A.Controller.get();
        var _history = _controllers.section.history;
        _history.length=0;
        var html_index_section = {"url":"index_section.html","hash":"#index_section","tag":"#index_section","query":"","param":{"":''}}
        _history.push(html_index_section);
    };

    $userinfo_section.on('sectionload', function(){

    });

    $userinfo_section.on('sectionshow', function(){
        var params = A.Component.params(this);
        A.showMask();
        rest.get({
            url: '/user',
            success: function(result) {
                if(result.code == '000') {
                    result.nsrmc = sessionStorage.getItem('nsrmc');
                    setSessionUserinfo(result);
                    A.template('#userinfo_tmpl').renderReplace(result,function() {
                        markMsg();
                    });
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.hideMask();
                A.showToast('更新办税厅数据失败');
            }
        });
        //clearHistory();
    });



    /**
     * 退出
     */
    $userinfo_section.find('#btn_logout').on(A.options.clickEvent, function () {
        A.showMask('退出中');
        rest.post({
            url: '/logout',
            success: function(result) {
                if(result.code == "000") {
                    A.hideMask();
                }
            }
        });
        clearSession();
        //A.Controller.back(false);

        history.back();
        //A.Controller.section('#login_section');
        A.hideMask();
        A.showToast('注销成功');
    });
});

