define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var jQuery = require('jquery');
    // var RSAUtils = require('rsa');
    var md5 = require('md5');
    var nsrsbh;
    // var verifyCode;
    var $register_form_valid;//校验obj
    /**
     * 初始化表单校验
     */
    function initFormValid() {
        if (!$register_form_valid) {
            $register_form_valid = jQuery('#register_section').find('#register_form').validator({
                theme: 'yellow_bottom',
                ignore: ':hidden',
                //stopOnError: true,
                fields: {
                    "register.user": {
                        rule: 'required;nsrsbh;',
                        msg: {required: "纳税人识别号不能为空"}
                    },
                    "register.frsfz": {
                        rule: "required;IDcard;",
                        msg: {required: "请填写正确的法人身份证号码"}
                    },
                    "register.usrsfz": {
                        rule: "required;IDcard;",
                        msg: {required: "请填写正确的用户身份证号码"}
                    }
                    // ,
                    // "register.phone": {
                    //     rule: "required;mobile;",
                    //     msg: {required: "请填办税员手机号码"}
                    // }
                }
            });
        }
    }


    $register_section = $('#register_section');

    $register_section.on('sectionload', function () {
        console.log('register_section load');
    });

    $register_section.on('sectionshow', function () {
        initFormValid();
        var $xydm = $register_section.find('#user');
        var $frsfz = $register_section.find('#frsfz');
        var $pwd = $register_section.find('#pwd');
        var $surepwd = $register_section.find('#surepwd');
        var $sfz = $register_section.find('#usrsfz');
        var $phone = $register_section.find('#phone');
        var $verifycode = $register_section.find('#sjyzm');

        var $getcodeBtn = $register_section.find("#getcode");

         $getcodeBtn.off();

        $getcodeBtn.on(A.options.clickEvent, function () {

            var phone = $phone.val() + '';

            if (isPhoneNumber(phone)) {
                timeCount($getcodeBtn);
                getVerifyCode(phone);
            }
            return false;
        });
        var $registerBtn = $register_section.find("#registerbtn");

        $registerBtn.off();

        $registerBtn.on(A.options.clickEvent, function () {

            if ($register_form_valid.isValid()) {

                nsrsbh = $xydm.val();
                var firstpwd = $.trim($pwd.val());
                var secondpwd = $.trim($surepwd.val());

                if (firstpwd == '') {
                    A.showToast("请输入登录密码!");
                    return false;
                }

                if (secondpwd == '') {
                    A.showToast("请输入确认登录密码!");
                    return false;
                }

                if (firstpwd == secondpwd) {

                    if (isPhoneNumber($phone.val())) {

                        var code = $verifycode.val();
                        if (code == '') {
                            A.showToast("请输入验证码!");
                            return false;
                        } else {

                            register(nsrsbh, $frsfz.val(), $sfz.val(), $pwd.val(), $phone.val(), $verifycode.val());
                        }
                    }

                } else {
                    A.showToast("请确认两次密码输入一致!");
                    return false;
                }
            }
            return false;
        });

    });


    $register_section.on('sectionhide', function () {

    });


    function isPhoneNumber(phone) {

        if (phone == '') {
            A.showToast('请输入办税员手机号码');
            return false;
        }

        var phoneReg = /^1[3-9]\d{9}$/;
        var r = phoneReg.test(phone);
        if (r) {
            return true;
        } else {
            A.showToast('请输入正确的手机号码');
            return false;
        }
    }

    var waitTime = 60;//s

    function timeCount(o) {
        if (waitTime == 0) {
            o.removeAttr("disabled");
            o.html("获取验证码");
            waitTime = 60;
            o.removeClass('disable');
        } else {
            o.attr("disabled", true);
            o.addClass('disable');
            o.html("重新发送(" + waitTime + "秒)");
            waitTime--;
            setTimeout(function () {
                    timeCount(o)
                },
                1000);
        }
    }

    function getVerifyCode(phone) {
        var condition = {
            phone: phone
        };
        A.showMask();
        rest.get({
            url: '/dxyz/send?sjhm={phone}',
            urlParams: condition,
            isNeedToken: false,
            success: function (result) {
                // verifyCode = $phone
                A.hideMask();
            },
            error: function () {
                A.hideMask();
                // A.showToast('获取数据失败');
            }
        });

    }


    function register(sbh, sfz1, sfz2, pwd, sjhm, yzm) {

        var data = {
            nsrsbh: sbh,
            frsfzhm: sfz1,
            dlmm: md5(pwd),
            bsysfzhm: sfz2,
            bsysjhm: sjhm,
            yzm: yzm
        };


        A.showMask("注册中...");
        rest.post({
            url: '/bsy/zcbsy',
            isNeedToken: false,
            data: data,
            success: function (result) {
                var msg = result.msg;
                A.hideMask();
                if (result.code == '000') {
                    //渲染
                    A.showToast('恭喜您,注册成功!');
                    //保存纳税人识别号
                    localStorage.setItem('nsrsbh', nsrsbh);
                    A.Controller.back();
                } else {
                    A.showToast(result.msg);
                }
            },
            error: function () {
                A.hideMask();
                A.showToast('获取数据失败');
            }
        });


    }


});