/**
 * Created by Li Hongwei on 2016/1/23.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var _this = $('#jsxxcx_search_modal');

    var count;//总页数

    /**
     * 条件
     * @type {{jkrqq: *, jkrqz: *, minNum: number, maxNum: number}}
     */
    var condition = {
        jkrqq:  _this.find('.jkrqq').val(),
        jkrqz:  _this.find('.jkrqz').val(),
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 清空条件
     */
    var resetCondition = function() {
        _this.find('.jkrqq_label').html('请选择时间');
        _this.find('.jkrqz_label').html('请选择时间');
        _this.find('.jkrqq').val('');
        _this.find('.jkrqz').val('');
        condition.jkrqq = _this.find('.jkrqq').val();
        condition.jkrqz = _this.find('.jkrqz').val();
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        rest.get({
            url: '/sssearch/queryjsxx?minNum={minNum}&maxNum={maxNum}&jkrqq={jkrqq}&jkrqz={jkrqz}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#jsxxcx_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#jsxxcx_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.jsxxList.length +'条记录');
                            }
                            nextPage();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#jsxxcx_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 查询模块
     */
    $('#jsxxcx_search_modal').on('modalshow', function() {

        //var datapicker = A.Datepicker();
        //
        //_this.find('.jkrqq_label').on(A.options.clickEvent, function () {
        //    var _date = null,
        //        _date_string_array = _this.find('.jkrqq').val().split('-');
        //    if (_date_string_array.length == 3) {
        //        _date = new Date(_date_string_array[0], parseInt(_date_string_array[1]) - 1, _date_string_array[2]);
        //    } else {
        //        _date = new Date();
        //    }
        //    datapicker.select(_date, function (data) {
        //        var _date = data.date,
        //            _date_string = data.dateString;
        //        _this.find('.jkrqq_label').html(_date_string);
        //        _this.find('.jkrqq').val(_date_string);
        //    });
        //});
        //
        //_this.find('.jkrqz_label').on(A.options.clickEvent, function () {
        //    var _date = null,
        //        _date_string_array = _this.find('.jkrqz').val().split('-');
        //    if (_date_string_array.length == 3) {
        //        _date = new Date(_date_string_array[0], parseInt(_date_string_array[1]) - 1, _date_string_array[2]);
        //    } else {
        //        _date = new Date();
        //    }
        //    datapicker.select(_date, function (data) {
        //        var _date = data.date,
        //            _date_string = data.dateString;
        //        _this.find('.jkrqz_label').html(_date_string);
        //        _this.find('.jkrqz').val(_date_string);
        //    });
        //});
    });


    /**
     * 加载主页
     */
    $('#jsxxcx_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        A.showMask();
        doRefresh();

        //rest.get({
        //    url: '/sssearch/queryjsxx?minNum={minNum}&maxNum={maxNum}&jkrqq={jkrqq}&jkrqz={jkrqz}',
        //    urlParams : condition,
        //    success: function(result) {
        //        if(result.code == '000') {
        //            if(result.jsxxList && result.jsxxList.length != 0) {
        //                A.template('#jsxxcx_tmpl').renderReplace(result, function() {
        //                    nextPage();
        //                });
        //            } else {
        //                if(condition.minNum==1) {//加载为首页时清空
        //                    A.template('#jsxxcx_tmpl').renderReplace();
        //                    A.showToast('未查询到相关记录');
        //                } else{
        //                    A.showToast('没有更多的信息了');
        //                }
        //            }
        //        } else {
        //            A.showToast(result.msg);
        //        }
        //        A.hideMask();
        //    },
        //    error: function() {
        //        A.showToast('连接超时');
        //        A.hideMask();
        //    }
        //});
    });

    /**
     * 滑动事件
     */
    $('#jsxxcx_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

    var initSeach = function(_this) {
        if(condition.jkrqq) {
            _this.find(".jkrqq_label").html(condition.jkrqq);
            _this.find(".jkrqq").val(condition.jkrqq);
        }
        if(condition.jkrqz) {
            _this.find(".jkrqz_label").html(condition.jkrqz);
            _this.find(".jkrqz").val(condition.jkrqz);
        }
    };

    $('#jsxxcx_search').on(A.options.clickEvent,function(e){
        //_this.find('.search_btn').off(A.options.clickEvent);
        //_this.find('.search_btn').on(A.options.clickEvent, function(){
        //    condition.jkrqq = _this.find('.jkrqq').val();
        //    condition.jkrqz = _this.find('.jkrqz').val();
        //    A.Controller.modal('#jsxxcx_search_modal');
        //});
        //A.Controller.modal('#jsxxcx_search_modal');


        var $popup = new A.Popup({
            html: $('#jsxxcx_search_modal').html(),
            pos : 'top'
        }).on('popupopen', function(){
                _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                    condition.jkrqq = _this.find(".jkrqq").val();
                    condition.jkrqz = _this.find(".jkrqz").val();
                    condition.minNum = 1;
                    condition.maxNum = 10;
                    //$('#jsxxcx_search_modal').html(_this.html());
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
        return false;
    });

});