/**
 * Created by Li Hongwei on 2016/1/24.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var count;//总页数

    /**
     * 查询条件
     * @type {{pzrqq: string, pzrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        pzrqq: "",
        pzrqz: "",
        minNum: 1,
        maxNum: 10
    };

    /**
     * 下一页页码
     */
    var nextPage = function () {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function () {
        A.showMask();
        rest.get({
            url: '/sssearch/sspzhd?minNum={minNum}&maxNum={maxNum}',
            urlParams: condition,
            success: function (result) {
                if (result.code == '000') {
                    if (condition.minNum <= result.count) {

                        for(var i in result.fppzhdList){
                            result.fppzhdList[i].objStr = JSON.stringify(result.fppzhdList[i]);
                        }

                        A.template("#pzhdxx_list_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#pzhdxxcx_article');
                            refresh.refresh();
                            count = result.count;
                            if (condition.minNum > 1) {
                                A.showToast('新加载' + result.fppzhdList.length + '条记录');
                            }
                            nextPage();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#pzhdxx_list_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function () {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    var resetCondition = function() {
        condition.minNum = 1;
        condition.maxNum = 10;
        condition.pzrqq = '';
        condition.pzrqz = '';
    };

    $('#pzhdxxcx_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        doRefresh();
    });

    $('#pzhdxxcx_article').on('refreshInit', function(){

        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });
});