/**
 * Created by Li Hongwei on 2016/1/23.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var _this = $('#sbxxcx_search_modal');

    var count;//总页数

    /**
     * 条件
     * @type {{skssqq: *, skssqz: *, minNum: number, maxNum: number}}
     */
    var condition = {
        skssqq:  _this.find('.skssqq').val(),
        skssqz:  _this.find('.skssqz').val(),
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    var doRefresh = function() {
        rest.get({
            url: '/sssearch/querysbxx?minNum={minNum}&maxNum={maxNum}&skssqq={skssqq}&skssqz={skssqz}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#sbxxcx_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#sbxxcx_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.sbxxList.length +'条记录');
                            }
                            nextPage();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#sbxxcx_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 查询模块
     */
    $('#sbxxcx_search_modal').on('modalshow', function() {

        //var datapicker = A.Datepicker();
        //
        //_this.find('.skssqq_label').on(A.options.clickEvent, function () {
        //    var _date = null,
        //        _date_string_array = _this.find('.skssqq').val().split('-');
        //    if (_date_string_array.length == 3) {
        //        _date = new Date(_date_string_array[0], parseInt(_date_string_array[1]) - 1, _date_string_array[2]);
        //    } else {
        //        _date = new Date();
        //    }
        //    datapicker.select(_date, function (data) {
        //        var _date = data.date,
        //            _date_string = data.dateString;
        //        _this.find('.skssqq_label').html(_date_string);
        //        _this.find('.skssqq').val(_date_string);
        //    });
        //});
        //
        //_this.find('.skssqz_label').on(A.options.clickEvent, function () {
        //    var _date = null,
        //        _date_string_array = _this.find('.skssqz').val().split('-');
        //    if (_date_string_array.length == 3) {
        //        _date = new Date(_date_string_array[0], parseInt(_date_string_array[1]) - 1, _date_string_array[2]);
        //    } else {
        //        _date = new Date();
        //    }
        //    datapicker.select(_date, function (data) {
        //        var _date = data.date,
        //            _date_string = data.dateString;
        //        _this.find('.skssqz_label').html(_date_string);
        //        _this.find('.skssqz').val(_date_string);
        //    });
        //});
    });


    var resetCondition = function() {
        _this.find('.skssqq_label').html('请选择时间');
        _this.find('.skssqz_label').html('请选择时间');
        _this.find('.skssqq').val('');
        _this.find('.skssqz').val('');
        condition.skssqq = _this.find('.skssqq').val();
        condition.skssqz = _this.find('.skssqz').val();
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    $('#sbxxcx_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        A.showMask();
        doRefresh();
        //rest.get({
        //    url: '/sssearch/querysbxx?minNum={minNum}&maxNum={maxNum}&skssqq={skssqq}&skssqz={skssqz}',
        //    urlParams : condition,
        //    success: function(result) {
        //        if(result.code == '000') {
        //            A.template('#sbxxcx_tmpl').renderReplace(result,function() {
        //                nextPage();
        //            });
        //        } else {
        //            A.showToast(result.msg);
        //        }
        //        A.hideMask();
        //    },
        //    error: function() {
        //        A.showToast('连接超时');
        //        A.hideMask();
        //    }
        //});
    });

    $('#sbxxcx_article').on('refreshInit', function(){

        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

    var initSeach = function(_this) {
        if(condition.skssqq) {
            _this.find(".skssqq_label").html(condition.skssqq);
            _this.find(".skssqq").val(condition.skssqq);
        }
        if(condition.skssqz) {
            _this.find(".skssqz_label").html(condition.skssqz);
            _this.find(".skssqz").val(condition.skssqz);
        }
    };

    $('#sbxxcx_search').on(A.options.clickEvent,function(e){
        //_this.find('.search_btn').off(A.options.clickEvent);
        //_this.find('.search_btn').on(A.options.clickEvent, function(){
        //    condition.skssqq = _this.find('.skssqq').val();
        //    condition.skssqz = _this.find('.skssqz').val();
        //    A.Controller.modal('#sbxxcx_search_modal');
        //});
        //A.Controller.modal('#sbxxcx_search_modal');

        var $popup = new A.Popup({
            html: $('#sbxxcx_search_modal').html(),
            pos : 'top'
        }).on('popupopen', function(){
                _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                    condition.skssqq = _this.find(".skssqq").val();
                    condition.skssqz = _this.find(".skssqz").val();
                    condition.minNum = 1;
                    condition.maxNum = 10;
                    //$('#sbxxcx_search_modal').html(_this.html());
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
        return false;
    });

});