/**
 * Created by Li Hongwei on 2016/1/23.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var count;//总页数

    /**
     * 条件
     * @type {{jkrqq: *, jkrqz: *, minNum: number, maxNum: number}}
     */
    var condition = {
        qyrqq:'',   //签约日期起
        qyrqz:'',	//签约日期止
        qybz:'',	//签约标志
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 清空条件
     */
    var resetCondition = function() {
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        rest.get({
            url: '/sssearch/sfxyxx?minNum={minNum}&maxNum={maxNum}&qyrqq={qyrqq}&qyrqz={qyrqz}&qybz={qybz}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#sfxyxx_list_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#sfxyxxcx_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.sfxyxxList.length +'条记录');
                            }
                            nextPage();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#sfxyxx_list_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };




    /**
     * 加载主页
     */
    $('#sfxyxxcx_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        A.showMask();
        doRefresh();
        //rest.get({
        //    url: '/sssearch/sfxyxx?minNum={minNum}&maxNum={maxNum}&qyrqq={qyrqq}&qyrqz={qyrqz}&qybz={qybz}',
        //    urlParams : condition,
        //    success: function(result) {
        //        if(result.code == '000') {
        //            if(result.sfxyxxList && result.sfxyxxList.length != 0) {
        //                A.template('#sfxyxx_list_tmpl').renderReplace(result, function() {
        //                    nextPage();
        //                });
        //            } else {
        //                A.showToast('未查询到相关记录');
        //            }
        //        } else {
        //            A.showToast(result.msg);
        //        }
        //        A.hideMask();
        //    },
        //    error: function() {
        //        A.showToast('连接超时');
        //        A.hideMask();
        //    }
        //});
    });

    /**
     * 滑动事件
     */
    $('#sfxyxxcx_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

});