/**
 * Created by Li Hongwei on 2016/2/16.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var smnsxyjbcx_section = $('#smnsxyjbcx_section');

    /**
     * 查询条件
     * @type pjnd 评价年度
     */
    var condition = {
        pjnd: new Date().getFullYear()
    };

    /**
     * 刷新
     */
    var doRefresh = function () {
        A.showMask();
        rest.get({
            url: '/xyjbcx/cxjb?pjnd={pjnd}',
            urlParams: condition,
            success: function (result) {
                if (result.code == '000') {
                    if (result.dataList.length > 0) {
                        result.nsrmc = result.dataList[0].nsrmc;
                        result.nsrsbh = result.dataList[0].nsrsbh;
                        result.ndxyjb = result.dataList[0].ndxyjb;
                        result.pjnd = result.dataList[0].pjnd;
                    } else {
                        A.showToast('未查询到相关记录');
                    }
                    A.template("#smnsxyjbnsr_tmpl").renderReplace(result);
                    A.template("#smnsxyjbcx_tmpl").renderReplace(result);
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function () {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 页面初始加载
     */
    smnsxyjbcx_section.on('sectionshow', function () {
        smnsxyjbcx_section.find('.year').val(condition.pjnd);
        doRefresh();
    });

    $('.search_btn').on(A.options.clickEvent, function () {
        var pjnd = smnsxyjbcx_section.find('.year').val();
        if (!pjnd.match(new RegExp('^\\d{4}$'))) {
            A.showToast('请输入4位数字的年份');
            return;
        }
        condition.pjnd = pjnd;
        doRefresh();
    });

    var initSearch = function (_this) {
        if (condition.pjnd) {
            _this.find(".year_label").html(condition.pjnd);
            _this.find(".year").val(condition.pjnd);
        }
    };

    /**
     * 查询按钮
     */
    $('#smnsxyjbcx_search').on(A.options.clickEvent, function () {
        var $popup = new A.Popup({
            html: $('#smnsxyjbcx_search_modal').html(),
            pos: 'top'
        }).on('popupopen', function () {
                var _this = this.popup;
                A.Component.datetime(_this);
                initSearch(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function () {
                    var vdate = _this.find(".year").val();
                    condition.pjnd = vdate ? new Date(vdate).getFullYear() : new Date().getFullYear();
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function () {
            }).open(function () {
            });
        return false;
    });
});
