/**
 * Created by Li Hongwei on 2016/2/16.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

var  $ssyhzgba_add_section =  $('#ssyhzgba_add_section');
    var count;//总页数

    /**
     * 查询条件
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        wszlDm:'10019',
        wsztDm:'',
        sqrqq:'',
        sqrqz:'',
        wsid:'',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    var resetCondition = function() {
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        A.showMask();
        rest.get({
            url: '/jkpz/list?minNum={minNum}&maxNum={maxNum}&dzsphm={dzsphm}&jkrqq={jkrqq}&jkrqz={jkrqz}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#ssyhzgba_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#ssyhzgba_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.list.length +'条记录');
                            }
                            nextPage();
                        });
                    } else {
                        A.showToast('没有更多的信息了');
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };



    /**
     * 页面初始加载
     */
    $('#ssyhzgba_add_section').on('sectionload', function() {
        rest.get({
            url: '/rd/ssyhzgba/init',
            success: function (result) {
                if (result.code == '000') {
                    A.template('#ssyhzgba_add_baxsel_tmp').renderReplace(result, function() {
                    });
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function () {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    });

    $('#add-btn').on(A.options.clickEvent, function() {
        rest.post({
            url: '/rd/ssyhzgba/add',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    A.template('#ssyhzgba_tmpl').renderReplace(result, function() {
                        nextPage();
                    });
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    })

    /**
     * 页面初始加载
     */
    $('#ssyhzgba_add_section').on('sectionshow', function(){
        $ssyhzgba_add_section.find('.nsrsbh').html(localStorage.getItem('nsrsbh'));
        $ssyhzgba_add_section.find('.nsrmc').html(sessionStorage.getItem('nsrmc'));
    });

});