/**
 * Created by Li Hongwei on 2016/1/24.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var _this = $('#wsspjdcx_search_modal');

    var count; //总页数



    /**
     * 条件
     * @type {{skssqq: *, skssqz: *, minNum: number, maxNum: number}}
     */
    var condition = {
        wszl: _this.find(".wszl option").not(function() { return !this.selected; }).val(),
        wszt: _this.find(".wszt option").not(function() { return !this.selected; }).val(),
        sqsjq: _this.find(".sqsjq").val(),
        sqsjz: _this.find(".sqsjz").val(),
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    var doRefresh = function() {
        A.showMask();
        rest.get({
            url: '/sssearch/querywssqxx?minNum={minNum}&maxNum={maxNum}&sqsjq={sqsjq}&sqsjz={sqsjz}&wszlDm={wszl}&wsztDm={wszt}',
            urlParams: condition,
            success: function(result) {
                if (result.code == '000') {
                    if (condition.minNum <= result.count) {
                        for (var i = 0, wssqList = result.wssqList; i < wssqList.length; i++) {
                            result.wssqList[i].stringify = JSON.stringify;
                        }
                        A.template("#wsspjdcx_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function() {
                            var refresh = A.Refresh('#wsspjdcx_article');
                            refresh.refresh();
                            count = result.count;
                            if (condition.minNum > 1) {
                                A.showToast('新加载' + result.wssqList.length + '条记录');
                            }
                            nextPage();
                        });
                    } else {
                        if (condition.minNum == 1) { //加载为首页时清空
                            A.template('#wsspjdcx_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else {
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    var initSeach = function(_this) {
        if (condition.sqsjq) {
            _this.find(".sqsjq_label").html(condition.sqsjq);
            _this.find(".sqsjq").val(condition.sqsjq);
        }
        if (condition.sqsjz) {
            _this.find(".sqsjz_label").html(condition.sqsjz);
            _this.find(".sqsjz").val(condition.sqsjz);
        }
        if (condition.wszl) {
            _this.find('.wszl option[value="' + condition.wszl + '"]').attr('selected', 'selected');
        }
        if (condition.wszt) {
            _this.find('.wszt option[value="' + condition.wszt + '"]').attr('selected', 'selected');
        }
    };

    $('#wsspjdcx_search').on(A.options.clickEvent, function() {
        var $popup = new A.Popup({
            html: $('#wsspjdcx_search_modal').html(),
            pos: 'top',
        }).on('popupopen', function() {
            _this = this.popup;
            A.Component.datetime(_this);
            initSeach(_this);
            _this.find('.search_btn').off(A.options.clickEvent);
            _this.find('.search_btn').on(A.options.clickEvent, function() {
                condition.sqsjq = _this.find(".sqsjq").val();
                condition.sqsjz = _this.find(".sqsjz").val();
                condition.wszl = _this.find(".wszl option").not(function() { return !this.selected; }).val();
                _this.find('.wszl option[value="' + condition.wszl + '"]').attr('selected', 'selected');
                condition.wszt = _this.find(".wszt option").not(function() { return !this.selected; }).val();
                _this.find('.wszt option[value="' + condition.wszt + '"]').attr('selected', 'selected');
                condition.minNum = 1;
                condition.maxNum = 10;
                //$('#wsspjdcx_search_modal').html(_this.html());
                doRefresh();
                $popup.close();
            });
        }).on('popupclose', function() {}).open(function() {});
        return false;
    });
    /**
     * 查询模块
     */
    _this.on('modalshow', function() {});

    $('#wsspjdcx_section').on('sectionload', function() {
        //加载文书种类
        rest.get({
            url: "/common/code/wszl",
            success: function(result) {
                if (result.code != "000") {
                    A.showToast(result.msg);
                    return;
                }
                if (!result.result || result.result.length == 0) {
                    A.showToast("没有查询到申请事项状态");
                    return;
                }
                A.template('#wszl_tmpl').renderReplace(result);
            }
        });

        //加载文书状态
        rest.get({
            url: "/common/code/wszt",
            success: function(result) {
                if (result.code != "000") {
                    A.showToast(result.msg);
                    return;
                }
                if (!result.result || result.result.length == 0) {
                    A.showToast("没有查询到申请事项状态");
                    return;
                }
                A.template('#wszt_tmpl').renderReplace(result);
            }
        });
    });


    var resetCondition = function() {
        condition.minNum = 1;
        condition.maxNum = 10;
        condition.wszl = '';
        condition.wszt = '';
        condition.sqsjq = '';
        condition.sqsjz = '';
        var _this = $('#wsspjdcx_search_modal');
        _this.find(".sqsjq").val('');
        _this.find(".sqsjz").val('');
        _this.find(".sqsjq_label").html('请选择日期');
        _this.find(".sqsjz_label").html('请选择日期');
        _this.find('.wszl option').removeAttr('selected');
        _this.find('.wszt option').removeAttr('selected');
    };

    //$('#wsspjdcx_section').on('sectionhide', function(){
    //    resetCondition();
    //});

    $('#wsspjdcx_section').on('sectionshow', function() {
        var params = A.Component.params(this);
        if (params.type == '1') { //从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        //rest.get({
        //    url: '/sssearch/querywssqxx?minNum={minNum}&maxNum={maxNum}&wszlDm={wszl}&wsztDm={wszt}&sqrq={sqrq}',
        //    urlParams : condition,
        //    success: function(result) {
        //        if(result.code == '000') {
        //            if(result.count && result.count != '0') {
        //                A.template('#wsspjdcx_tmpl').renderReplace(result, function() {
        //                    nextPage();
        //                });
        //            } else {
        //                A.template('#wsspjdcx_tmpl').renderReplace();
        //                A.showToast('未查询到相关记录');
        //            }
        //        } else {
        //            A.showToast(result.msg);
        //        }
        //        A.hideMask();
        //    },
        //    error: function() {
        //        A.showToast('连接超时');
        //        A.hideMask();
        //    }
        //});

        doRefresh();
    });

    $('#wsspjdcx_article').on('refreshInit', function() {

        var refresh = A.Refresh(this);
        refresh.on('pullup', function() {
            doRefresh();
        });
        refresh.on('pulldown', function() {
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

    //$('#wsspjdcx_search').on(A.options.clickEvent,function(e){
    //    _this.find('.search_btn').off(A.options.clickEvent);
    //    _this.find('.search_btn').on(A.options.clickEvent, function(){
    //        condition.wszl = _this.find(".wszl option").not(function () {return !this.selected;}).val();
    //        condition.wszt = _this.find(".wszt option").not(function () {return !this.selected;}).val();
    //        A.Controller.modal('#wsspjdcx_search_modal');
    //    });
    //    A.Controller.modal('#wsspjdcx_search_modal');
    //});

});