/**
 * Created by Li Hongwei on 2016/1/23.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var _formatDate = function(dateStr){
        var param = dateStr.split("-");
        return new Date(param[0]+'/'+param[1]+'/'+param[2]);
    };

    var validDate = function(startDateStr,endDateStr){
        var startDate = _formatDate(startDateStr);
        var endDate = _formatDate(endDateStr);
        var today = new Date();
        if(startDate<today && endDate>today)
            return true;
        else
            return false;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        rest.get({
            url: '/sssearch/zzsybnsrrd',
            success: function(result) {
                if(result.code == '000') {
                    if(result.zzsybnsrRdxxList && result.zzsybnsrRdxxList.length != 0) {
                        var data = {hasData : false};
                        for(var i in result.zzsybnsrRdxxList){
                            if(validDate(result.zzsybnsrRdxxList[i].yxqQ,result.zzsybnsrRdxxList[i].yxqZ)){
                                data = result.zzsybnsrRdxxList[i];
                                data.hasData = true;
                            }
                        }
                        A.template('#ybnsrrdxx_info_tmpl').renderReplace(data, function() {
                        });
                    } else {
                        A.showToast('未查询到相关记录');
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };



    /**
     * 加载主页
     */
    $('#ybnsrrdxxcx_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        A.showMask();
        doRefresh();
    });

    /**
     * 滑动事件
     */
    $('#ybnsrrdxxcx_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pulldown', function(){
            doRefresh();
        });
    });
});