/**
 * Created by Li Hongwei on 2016/2/16.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
	var section = $('#yhsxbacx_section');
	var search_btn = $('.search_btn');

    /**
     * 查询条件
     * @param nd 年度 
     */
    var condition = {
        nd: new Date().getFullYear() 
    };

    /**
     * 刷新
     */
    var doRefresh = function () {
        A.showMask();
        rest.get({
            url: '/nsrls/cxsdsyh?nd={nd}',
            urlParams: condition,
            success: function (result) {
                if (result.code == '000') {
					if (result.dataList.length > 0) {
						result.nsrmc = sessionStorage.getItem('nsrmc');
						result.nsrsbh = localStorage.getItem('nsrsbh');
					} else {
						A.showToast('未查询到相关记录');
					}
					A.template('#yhsxbacx_tmpl').renderReplace(result);
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function () {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 页面初始加载
     */
    section.on('sectionshow', function () {
		section.find(".year").val(condition.nd);
        doRefresh();
    });

    /**
     * 查询按钮
     */
    search_btn.on(A.options.clickEvent, function () {
		condition.nd = section.find('.year').val();
		if (!condition.nd.match(new RegExp('^\\d{4}$'))) {
			A.showToast('请输入4位数字的年份');
			return;
		}
		doRefresh();
        return false;
    });

});
