/**
 * Created by Li Hongwei on 2016/1/26.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var $bsrl_section = $('#bsrl_section');
    var today = new Today();    //今日对象
    var year = today.year;      //当前显示的年份
    var month = today.month;    //当前显示的月份

    /**
     * 更新年月提示
     */
     function updateDateInfo() {
         $bsrl_section.find("#dateInfo").html(year + "年" + (month + 1) + "月");
    }

    /**
     * 今天对象
     * @constructor
     */
    function Today() {
        this.now = new Date();
        this.year = this.now.getFullYear();
        this.month = this.now.getMonth();
        this.day = this.now.getDate();
    }

    //判断是否闰年返回每月天数
    function getDays(month, year) {
        var daysInMonth = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
        if (1 == month) {
            if (((0 == year % 4) && (0 != (year % 100))) || (0 == year % 400)) {
                return 29;
            } else {
                return 28;
            }
        } else {
            return daysInMonth[month];
        }
    }

    var initBtnEvent = function(){
        /**
         * 显示上月日程
         */
        $bsrl_section.find('.prevMonth').off(A.options.clickEvent);
        $bsrl_section.find('.prevMonth').on(A.options.clickEvent, function () {
            if ((month - 1) < 0) {
                month = 11;
                year--;
                sessionStorage.removeItem("bsrq");
            } else {
                month--;
            }

            if(sessionStorage.getItem("bsrq")){
                var cacheBsrq = JSON.parse(sessionStorage.getItem("bsrq"));

                var formatedMonth;

                if(cacheBsrq.dataList.length==0){
                    fillBox_new("0,0");
                    changeTips_new("");
                    return;
                }
                for(var i in cacheBsrq.dataList){
                    if(month<9){
                        formatedMonth = "0"+(month+1);
                    }else{
                        formatedMonth = ""+(month+1);
                    }
                    if(cacheBsrq.dataList[i].sbyf==year+"-"+formatedMonth){
                        fillBox_new(cacheBsrq.dataList[i].sbrq);
                        changeTips_new(cacheBsrq.dataList[i].description);
                        break;
                    };
                    if(i==cacheBsrq.dataList.length-1){
                        fillBox_new("0,0");
                        changeTips_new("");
                    }
                }
            }else{
                A.showMask();
                rest.get({
                    url: "/ggfw/bsrl/getsbrq?sbnf={sbnf}",
                    urlParams: {
                        sbnf : year
                    },
                    success: function (data) {
                        A.hideMask();
                        var formatedMonth;
                        sessionStorage.setItem("bsrq",JSON.stringify(data));

                        if(data.dataList.length==0){
                            fillBox_new("0,0");
                            changeTips_new("");
                            return;
                        }
                        for(var i in data.dataList){
                            if(month<9){
                                formatedMonth = "0"+(month+1);
                            }else{
                                formatedMonth = ""+(month+1);
                            }
                            if(data.dataList[i].sbyf==year+"-"+formatedMonth){
                                fillBox_new(data.dataList[i].sbrq);
                                changeTips_new(data.dataList[i].description);
                                break;
                            };
                            if(i==data.dataList.length-1){
                                fillBox_new("0,0");
                                changeTips_new("");
                            }
                        }
                    },
                    error: function (err) {
                        fillBox_new("0,0");
                        changeTips_new("");
                        A.hideMask();
                        A.showToast("查询办税日期失败");
                    }
                });
            }
        });

        /**
         * 显示下月日程
         */
        $("#nextMonth").off(A.options.clickEvent);
        $("#nextMonth").on(A.options.clickEvent, function () {
            if ((month + 1) > 11) {
                month = 0;
                year++;
                sessionStorage.removeItem("bsrq");
            } else {
                month++;
            }

            if(sessionStorage.getItem("bsrq")){
                var cacheBsrq = JSON.parse(sessionStorage.getItem("bsrq"));

                var formatedMonth;

                if(cacheBsrq.dataList.length==0){
                    fillBox_new("0,0");
                    changeTips_new("");
                    return;
                }

                for(var i in cacheBsrq.dataList){
                    if(month<9){
                        formatedMonth = "0"+(month+1);
                    }else{
                        formatedMonth = ""+(month+1);
                    }
                    if(cacheBsrq.dataList[i].sbyf==year+"-"+formatedMonth){
                        fillBox_new(cacheBsrq.dataList[i].sbrq);
                        changeTips_new(cacheBsrq.dataList[i].description);
                        break;
                    };
                    if(i==cacheBsrq.dataList.length-1){
                        fillBox_new("0,0");
                        changeTips_new("");
                    }
                }
            }else{
                A.showMask();
                rest.get({
                    url: "/ggfw/bsrl/getsbrq?sbnf={sbnf}",
                    urlParams: {
                        sbnf : year
                    },
                    success: function (data) {
                        A.hideMask();
                        var formatedMonth;
                        sessionStorage.setItem("bsrq",JSON.stringify(data));

                        if(data.dataList.length==0){
                            fillBox_new("0,0");
                            changeTips_new("");
                            return;
                        }

                        for(var i in data.dataList){
                            if(month<9){
                                formatedMonth = "0"+(month+1);
                            }else{
                                formatedMonth = ""+(month+1);
                            }

                            if(data.dataList[i].sbyf==year+"-"+formatedMonth){
                                fillBox_new(data.dataList[i].sbrq);
                                changeTips_new(data.dataList[i].description);
                                break;
                            };
                            if(i==data.dataList.length-1){
                                fillBox_new("0,0");
                                changeTips_new("");
                            }
                        }
                    },
                    error: function (err) {
                        fillBox_new("0,0");
                        changeTips_new("");
                        A.hideMask();
                        A.showToast("查询办税日期失败");
                    }
                });
            }
        });
    }

    $bsrl_section.on('sectionhide',function(){
        sessionStorage.removeItem("bsrq");
    });

    /**
     * 初始化
     */
    $bsrl_section.on('sectionshow', function () {
        today = new Today();    //今日对象
        year = today.year;      //当前显示的年份
        month = today.month;    //当前

        initBtnEvent();
        A.showMask();
        rest.get({
            url: "/ggfw/bsrl/getsbrq?sbnf={sbnf}",
            urlParams: {
                sbnf : year
            },
            success: function (data) {
                A.hideMask();
                sessionStorage.setItem("bsrq",JSON.stringify(data));

                if(data.dataList.length==0){
                    fillBox_new("0,0");
                    changeTips_new("");
                    return;
                }
                for(var i in data.dataList){
                    if(month<10){
                        if(data.dataList[i].sbyf==year+"-0"+(month+1)){
                            fillBox_new(data.dataList[i].sbrq);
                            changeTips_new(data.dataList[i].description);
                            break;
                        };
                    }else{
                        if(data.dataList[i].sbyf==year+"-"+(month+1)){
                            fillBox_new(data.dataList[i].sbrq);
                            changeTips_new(data.dataList[i].description);
                            break;
                        };
                    }
                }
            },
            error: function (err) {
                A.hideMask();
                A.showToast("查询办税日期失败");
            }
        });
    });
    $bsrl_section.on('sectionhide', function () {
        A.template('#bsrl_tip_tmpl').renderReplace();
    });

    var changeTips_new = function(content){
        var param = {
            content : content
        }
        A.template('#bsrl_tip_tmpl').renderReplace(param, function () {});
    }

    var fillBox_new = function(sbrq) {
        updateDateInfo();                   //更新年月提示
        $("td.calBox").empty();             //清空每日单元格

        var dayCounter = 1;                 //设置天数计数器并初始化为1
        var cal = new Date(year, month, 1); //以当前年月第一天为参数创建日期对象
        var startDay = cal.getDay();        //计算填充开始位置

        //计算填充结束位置
        var endDay = startDay + getDays(cal.getMonth(), cal.getFullYear()) - 1;

        //如果显示的是今日所在月份的日程，设置day变量为今日日期
        var day = -1;
        if (today.year == year && today.month == month) {
            day = today.day;
        }

        var startSbrq = sbrq.split(",")[0];
        var endSbrq = sbrq.split(",")[1];

        //从startDay开始到endDay结束，在每日单元格内填入日期信息
        for (var i = startDay; i <= endDay; i++) {
            ///////////////
            var tempmonth;
            var tempday;
            if (month + 1 < 10) {
                tempmonth = "0" + (month + 1);
            } else {
                tempmonth = (month + 1);
            }
            if (dayCounter < 10) {
                tempday = "0" + dayCounter;
            } else {
                tempday = dayCounter;
            }


            if (dayCounter <= endSbrq && dayCounter>=startSbrq) {
                if (dayCounter == day) {
                    $bsrl_section.find("#calBox" + i).html("<div class='date today shenbaoqi' title='今天是办税申报日' id='" + year + "-" + tempmonth + "-" + tempday + "' >" + dayCounter + "</div>");
                } else {
                    $bsrl_section.find("#calBox" + i).html("<div class='date shenbaoqi' title='办税申报期' id='" + year + "-" + tempmonth + "-" + tempday + "' >" + dayCounter + "</div>");
                }

            } else {
                if (dayCounter == day) {
                    $bsrl_section.find("#calBox" + i).html("<div class='date today' title='今天不是办税申报日' id='" + year + "-" + tempmonth + "-" + tempday + "' >" + dayCounter + "</div>");
                } else {
                    $bsrl_section.find("#calBox" + i).html("<div class='date' id='" + year + "-" + tempmonth + "-" + tempday + "' >" + dayCounter + "</div>");
                }
            }
            dayCounter++;
        }
    }

});
