/**
 * Created by Li Hongwei on 2016/1/26.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var calendar_calendar = null;
    var today = new Date();
    var html = '';

    /**
     * 2016年办税日历
     * @type {*[]}
     */
    var bsrllist = [
        {month : 1, endday : 18},
        {month : 2, endday : 22},
        {month : 3, endday : 15},
        {month : 4, endday : 18},
        {month : 5, endday : 16},
        {month : 6, endday : 20},
        {month : 7, endday : 15},
        {month : 8, endday : 15},
        {month : 9, endday : 18},
        {month : 10, endday : 24},
        {month : 11, endday : 15},
        {month : 12, endday : 15}
    ];

    /**
     * 办税日期样式
     * @type {string}
     * @private
     */
    var _bsrqClass = 'carrot';

    /**
     * 显示日历
     * @param _val
     */
     var showCalendar = function(_val){
        if(_val){
            calendar_calendar = A.Calendar("#calendar_calendar",{
                row:_val,
                autoJump:_val>6?false:true,
                marks:{
                    '2016-1-1':{
                        data:[
                            {
                                id:1,
                                name:'买灯泡',
                                position:'汉中门大街'
                            }
                        ],
                        'top':{
                            class:'curr_top'
                        },
                        hideCount:true
                    },
                    '2016-1-2':{
                        data:[
                            {
                                id:2,
                                name:'买牙膏'
                            },{
                                id:3,
                                name:'包粽子',
                                position:'奶奶家'
                            }
                        ],
                        'bottom':{
                            content:'端午',
                            class:'hoilday'
                        },
                        hideCount:true
                    },
                    '2016-1-3':{
                        data:[
                            {
                                id:11,
                                name:'熏蚊子'
                            },{
                                id:12,
                                name:'打印材料'
                            },{
                                id:13,
                                name:'回电话给客户'
                            },{
                                id:14,
                                name:'调热水器'
                            },{
                                id:15,
                                name:'油烟机送洗'
                            }
                        ],
                        formClass:'curr_td'
                    },
                    '2016-1-4':{
                        data:[
                            {
                                id:16,
                                name:'换煤气'
                            }
                        ],
                        formClass:'bg-sun-flower white'
                    },
                    '2016-1-5':{
                        data:[
                            {
                                id:18,
                                name:'整理柜子',
                                position:'办公室'
                            },
                            {
                                id:19,
                                name:'扔垃圾'
                            }
                        ]
                    },
                    '2016-1-26':{
                        data:[
                            {
                                id:18,
                                name:'整理柜子',
                                position:'办公室'
                            },
                            {
                                id:19,
                                name:'扔垃圾'
                            }
                        ]
                    }
                }

            });
            calendar_calendar.onChange(function(data){
                showBsrq();
                if(calendar_calendar.opts.selectedDateString){
                    $('#datapicker_label').html(calendar_calendar.opts.selectedDateString);
                    $('#datapicker').val(calendar_calendar.opts.selectedDateString);
                }else{
                    $('#datapicker_label').html('点此跳转');
                    $('#datapicker').val('');
                }
            })
            calendar_calendar.onTap(updataData);

            A.Scroll("#bsrl_article",{}).refresh();
        }
    };

    /**
     * 单条办税日期样式操作
     */
    var bsrqAddClass = function(value) {
        var month = value.month;
        var endDay = value.endday;
        for(var i=1; i<=endDay; i++) {
            if($('[data-day="2016-' + month + '-' + i + '"]').length > 0) {
                $('[data-day="2016-' + month + '-' + i + '"]').parent().addClass(_bsrqClass);
            } else {
                return;
            }
        }
    };

    /**
     * 显示办税日期
     */
    var showBsrq = function() {
        bsrllist.map(bsrqAddClass);
    };

    var updataDataPanel = function(_mark){
        var html = '';

        if(_mark.data&&_mark.data.length!=0) {
            html+='<p style="margin-left: 3px;margin-top: 4px;">活动总数:'
                +_mark.data.length
                +'</p>';

            html+='<button id="detal_button" class="link">点此查看详情</button>';
        }

        A.anim.run($("#data_panel"),'scaleIn');

        $("#data_panel").html(html);

        $('#detal_button').off(A.options.clickEvent).on(A.options.clickEvent,function(){
            A.Controller.modal('#detail_modal');
        });
    }

    function updataEditData(_date_string,_mark){
        var html_scroller='';

        if(_mark.data&&_mark.data.length!=0) {
            html_scroller+='<ul id="swipe_test" class="listitem">';

            for(var key in _mark.data){
                html_scroller+='<li data-key="'+key+'" data-date="'+_date_string+'">';

                html_scroller+='<div class="text">';

                html_scroller+='<font style="font-size: 18px;color: #3779D0;">'
                    +_mark.data[key].name
                    +'</font>';

                if(_mark.data[key].position){
                    html_scroller +='<p>地点：'+_mark.data[key].position+'</p>';
                }

                if(_mark.data[key].startTime||_mark.data[key].endTime){
                    html_scroller +='<p>时间：'+(_mark.data[key].startTime?_mark.data[key].startTime:'<font style="color:red;">?</font>')+'~'+(_mark.data[key].endTime?_mark.data[key].endTime:'<font style="color:red;">?</font>')+'</p>';
                }

                html_scroller+='</div>';

                html_scroller+='</li>';
            }

            html_scroller+='</ul>';
        }

        $('#detail_modal_title').html(_date_string+'的活动');

        $('#detail_modal_article_scroller').html(html_scroller);

        A.Scroll("#detail_modal_article").refresh();
    }

    function updataData(data){
        showBsrq();

        var _mark = data.mark,
            _date = data.date,
            _date_string = _date.getFullYear()+'-'+(_date.getMonth()+1)+'-'+_date.getDate();

        $('#datapicker_label').html(_date_string);
        $('#datapicker').val(_date_string);

        updataDataPanel(_mark);

        updataEditData(_date_string,_mark);

        var ulController = A.ExList.ulController('#swipe_test',{
            swipeOptionOnTap : function(liElement,targetElement){
                A.confirm('提示','确定移除该活动吗？', function(){
                    var _$this = $(liElement);
                    var _data_key = _$this.data('key');
                    var _date_string = _$this.data('date');

                    delete_one_mark(_data_key,_date_string);

                    updataDataPanel(_mark);

                    calendar_calendar.refresh();
                });
            }
        });

        //(function(){
            $('#detail_modal_edit').text('编辑');

            $('#edit_footer').css('bottom','-56px');

            $('#detail_modal_edit').off(A.options.clickEvent).on(A.options.clickEvent,edit);

            $('#edit_footer').off(A.options.clickEvent).on(A.options.clickEvent,function(){
                var number = 0;
                $('.exlist_checkbox').each(function(){
                    var $li = $(this).parents('li');
                    if($(this)[0].checked && $li.data('key')!='-1'){
                        number++;
                    }
                });

                if(number==0){
                    A.alert("请选择待删除的活动");
                    return;
                }

                A.confirm('提示','确定移除这'+number+'项活动吗？', function(){
                    $('.exlist_checkbox').each(function(){
                        var _data_key , _date_string;
                        var $li = $(this).parents('li');
                        if($(this)[0].checked && $li.data('key')!='-1'){
                            _data_key = $li.data('key');
                            _date_string = $li.data('date');
                            delete_one_mark(_data_key,_date_string);
                        }
                    });

                    updataDataPanel(_mark);

                    calendar_calendar.refresh();
                });
            });

            function showEditMenu(){
                $('#edit_footer').animate({
                    bottom:'0px'
                },100);
            }

            function hideEditMenu(){
                $('#edit_footer').animate({
                    bottom:'-56px'
                },100);
            }

            function edit(){
                ulController.showLeft();
                $('#detail_modal_edit').text('取消');
                showEditMenu();
                $('#detail_modal_edit').off(A.options.clickEvent).on(A.options.clickEvent,function(){
                    ulController.hideLeft();
                    $('#detail_modal_edit').text('编辑');
                    $('#detail_modal_edit').off(A.options.clickEvent).on(A.options.clickEvent,edit);
                    hideEditMenu();
                });
            }
        //})();
    }

    function delete_one_mark(_data_key,_date_string){
        var _data = calendar_calendar.getMarkAllData(_date_string);
        var _data_temp = [];

        for(var key in _data){
            if(key!=_data_key){
                _data_temp.push(_data[key]);
            }
        }

        calendar_calendar.setMarkAllData(_date_string,_data_temp);

        if(!calendar_calendar.getMarkAllData(_date_string)||calendar_calendar.getMarkAllData(_date_string).length==0){
            calendar_calendar.removeMark(_date_string);
        }

        $('[data-key="'+_data_key+'"]').data('key','-1').css('display','none').attr('data-key',-1);

        var index = 0;

        $('#swipe_test').find('li').each(function(){
            if($(this).data('key') != '-1'){
                $(this).data('key',index);
                $(this).attr('data-key',index);
                index++;
            }
        });
    }


    $('#calendar_calendar').on('refresh',function(){
        alert(1)
    });

    $('#bsrl_section').on('sectionshow',function(){
        showCalendar(6);

        showBsrq();

        var datapicker = A.Datepicker();

        $('#control_panel').on(A.options.clickEvent, function() {
            var _date=null,
                _date_string_array=$('#datapicker').val().split('-');

            if(_date_string_array.length==3){
                _date=new Date(_date_string_array[0],parseInt(_date_string_array[1])-1,_date_string_array[2]);
            }else{
                _date=new Date();
            }

            datapicker.select(_date,function(data){
                var _date=data.date,
                    _date_string = data.dateString;
                $('#datapicker').val(_date_string);
                $('#datapicker_label').html(_date_string);
                calendar_calendar.goto(data.date);
            });
        });
    });

    $('#add_mark').on(A.options.clickEvent,function(e){
        if(calendar_calendar.opts.selectedDateString==null){
            A.alert('提示','请先选定日期');
            return;
        }
        $('#add_mark_button').off(A.options.clickEvent);
        $('#add_mark_button').on(A.options.clickEvent, function(){
            var name = $('#add_detail_modal_name').val();
            if(name == '' || name == null){
                A.alert('提示','请输入活动名称');
                return;
            }
            var position = $('#add_detail_modal_position').val();
            calendar_calendar.addMarkData(calendar_calendar.opts.selectedDateString,{
                name:name,
                position:position,
                startTime:$('#add_detail_modal_start_time').val(),
                endTime:$('#add_detail_modal_end_time').val()
            });
            calendar_calendar.refresh();
            updataData({
                date:calendar_calendar.opts.selectedDate,
                mark:{
                    data:calendar_calendar.getMarkAllData(calendar_calendar.opts.selectedDateString)
                }
            });

            A.Controller.modal('#add_detail_modal');
        });

        $('#add_detail_modal_form').find('input').val('');
        A.Controller.modal('#add_detail_modal');
    });

});
