/**
 * Created by Li Hongwei on 2016/1/19.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var utils = require('utils');

    //require('baidumap');

    var $bstdh_section = $('#bstdh_section');
    var geolocation;
    var condition = {
        bstdz:"",
        bstname:"",
        gsbz:"",
        xzqhszDm : "430100"
    };

    var doRefresh = function() {
        //condition.xzqhszDm = localStorage.getItem('xzqhszDm');
        A.showMask();
        rest.get({
            //url: '/ggfw/bstdh/getlist?xzqhszDm={xzqhszDm}&gsbz={gsbz}&bstdz={bstdz}&bstname={bstname}',
            url: '/ggfw/bstdh/ssjklist?xzqhszDm={xzqhszDm}&gsbz={gsbz}&bstdz={bstdz}&bstname={bstname}',
            urlParams:condition,
            isNeedToken : false,
            success: function(result) {
                if(result.code == '000') {
                    result.url = seajs.data.vars.baseurl;
                    if(result.dataList.length > 0) {
                        A.template('#bstlist_tmpl').renderReplace(result, function () {

                        });
                    }else {
                        A.template('#bstlist_tmpl').renderReplace();
                        A.showToast('未查询到相关信息');
                    }
                    A.hideMask();
                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 获得监控数据(已废弃)
     */
    var getSsjklist = function () {
        rest.get({
            url: '/ggfw/bstdh/ssjklist?xzqhszDm={xzqhszDm}&gsbz={gsbz}&bstdz={bstdz}&bstname={bstname}',
            urlParams:condition,
            isNeedToken : false,
            success: function(result) {
                if(result.code == '000') {
                    result.url = seajs.data.vars.baseurl;
                    //A.template('#bstlist_tmpl').renderReplace(result, function () {
                    //    A.hideMask();
                    //});
                    for(var i=0, j=result.dataList.length; i<j; i++) {
                        if(result.dataList[i].ssjk != undefined&& result.dataList[i].ssjk != null && result.dataList[i].ssjk != 'null'&& result.dataList[i].ssjk != '') {
                            var $li =  $('#bstdhlist').find('.sliver').eq(i);
                            $li.find('.dhrs').html(result.dataList[i].ssjk.ddrs);
                            $li.find('.zbrs').html(result.dataList[i].ssjk.zbrs);
                            $li.find('.ckkts').html(result.dataList[i].ssjk.ckkts);
                        }
                    }

                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };


    /**
     * 初始化地区下拉菜单(已废弃)
     */
    var initDqSel = function () {
        var data = {
            swjgDm : '14300000000',
            zgswj : 'Y'
        };
        rest.get({
            url: '/common/swjg?swjgDm={swjgDm}&zgswj={zgswj}',
            urlParams:data,
            isNeedToken : false,
            success: function(result) {
                A.template('#bstdh_sel_tmpl').renderReplace(result, function() {
                    A.hideMask();
                });
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 截取城市名
     * @param city
     */
    function strCity(city) {
        if(city.xzqhMc.indexOf('市') > -1) {
            city.xzqhMc = city.xzqhMc.split('市')[0];
        } else {
            city.xzqhMc = city.xzqhMc.substr(0, 2);
        }
    }


    function getCityList() {
        A.showMask();
        if(sessionStorage.getItem('citylist')) {
            var citylist = JSON.parse(sessionStorage.getItem('citylist'));
            //GPS(citylist);
            initDW();

        } else {
            var data = {
                xzqhszDm : 430000//查询市级单位
            };
            rest.get({
                url: '/common/xzqh?xzqhszDm={xzqhszDm}',
                urlParams:data,
                isNeedToken : false,
                success: function(result) {
                    if(result.code == '000') {
                        result.dataList.map(strCity);
                        sessionStorage.setItem('citylist', JSON.stringify(result.dataList));
                        //GPS(result.dataList)
                        initDW();

                    }
                }
            });
        }
    }

    function initDW() {
        var xzqhszDm = localStorage.getItem('xzqhDm');
        if(xzqhszDm) {
            condition.xzqhszDm = localStorage.getItem('xzqhDm');
            $bstdh_section.find('.location_city').text(localStorage.getItem('city'));
        } else {
            condition.xzqhszDm = "430100";
            $bstdh_section.find('.location_city').text('长沙');
        }
        doRefresh();
    }


    /**
     * 获取定位信息(已废弃)
     * @param citylist
     * @constructor
     */
    // function GPS(citylist) {
    //     var city = localStorage.getItem('city');
    //     if(utils.isFromIndex()) {
    //         var cityname;
    //         geolocation = new BMap.Geolocation();
    //         geolocation.getCurrentPosition(function(r) {
    //             if (this.getStatus() == BMAP_STATUS_SUCCESS) {
    //                 var myXY = r.point;
    //                 var myPoint = new BMap.Point(myXY.lng, myXY.lat);
    //                 var myCity = new BMap.LocalCity();
    //                 myCity.get(function(result) {
    //                     cityname = result.name.split('市')[0];
    //                     //var citylist = JSON.parse(sessionStorage.getItem('citylist'));
    //                     for(var i= 0,j=citylist.length; i<j; i++) {
    //                         if(result.name.indexOf(citylist[i].swjgmc) > -1) {
    //                             cityname = citylist[i].swjgmc;
    //                             localStorage.setItem('xzqhszDm', citylist[i].xzqhszDm);
    //                             $bstdh_section.find('.location_city').text(cityname);
    //                             doRefresh();
    //                             return;
    //                         }
    //                     }
    //                 });
    //             }
    //         });
    //     } else if(city) {
    //         $bstdh_section.find('.location_city').html(city);
    //         doRefresh();
    //     } else {//选择了地区，直接去请求数据排序
    //         $bstdh_section.find('.location_city').text('加载失败');
    //     }
    // }

    $bstdh_section.on('sectionshow', function(){
        //GPS();
        getCityList();

        //initDqSel();
        //getSsjklist();
    });

    var initSeach = function(_this) {
        if(condition.bstdz) {
            _this.find(".bstdz").val(condition.bstdz);
        }
        if(condition.bstname) {
            _this.find(".bstname").val(condition.bstname);
        }
        if(condition.gsbz) {
            _this.find('.gsbz option[value="' + condition.gsbz +'"]').attr('selected','selected');
        }
        //if(condition.xzqhszDm) {
        //    _this.find('.xzqhszDm option[value="' + condition.xzqhszDm +'"]').attr('selected','selected');
        //}

    };

    $('#bstdh_search').on(A.options.clickEvent, function(){
        var $popup = new A.Popup({
            html: $('#bstdh_search_modal').html(),
            pos : 'top'
        }).on('popupopen', function(){
                var _this = this.popup;
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                    condition.bstdz = _this.find(".bstdz").val();
                    condition.bstname = _this.find(".bstname").val();
                    condition.gsbz = _this.find(".gsbz option").not(function () {return !this.selected;}).val();
                    _this.find('.gsbz option[value="' + condition.gsbz +'"]').attr('selected','selected');
                    //condition.xzqhszDm = _this.find(".xzqhszDm option").not(function () {return !this.selected;}).val();
                    //_this.find('.xzqhszDm option[value="' + condition.xzqhszDm +'"]').attr('selected','selected');
                    condition.minNum = 1;
                    condition.maxNum = 10;
                    //$('#bstdh_search_modal').html(_this.html());
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
        return false;
    });
});

