/**
 * Created by Li Hongwei on 2016/1/23.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var yzm = '';
    // 重新开始查询时间
    var start = '';
    // 上次结束查询时间
    var end = '';

    var $nsrcy_section = $('#nsrcy_section');

    function close(_$this) {
        A.hideMask();
        _$this.prop("disabled", false);
    }

    function open(_$this) {
        A.showMask('查询中');
        _$this.prop("disabled", true);
    }

    var createCode = function() {
        rest.get({
            url: '/code/create',
            isNeedToken: false,
            success: function(result) {
                if (result.code == '000') {
                    yzm = A.Base64.decode(result.yzm);
                    $nsrcy_section.find('.verifyimg').attr('src', seajs.data.vars.baseurl + '/code/get/' + result.yzm);
                } else {
                    A.showToast('获取数据异常');
                    A.Controller.back();
                }
            },
            error: function() {
                A.showToast('获取数据失败');
                A.Controller.back();
            }
        });
    }

    /**
     * 发票查询
     */
    $nsrcy_section.find('.search_btn').on(A.options.clickEvent, function() {
        var nsrsbh = '';
        var nsrmc = '';
        var params = $nsrcy_section.find(".nsrsbh_nsrmc").val();
        if (/.*[\u4e00-\u9fa5]+.*$/.test(params)) {
            nsrmc = params;
        } else {
            nsrsbh = params;
        }
        var inputyzm = $nsrcy_section.find('#verifyCode').val().toLocaleLowerCase();
        if (inputyzm != yzm) {
            A.showToast('请输入正确的验证码!');
            createCode();
            return;
        }
        start = new Date().getTime();
        if (start && start - end <= 20 * 1000) {
            A.showToast('您查询的速度过快,请稍后查询!');
            // createCode();
            return;
        }
        var url = '/ggfw/nsrcy';
        if ($.trim(nsrsbh) == '' && $.trim(nsrmc) == '') {
            A.showToast('请输入查询条件');
        } else {
            if ($.trim(nsrsbh) != '' && $.trim(nsrmc) == '') {
                url = '/ggfw/nsrcy?nsrsbh=' + nsrsbh;
            }
            if ($.trim(nsrsbh) == '' && $.trim(nsrmc) != '') {
                url = '/ggfw/nsrcy?nsrmc=' + nsrmc;
            }
            if ($.trim(nsrsbh) != '' && $.trim(nsrmc) != '') {
                url = '/ggfw/nsrcy?nsrsbh=' + nsrsbh + '&nsrmc=' + nsrmc;
            }

            var _$this = $(this);
            open(_$this);
            rest.get({
                url: url,
                isNeedToken: false,
                success: function(result) {
                    createCode();
                    A.template("#nsrcy_tmpl_count").renderReplace(result);
                    if (result.code == '000' && result.count == 1) {
                        end = new Date().getTime();
                        A.Controller.section("service/nsrcy/nsrcy_info_section.html?nsrsbh=" + result.nsrcyList[0].nsrsbh);
                    } else {
                        A.template('#nsrcy_tmpl').renderReplace(result, function() {
                            A.hideMask();
                        });
                    }
                    close(_$this);
                },
                error: function() {
                    close(_$this);
                    return false;
                }
            });
        }
    });

    $nsrcy_section.find('.verifyimg').on(A.options.clickEvent, function() {
        createCode();
    });

    /**
     * 拍照扫描
     */
    $nsrcy_section.find('.pz_btn').on(A.options.clickEvent, function() {
        A.showToast('此功能暂未开放');
    });

    $nsrcy_section.on('sectionload', function() {
        createCode();
    });

    $nsrcy_section.on('sectionshow', function() {
        var params = A.Component.params(this);
    });
});
