define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var $nsrzgcx_section = $('#nsrzgcx_section');
    var yzmCode;

    var requestFlag = true;
    var requestInterval;

    var getImg = function(){
        rest.get({
            url : "/code/create",
            isNeedToken : false,
            success : function(data){
                if(!$.isEmptyObject(data) && data.code=="000") {
                    yzmCode = A.Base64.decode(data.yzm);
                    $("#nsrzg-yzm-img").attr("src", seajs.data.vars.baseurl+"/code/get/" + data.yzm);
                }else{
                    A.showToast(data.msg||"获取验证码失败!");
                }
            },
            error : function(err){
                A.showToast("获取验证码失败!");
            }
        });
    };

    $("#nsrzg-yzm-img").on(A.options.clickEvent,function(){
        getImg();
    });

    getImg();

    $nsrzgcx_section.find("button[name=search_btn]").on(A.options.clickEvent,function(){

        var fnChkZiXunSaveForm = function() {
            var strVal = $.trim($("#nsrzg-field").val());
            if (!strVal || strVal == "") {
                A.showToast("纳税人识别号/纳税人名称不能为空，请输入！");
                $("#nsrzg-field").focus();
                return false;
            }

            if(/.*[\u4e00-\u9fa5]+.*$/.test(strVal)) {
                if(strVal.length<=4){
                    A.showToast("纳税人名称长度至少为4位，请重新输入！");
                    $("#nsrzg-field").focus();
                    return false;
                }
                params.nsrmc = strVal;
                url = "/tjcx/ybnsrzg?nsrmc={nsrmc}";
            }else{
                params.nsrsbh = strVal;
                url = "/tjcx/ybnsrzg?nsrsbh={nsrsbh}";
            }

            strVal = $.trim($("#nsrzg-yzm").val());
            if (strVal == "") {
                A.showToast("验证码不能为空，请输入！");
                $("#nsrzg-yzm").focus();
                return false;
            }
            strVal = strVal.toLowerCase();
            if (strVal != yzmCode) {
                A.showToast("验证码输入错误，请重新输入！");
                $("#nsrzg-yzm").focus();
                getImg();
                return false;
            }
            return true;
        };

        var params = {},url;
        if(fnChkZiXunSaveForm()) {

            getImg();

            A.showMask();
            rest.get({
                url : url,
                isNeedToken : true,
                urlParams : params,
                beforeSend : function(){
                    if(requestFlag) {
                        requestFlag = false;
                        return true;
                    } else {
                        A.hideMask();
                        A.showToast("请求次数频繁,请稍等片刻！");
                        getImg();
                        return false;
                    }
                },
                success : function(data){
                    if(!$.isEmptyObject(data) && data.code=="000") {
                        $("#nsrzg-field").val("");
                        $("#nsrzg-yzm").val("");
                        A.template("#nsrzg_detail_tmpl").renderReplace(data, function () {});
                        A.Controller.modal("#nsrzgcx_info_section");
                    }else{
                        A.showToast(data.msg||"纳税人资格查询失败!");
                    }
                    if(!requestInterval) {
                        requestInterval = window.setInterval(function () {
                            requestFlag = true;
                        }, 20000);
                    }
                },
                error : function (err) {
                    A.showToast("纳税人资格查询失败!");
                },
                complete : function(){
                    A.hideMask();
                }
            });

        }

    });

    $('#nsrzgcx_section').on('sectionhide', function(){
        window.clearInterval(requestInterval);
        requestInterval = null;
    });

});