define(function(require,exports,module){

    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var yzmCode,url,params = {};

    var getImg = function(){
        rest.get({
            url : "/code/create",
            isNeedToken : false,
            success : function(data){
                if(!$.isEmptyObject(data) && data.code=="000") {
                    yzmCode = A.Base64.decode(data.yzm);
                    $("#nsxyaj-yzm-img").attr("src", seajs.data.vars.baseurl+"/code/get/" + data.yzm);
                }else{
                    A.showToast(data.msg||"获取验证码失败!");
                }
                $("#nsxyaj-yzm").val("");
            },
            error : function(err){
                A.showToast("获取验证码失败!");
            }
        });
    };

    var initPjnd = function(){

        var year = [];
        for(var i=new Date().getFullYear();i>new Date().getFullYear()-5;i--){
            year.push({key:i,text:i+"年"});
        }

        var pjndParam = {
            pjnd : year
        };
        A.template("#nsxyajnsrcx-pjnd-tmpl").renderReplace(pjndParam,function(){});
    };

    var fnChkZiXunSaveForm = function() {
        var strVal = $.trim($("#nsxyajnsrcx-field").val());
        if (!strVal || strVal == "") {
            A.showToast("请输入纳税人识别号/纳税人名称！");
            $("#nsrzg-field").focus();
            return false;
        }

        if(/.*[\u4e00-\u9fa5]+.*$/.test(strVal)) {
            if(strVal.length<=4){
                A.showToast("纳税人名称长度至少为5位，请重新输入！");
                $("#nsxyajnsrcx-field").focus();
                return false;
            }
            params.nsrmc = strVal;
            url = "/xyjbcx/ggcx?nsrmc={nsrmc}";
        }else{
            params.nsrsbh = strVal;
            url = "/xyjbcx/ggcx?nsrsbh={nsrsbh}";
        }

        strVal = $("#nsxyajnsrcx-pjnd").val();
        if(!strVal){
            A.showToast("请选择评价年度！");
            $("#nsrzg-field").focus();
            return false;
        }

        strVal = $.trim($("#nsxyaj-yzm").val());
        if (strVal == "") {
            A.showToast("请输入验证码！");
            $("#nsxyaj-yzm").focus();
            return false;
        }
        strVal = strVal.toLowerCase();
        if (strVal != yzmCode) {
            A.showToast("验证码输入错误，请重新输入！");
            $("#nsxyaj-yzm").focus();
            getImg();
            return false;
        }
        return true;
    };

    $("#nsxyaj-yzm-img").on(A.options.clickEvent,function(){
        getImg();
    });

    $("#nsxyajnsrcx_search button[name='search_btn']").on(A.options.clickEvent,function(){
        if(fnChkZiXunSaveForm()){
            getImg();

            var pjnd = $("#nsxyajnsrcx-pjnd").val();
            A.showMask();
            rest.get({
                url : url+"&pjnd="+pjnd,
                isNeedToken : true,
                urlParams : params,
                success : function(data){
                    if(data.code == '000') {
                        if(data.dataList && data.dataList.length > 0) {
                            A.template("#nsxyajnsrcx_list_tmpl").renderReplace(data, function () {
                                A.Controller.modal("#nsxyajnsrcx_modal");
                            });
                        }else{
                            A.showToast("未查询到纳税信用A级记录");
                        }
                    }else{
                        A.showToast(data.msg);
                    }
                },
                error : function (err) {
                    A.showToast("纳税信用A级纳税人查询失败!");
                },
                complete : function(){
                    A.hideMask();
                }
            });
        }
    });

    $('#nsxyajnsrcx_section').on('sectionshow', function(){
        getImg();
        initPjnd();
    });

});