/**
 * Created by Li Hongwei on 2015-12-08.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var Frozen = require("frozen");

    var A = require('agile');
    var rest = require('rest');

    var $rdwd_section = $('#rdwd_section');
    var count = 0;

    /**
     * 静态页面数据（已废弃）
     * @type {{rdwdList: *[]}}
     */
    var dataList = {
        "rdwdList": [
            { "title": "我单位是实行“三证合一、一照一码”登记的纳税人，现“财务负责人”发生变更，应向哪个机关申报办理？", "id": "1" },
            { "title": "“企业境外所得适用简易征收和饶让抵免的核准”审批事项取消后，相关事项如何处理？", "id": "2" },
            { "title": "保险企业因执行财政部企业会计规定计提的准备金与之前执行中国保险业监督委员管理会有关监管规定计提的准备金形成的差额，如何处理？", "id": "3" },
            { "title": "我单位与某公司签订一项计算机软件著作权非独占许可使用权转让合同，是否可以享受技术转让所得企业所得税优惠？", "id": "4" },
            { "title": "有限合伙制创业投资企业的法人合伙人采取股权投资方式投资于未上市的中小高新技术企业，是否可以享受抵扣应纳税所得额的优惠政策？", "id": "5" },
            { "title": "1.6升及以下排量乘用车车辆购置税减按5%的税率征收车辆购置税，其中“乘用车”需满足哪些条件？", "id": "6" },
            { "title": "我单位是一家煤炭采掘企业，购进巷道照明通风设备取得增值税专用发票，其进项税额是否可以从销项税额中抵扣？", "id": "7" },
            { "title": "我单位向境外单位提供软件服务，是否适用增值税零税率政策？", "id": "8" },
            { "title": "蔬菜清洗机增值税适用税率是多少？", "id": "9" },
            { "title": "我省农产品增值税进项税额核定扣除试点范围新增哪些行业？", "id": "10" },
            { "title": "纳税人具备什么样的情形，不影响其纳税信用评价？", "id": "11" }
        ]
    };

    /**
     * 加载静态页面（已废弃）
     */
    //$rdwd_section.on('sectionload', function(){
    //var params = A.Component.params(this);
    //var result = dataList[type];
    //     A.showMask();
    //     A.template('#rdwd_tmpl').renderReplace(dataList, function() {
    //         A.hideMask();
    //     });
    // });

    /**
     * 常见问题
     */
    var initCjwt = function() {
        var condition = {
            questionStatus:2,//问题状态	2已答复0未答复
            questionCommon: 1,//问题类型	1常见问题2普通问题
            zt : 2,	//状态	1草稿2发布web段默认查询发布状态
            // rqq	//日期起
            // rqz	//日期止
            minNum:1,	//最小序号	分页查询最小序号。可选，分页查询时必录
            maxNum:4	//最大序号	分页查询最大序号。可选，分页查询时必录
        };
        rest.get({
            url: '/ggfw/rdwd/getlist?questionStatus={questionStatus}&questionCommon={questionCommon}&zt={zt}&minNum={minNum}&maxNum={maxNum}',
            urlParams : condition,
            isNeedToken: false,
            success: function(result) {
                if (result.code == '000') {
                    var datalist = result.dataList;
                    if (datalist.length > 0) {
                        A.template('#rdwd_cjwt_tmpl').renderReplace(result, function() {
                        });
                    }
                }
            }
        });
    };


    var condition = {
       // title	//标题	模糊查询
        questionStatus:'',//问题状态	2已答复0未答复
        questionCommon: '',//问题类型	1常见问题2普通问题
        zt : 2,	//状态	1草稿2发布web段默认查询发布状态
       // rqq	//日期起
       // rqz	//日期止
        minNum:1,	//最小序号	分页查询最小序号。可选，分页查询时必录
        maxNum:10	//最大序号	分页查询最大序号。可选，分页查询时必录
    };

    $rdwd_section.on('sectionshow', function() {
        A.showMask();
        rest.get({
            url: '/ggfw/rdwd/getlist?questionStatus={questionStatus}&questionCommon={questionCommon}&zt={zt}&minNum={minNum}&maxNum={maxNum}',
            urlParams : condition,
            isNeedToken: false,
            success: function(result) {
                if (result.code == '000') {
                    var datalist = result.dataList;
                    if (datalist.length > 0) {
                        A.template('#rdwd_tmpl').renderReplace(result, function() {
                            A.hideMask();
                        });
                    } else {
                         A.hideMask();
                        A.showToast('暂无数据');
                    }
                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('链接失败');
            }
        });



    });






});