/**
 * Created by Li Hongwei on 2015-12-08.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var count = 0;

    var $rdwd_search_section = $('#rdwd_search_section');

    $rdwd_search_section.on('sectionload', function () {
        $rdwd_search_section.find('.ui-searchbar').on(A.options.clickEvent, function(){
            $rdwd_search_section.find('.ui-searchbar-wrap').addClass('focus');
            $rdwd_search_section.find('.ui-searchbar-input input').focus();
        });
        $rdwd_search_section.find('.ui-icon-close').on(A.options.clickEvent, function(){
            $rdwd_search_section.find('.ui-searchbar-wrap').removeClass('focus');
            return false;
        });
    });

    $rdwd_search_section.on('sectionshow', function () {
        $rdwd_search_section.find('.ui-searchbar-wrap').addClass('focus');
        $rdwd_search_section.find('.ui-searchbar-input input').focus();
    });

    /**
     * 查询条件
     * @type {{title: string, questionStatus: number, questionCommon: string, zt: number, minNum: number, maxNum: number}}
     */
    var condition = {
        title:'',	//标题	模糊查询
        questionStatus:'',//问题状态	2已答复0未答复
        questionCommon: '',//问题类型	1常见问题2普通问题
        zt : 2,	//状态	1草稿2发布web段默认查询发布状态
        minNum:1,	//最小序号	分页查询最小序号。可选，分页查询时必录
        maxNum:10	//最大序号	分页查询最大序号。可选，分页查询时必录
    };

    /**
     * 查询热点问题
     * @param title 标题(模糊查询)
     * @param questionCommon 问题状态(2已答复0未答复)
     */
    var doRefresh = function() {
        A.showMask();
        rest.get({
            url: '/ggfw/rdwd/getlist?title={title}&questionStatus={questionStatus}&questionCommon={questionCommon}&zt={zt}&minNum={minNum}&maxNum={maxNum}',
            urlParams : condition,
            isNeedToken: false,
            success: function(result) {
                A.hideMask();
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#rdwd_list_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            setTimeout(function() {
                                A.Scroll('#rdwd_search_article').refresh();
                            },1);
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.dataList.length +'条记录');
                            }
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#rdwd_list_tmpl').renderReplace();
                            A.showToast('未查询到相关问答');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    $rdwd_search_section.find('.ui-btn').on(A.options.clickEvent, function () {
        var title = $rdwd_search_section.find('.ui-searchbar-input input').val();
        condition.title = title;
        doRefresh();
    });
});