/**
 * Created by Li Hongwei on 2015-12-08.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var $sszx_section = $('#sszx_section');

    /**
     * 表单校验
     * @returns {boolean}
     */
    var fnChkZiXunSaveForm = function() {
        var strVal = $.trim($("#sszx_form input[name='txtName']").val());
        if (strVal == "") {
            A.showToast("姓名不能为空，请输入！");
            return false;
        }

        strVal = $.trim($("#sszx_form input[name='txtTel']").val());
        if (strVal == "") {
            A.showToast("联系电话不能为空，请输入！");
            return false;
        }
        strVal = $.trim($("#sszx_form input[name='txtEmail']").val());
        if (strVal != "" && (!fnChkData(9, strVal))) {
            A.showToast("电子邮箱地址格式不正确 ，请输入！");
            return false;
        }

        strVal = $.trim($("#sszx_form input[name='txtPwd']").val());
        if (strVal == "") {
            A.showToast("查询密码不能为空，请输入！");
            return false;
        }
        if (!fnChkData(11, strVal)) {
            A.showToast("查询密码由5-20个字符组成，请重新输入！");
            return false;
        }
        strVal = $.trim($("#sszx_form select[name='selType']").val());
        if (strVal == "") {
            A.showToast("请选择问题所属类别！");
            return false;
        }
        strVal = $.trim($("#sszx_form input[name='txtSubject']").val());
        if (strVal == "") {
            A.showToast("标题不能为空，请输入！");
            return false;
        }
        strVal = $.trim($("#sszx_form input[name='txtContent']").val());
        if (strVal == "") {
            A.showToast("详细内容不能为空，请输入！");
            return false;
        }
        if (strVal.length > 4000) {
            A.showToast("正文最多允许4000个字符，请重新输入！");
            return false;
        }
        strVal = $.trim($("#sszx_form input[name='txtChkCode']").val());
        if (strVal == "") {
            A.showToast("验证码不能为空，请输入！");
            return false;
        }
        return true;
    };

    /**
     * 表单提交
     */
    var submitFrom = function() {
        if(fnChkZiXunSaveForm()) {
            $sszx_section.find('.formSave').submit();
        }
    };



    $sszx_section.on('sectionshow', function(){
        var params = A.Component.params(this);

        /**
         * 协议勾选
         */
        $sszx_section.find('input[type="checkbox"]').off(A.options.clickEvent);
        $sszx_section.find('input[type="checkbox"]').on(A.options.clickEvent, function (e) {
            if ($sszx_section.find('input[type="checkbox"]').prop("checked")==true) {
                $sszx_section.find('.search_btn').on(A.options.clickEvent,submitFrom);
                $sszx_section.find('.search_btn').removeClass('disable').prop("disabled",false);
            } else {
                $sszx_section.find('.search_btn').off(A.options.clickEvent);
                $sszx_section.find('.search_btn').addClass('disable').prop("disabled",true);
            }
        });
    });



    /**
     * 验证码刷新
     */
    $sszx_section.find('.btn-valimg, .valimg').on(A.options.clickEvent, function () {
        var id = new Date().valueOf();
        $sszx_section.find('.valimg').attr('src', 'http://www.hntax.gov.cn/inc/validate_code.jsp?id=' + id)
    });

    function fnChkData(format, value) {
        var regObj = null;
        switch (format) {
            case 1:
                regObj = /^\d{4}$/gi;
                if (regObj.test(value)) {
                    var iYear = parseInt(value);
                    if (iYear >= 2030 || iYear <= 1900) {
                        return false;
                    }
                    return true;
                } else {
                    return false;
                }
                break;
            case 2:
                regObj = /^(0[1-9]|1[0-2])$/gi;
                break;
            case 3:
                regObj = /^(0[1-9]|1[0-9]|2[0-9]|3[0-1])$/gi;
                break;
            case 4:
                regObj = /^[1-9][0-9]*$/gi;
                break;
            case 5:
                regObj = /^([1-9][0-9]*|0)$/gi;
                break;
            case 6:
                regObj = /^\d+.?\d+$/gi;
                break;
            case 7:
                regObj = /^\d{4}-(0[1-9]|1[0-2])-(0[1-9]|1[0-9]|2[0-9]|3[0-1])$/gi;
                break;
            case 8:
                regObj = /^\d{4}-(0[1-9]|1[0-2])-(0[1-9]|1[0-9]|2[0-9]|3[0-1])\s+(0[0-9]|[1-5][0-9]):(0[0-9]|[1-5][0-9])$/gi;
                break;
            case 9:
                regObj = /^.+@.+$/gi;
                break;
            case 10:
                regObj = /^[A-Za-z][A-Za-z0-9_]{4,17}$/gi;
                break;
            case 11:
                regObj = /^.{5,20}$/gi;
                break;
        }
        if (regObj != null) {
            return regObj.test(value);
        }
        return false;
    }



});