/**
 * Created by Li Hongwei on 2015-12-08.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var Utils = require('utils');

    var count;//总页数

    /**
     * 条件
     * @type {{minNum: number, maxNum: number}}
     */
    var condition = {
        //affichefbr	发布人
        //affichetitle	标题
        //affichetype	状态
        afficheZt : 2, //状态	1草稿2发布
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 清空条件
     */
    var resetCondition = function() {
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        rest.get({
            url: '/ggfw/tzgg/list?afficheZt={afficheZt}&minNum={minNum}&maxNum={maxNum}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        var dataList = result.afficheInfoList;
                        for (var i = 0; i < dataList.length; i++) {
                            dataList[i].flag = Utils.compareToDate(dataList[i].afficheFbrq, 30);
                        }
                        A.template("#tzgg_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            //var refresh = A.Refresh('#tzgg_article');
                            //refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.afficheInfoList.length +'条记录');
                            }
                            nextPage();

                            $("#tzgg_article li[name='tzgg-list-item']").off(A.options.clickEvent);
                            $("#tzgg_article li[name='tzgg-list-item']").on(A.options.clickEvent,function(){
                                A.Controller.section("service/tzgg/tzgg_info_section.html?afficheId="+$(this).data("afficheid"));
                            });
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#tzgg_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    /**
     * 加载主页
     */
    $('#tzgg_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        A.showMask();
        doRefresh();
    });

    /**
     * 滑动事件
     */
    $('#tzgg_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

});