define(function(require,exports,module){

    var $ = require("zepto");
    var A = require("agile");
    var rest = require("rest");
    var yzmCode;

    var getImg = function(){
        A.showMask();
        rest.get({
            url : "/code/create",
            isNeedToken : false,
            success : function(data){
                if(!$.isEmptyObject(data) && data.code=="000") {
                    yzmCode = A.Base64.decode(data.yzm);
                    $("#wgzcy-yzm-img").attr("src", seajs.data.vars.baseurl+"/code/get/" + data.yzm);
                }else{
                    A.showToast(data.msg||"获取验证码失败!");
                }
            },
            error : function(err){
                A.showToast("获取验证码失败!");
            },
            complete : function(){
                A.hideMask();
            }
        });
    };

    var clearInp = function(){
        $("#input_nsrsbh").val("");
        $("#input_wcjyzmdh").val("");
        $("#wgzcy-yzm").val("");
    }

    $("#wgzcy_section").on("sectionshow",function(){
        getImg();
    })

    $("#wgzcy_section").on("sectionhide",function(){
        clearInp();
    })

    $("#wgzcy_article button[name='search_btn']").on(A.options.clickEvent,function(){


        var nsrsbh = $("#input_nsrsbh").val();
        var jg = $("#input_jg").val();
        var zg = $("#input_zg").val();
        var ng = $("#input_ng").val();
        var zh = $("#input_zh").val();

        if(!$.trim(nsrsbh)){
            A.showToast('请输入纳税人识别号！');
            return;
        }
        if(!$.trim(jg)){
            A.showToast('请输入局轨！');
            return;
        }
		if(!$.trim(zg)){
            A.showToast('请输入字轨！');
            return;
        }
        if(!$.trim(ng)){
            A.showToast('请输入年号！');
            return;
        }
        if(!$.trim(zh)){
            A.showToast('请输入序号！');
            return;
        }
        if(!$.trim($("#wgzcy-yzm").val())){
            A.showToast('请输入验证码！');
            return;
        }
        if($.trim($("#wgzcy-yzm").val()).toUpperCase()!=yzmCode.toUpperCase()){
            getImg();
            $("#wgzcy-yzm").val("");
            A.showToast('验证码输入错误！');
            return;
        }

        A.showMask();
        rest.get({
            url : "/zm/wcjy/cywcjyzm?nsrsbh={nsrsbh}&swjgjg={swjgjg}&zg={zg}&nh={nh}&wh={wh}",
            urlParams : {
                nsrsbh : nsrsbh,
                swjgjg: jg,
			    zg: zg,
				nh: ng,
				wh: zh
            },
            success : function(data){
                if(!$.isEmptyObject(data)){
                    if(data.code=="000"){
                        if(data.dataList.length>0){
                            A.template("#wgzcy_detail_tmpl").renderReplace(data.dataList[0],function(){
                                A.Controller.modal("#wgzcy_info_modal");

                                $("#btn_open_detail").on(A.options.clickEvent,function(){
                                    $("#service-details-block").toggle();
                                });

                                $("#btn_open_product_detail").on(A.options.clickEvent,function(){
                                    $("#product-details-block").toggle();
                                });
                            });
                        }else{
                            A.showToast('未查询到外管证信息！');
                        }
                    }else{
                        A.showToast(data.msg);
                    }
                }else{
                    A.showToast('查询外管证失败！');
                }
            },
            error : function(){
                A.showToast('查询外管证失败！');
            },
            complete : function(){
                getImg();
                A.hideMask();
            }
        });
    });

    $("#wgzcy-yzm-img").on(A.options.clickEvent,function(){
        getImg();
    });

});
