define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var jQuery = require('jquery');
    //require('validator');

    var count = 0;

    var $query_yybs_form_valid;

    var $yybs_query_section = $('#yybs_query_section');

    var datalist;

    var initFormValid = function () {
        $query_yybs_form_valid = jQuery('#yybs_query_section').find('#yybs_query_form').validator({
            theme: 'yellow_bottom',
            ignore: ':hidden',
            stopOnError: true,
            fields: {
                "kd.sjhm": {
                    rule: "required;mobile;",
                    msg: {required: "请填写手机号码"}
                }
            }
        });
    };

    // var resultList = {
    //     "resultList": [
    //         { "yyxh": "12345234589","taxDhId": "3", "bstname": "长沙市芙蓉区国家税务局", "bstdz": "长沙市芙蓉区晚报大道115号", "jd": "28.186015", "wd": "112.986548", "gsbz": "Y", "phone": "0731-84185602", "img": null, "swjgDm": "14301020000", "xzqhszDm": "430102", "swjgMc": "长沙市芙蓉区国家税务局", "xzqhMc": "芙蓉区", "yyrq": "2016-04-13","yysd":"10:00-11:00", "zbrs": "15人", "dhsc": "0.5小时", "cxsj": "2016-04-12 17:20:10" },
    //         { "yyxh": "12345234890","taxDhId": "4","bstname": "长沙市芙蓉区地方税务局办税服务厅", "bstdz": "长沙市芙蓉区荷花路15号", "jd": "28.198017", "wd": "113.0285028", "gsbz": "N", "phone": "0731-82996502", "img": null, "swjgDm": null, "xzqhszDm": "430102", "swjgMc": null, "xzqhMc": "芙蓉区", "yyrq": "2016-04-13","yysd":"10:00-11:30", "zbrs": "15人", "dhsc": "0.5小时", "cxsj": "2016-04-12 17:20:10" },
    //         { "yyxh": "12345234566","taxDhId": "5", "bstname": "长沙市天心区国家税务局", "bstdz": "长沙市天心区裕南街向东南路206号", "jd": "28.178071", "wd": "112.982442", "gsbz": "Y", "phone": "0731-85131263", "img": null, "swjgDm": "14301030000", "xzqhszDm": "430103", "swjgMc": "长沙市天心区国家税务局", "xzqhMc": "天心区", "yyrq": "2016-04-15","yysd":"10:00-11:00", "zbrs": "15人", "dhsc": "0.5小时", "cxsj": "2016-04-12 17:20:10" },
    //         { "yyxh": "12345236788","taxDhId": "6", "bstname": "长沙市天心区地方税务局办税服务厅", "bstdz": "长沙市天心区轻院路118号", "jd": "28.186015", "wd": "112.986548", "gsbz": "N", "phone": "0731-88629024", "img": null, "swjgDm": "14301040000", "xzqhszDm": "430104", "swjgMc": "长沙市岳麓区国家税务局", "xzqhMc": "岳麓区", "yyrq": "2016-04-13","yysd":"11:00-12:00",  "zbrs": "15人", "dhsc": "0.5小时", "cxsj": "2016-04-12 17:20:10" }
    //
    //     ]
    // };

    $yybs_query_section.on('sectionload', function () {

        $yybs_query_section.find('.ui-searchbar').on(A.options.clickEvent, function () {
            $yybs_query_section.find('.ui-searchbar-wrap').addClass('focus');
            $yybs_query_section.find('.ui-searchbar-input input').focus();
        });
        $yybs_query_section.find('.ui-icon-close').on(A.options.clickEvent, function () {
            $yybs_query_section.find('.ui-searchbar-wrap').removeClass('focus');
            return false;
        });
    });

    $yybs_query_section.on('sectionshow', function () {
        $yybs_query_section.find('.ui-searchbar-wrap').addClass('focus');
        $yybs_query_section.find('.ui-searchbar-input input').focus();
        initFormValid();


        $yybs_query_section.find('.yybsquery').on(A.options.clickEvent, function () {

            queryYY();


        });

        function queryYY() {
            if ($query_yybs_form_valid.isValid()) {
                var sjhm = $yybs_query_section.find('.inputsjh').val();

                var condition = {
                    sjh: sjhm
                };
                A.showMask();
                rest.get({
                    url: '/ggfw/yybs/yyjl/{sjh}',
                    urlParams: condition,
                    isNeedToken: false,
                    success: function (result) {


                        if (result.code == '000') {
                            //渲染
                            datalist = result.dataList;

                            for (var i = 0; i < datalist.length; i++) {
                                datalist[i].index = i;
                            }

                            A.hideMask();
                            A.showToast(result.msg);
                            A.template('#yybs_query_tmpl').renderReplace(result, function () {

                                $yybs_query_section.find('.btn_cancel_yy').on(A.options.clickEvent, function () {
                                    var index = $(this).data('index');
                                    var yyxlh = datalist[index].yyxlh;//$(this).data('yyxlh');
                                    var dtDm = datalist[index].dtDm;// $(this).data('dtdm');
 
                                    A.confirm('提示', '您确定要取消' + yyxlh + '号预约吗?',
                                        function () {
                                            // A.showToast('你选择了“确定”');

                                            var condition = {
                                                yyxlh: yyxlh,
                                                dtDm: dtDm
                                            };
                                            A.showMask();
                                            rest.get({
                                                url: '/ggfw/yybs/qxyy?yyxlh={yyxlh}&dtDm={dtDm}',
                                                urlParams: condition,
                                                isNeedToken: false,
                                                success: function (result) {

                                                    var result = result;
                                                    if (result.code == '000') {
                                                        //渲染
                                                        var result = result;
                                                        A.hideMask();
                                                        A.showToast(result.msg);
                                                        queryYY();

                                                    } else {
                                                        A.hideMask();
                                                        A.showToast(result.msg);
                                                    }
                                                },
                                                error: function () {
                                                    A.hideMask();
                                                    A.showToast('获取数据失败');
                                                }
                                            });

                                            return false;/////

                                        },
                                        function () {
                                            //A.alarmToast('你选择了“取消”');
                                        });
                                    return false;
                                });
                            });


                        } else {
                            A.hideMask();
                            A.showToast(result.msg);
                        }
                    },
                    error: function () {
                        A.hideMask();
                        A.showToast('获取数据失败');
                    }
                });

                return false;
            }
        }
    });


});