define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var $yybs_query_section = $('#yybs_query_detail_section');

    var qresult = {};

    // var resultList = {
    //     "resultList": [
    //         {
    //             "yyxh": "12345234589",
    //             "bstname": "长沙市芙蓉区国家税务局",
    //             "bstdz": "长沙市芙蓉区晚报大道115号",
    //             "jd": "28.186015",
    //             "wd": "112.986548",
    //             "gsbz": "Y",
    //             "phone": "0731-84185602",
    //             "img": null,
    //             "swjgDm": "14301020000",
    //             "xzqhszDm": "430102",
    //             "swjgMc": "长沙市芙蓉区国家税务局",
    //             "xzqhMc": "芙蓉区",
    //             "yyrq": "2016-04-13",
    //             "yysd": "10:00-11:00",
    //             "zbrs": "15人",
    //             "dhsc": "0.5小时",
    //             "cxsj": "2016-04-12 17:20:10"
    //         }
    //
    //     ]
    // };

    $yybs_query_section.on('sectionload', function () {


        $yybs_query_section.find('.ui-searchbar').on(A.options.clickEvent, function () {
            $yybs_query_section.find('.ui-searchbar-wrap').addClass('focus');
            $yybs_query_section.find('.ui-searchbar-input input').focus();
        });
        $yybs_query_section.find('.ui-icon-close').on(A.options.clickEvent, function () {
            $yybs_query_section.find('.ui-searchbar-wrap').removeClass('focus');
            return false;
        });
    });

    $yybs_query_section.on('sectionshow', function () {

        var params = A.Component.params(this);
        qresult.dtDm = params.dtDm;
        qresult.dtMc = params.dtMc;
        qresult.yysj = params.yysj;
        qresult.yyblyw = params.yyblyw;

        $yybs_query_section.find('.ui-searchbar-wrap').addClass('focus');
        $yybs_query_section.find('.ui-searchbar-input input').focus();

        // $yybs_query_section.find('.query_detail_result').hide();
        $yybs_query_section.find('.detailpanel').hide();

    });


    $yybs_query_section.find('#query').on(A.options.clickEvent, function () {


        var cxh = $yybs_query_section.find('.querykey').val();

        if (cxh == '') {
            A.showToast('请输入要查询的排队号');
        } else {
            qresult.pdh = cxh;
            var condition = {
                yyxlh: cxh,
                dtDm: qresult.dtDm
            };
            A.showMask();
            rest.get({
                url: '/ggfw/yybs/getyybyph?yyxlh={yyxlh}&dtDm={dtDm}',
                urlParams: condition,
                isNeedToken: false,
                success: function (result) {

                   // result = {"msg": "调用失败，失败原因:无数据信息", "code": "000", "ddrs": "9"};
                    var result = result;
                    A.hideMask();

                    if (result.code == '000') {
                        //渲染
                        var result = result;
                        A.hideMask();
                        qresult.ddrs = result.ddrs;


                        // $yybs_query_section.find('.pdrs').text(result.ddrs+'人');
                        // $yybs_query_section.find('.query_detail_result').show();
                        $yybs_query_section.find('.detailpanel').show();

                        A.template('#yybs_query_detail_tmpl').renderReplace(qresult, function () {

                        });
                    } else {
                        A.hideMask();
                        A.showToast(result.msg);
                    }
                },
                error: function () {
                    A.hideMask();
                    A.showToast('获取数据失败');
                }
            });


        }

        return false;
    });


});