/**
 * Created by Li Hongwei on 2015-12-08.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var $zcfg_list_section = $('#zcfg_list_section');

    var dataList = {
        "1": {
            "header": "政策法规",
            "zcfgList": [{
                "title": "关于明确有机肥产品执行标准的公告 <span>公告[2015]86号</span>",
                "id": "l-5"
            }, {
                "title": "关于推行通过增值税电子发票系统开具的增值税电子普通发票有关问题的公告 <span>公告[2015]84号</span>",
                "id": "l-6"
            }, {
                "title": "关于公布符合条件的销售熊猫普制金币纳税人名单（第五批）的公告 <span>公告[2015]78号</span>",
                "id": "l-7"
            }, {
                "title": "关于发布增值税发票系统升级版与税控收款机数据接口规范的公告 <span>公告[2015]77号</span>",
                "id": "l-8"
            }, {
                "title": "关于“三证合一”登记制度改革涉及增值税一般纳税人管理有关事项的公告 <span>公告[2015]74号</span>",
                "id": "l-9"
            }, {
                "title": "关于煤炭采掘企业增值税进项税额抵扣有关事项的通知 <span>财税[2015]117号</span>",
                "id": "l-10"
            }, {
                "title": "关于动物尸体降解处理机 蔬菜清洗机增值税适用税率问题的公告 <span>公告[2015]72号</span>",
                "id": "l-1"
            }, {
                "title": "关于印发《增值税税控系统服务单位监督管理办法》的通知 <span>公告[2015]72号</span>",
                "id": "l-2"
            }, {
                "title": "关于化肥恢复征收增值税后库存化肥有关税收管理事项的公告 <span>公告[2015]72号</span>",
                "id": "l-3"
            }, {
                "title": "关于调整2015年进口种子种源免税政策执行方式有关问题的通知 <span>公告[2015]72号</span>",
                "id": "l-4"
            }]
        },
        "2": {
            "header": "政策解读",
            "zcfgList": [{
                "title": "关于《国家税务总局关于公布税务行政许可审批事项目录的公告》的解读",
                "id": "i-5"
            }, {
                "title": "关于《国家税务总局关于明确纳税信用管理若干业务口径的公告》的解读",
                "id": "i-6"
            }, {
                "title": "关于《国家税务总局关于明确有机肥产品执行标准的公告》的解读",
                "id": "i-7"
            }, {
                "title": "关于《国家税务总局关于公开税务行政许可审批事项目录的公告》的解读",
                "id": "i-8"
            }, {
                "title": "关于《国家税务总局关于技术转让所得企业所得税有关问题的公告》的解读",
                "id": "i-9"
            }, {
                "title": "关于《车船税管理规程（试行）》公告的解读",
                "id": "i-10"
            }, {
                "title": "关于《国家税务总局关于动物尸体降解处理机 蔬菜清洗机增值税适用税率问题的公告》的解读 ",
                "id": "i-1"
            }, {
                "title": "关于《国家税务总局关于企业境外所得适用简易征收和饶让抵免的核准事项取消后有关管理问题的公告》的解读",
                "id": "i-2"
            }, {
                "title": "关于《国家税务总局关于中小企业信用担保机构免征营业税审批事项取消后有关问题的公告》的政策解读",
                "id": "i-3"
            }, {
                "title": "关于《国家税务总局关于契税纳税申报有关问题的公告》的解读",
                "id": "i-4"
            }]
        }
    };

    // $zcfg_list_section.on('sectionshow', function () {
    //     var params = A.Component.params(this);
    //     var type = params.type;
    //     $zcfg_list_section.find('.title').html(dataList[type].header);
    //     var result = dataList[type];
    //     A.showMask();
    //     A.template('#zcfg_list_tmpl').renderReplace(result, function () {
    //         A.hideMask();
    //     });
    // });

    $zcfg_list_section.on('sectionshow', function () {

        var params = A.Component.params(this);
        $zcfg_list_section.find('.title').html(params.zcfgmc);
        var zcfgDm = params.zcfgDm;
        A.showMask();
        rest.get({
            url: '/ggfw/zcfg/weblist',
            success: function (result) {
                if (result.code == '000') {
                    var datamap = result.dataMap[zcfgDm];

                    var jsonList = {
                        "data": datamap
                    };
                    A.template("#zcfg_list_tmpl").renderReplace(jsonList, function () {

                    });
                    if (datamap.length == 0) {
                        A.showToast('暂无数据');
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function () {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    });


});