/**
 * Created by Li Hongwei on 2016-03-10.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var jQuery = require('jquery');

    var selectedAddr;
    var lyfsParam = {
        fply: {}
    };
    var fply = { defaultAddr: {} };
    var reqUrl, reqData;
    var firstLoad = true;

    var initFormValid = function() {

        var validStr = $("#add_fply_form").find("select[name='fply.fpzlDm']").val();
        if (!validStr) {
            A.showToast("请选择发票种类!");
            return false;
        }

        validStr = $("#add_fply_form").find("input[name='fply.fs']").val()
        if (!validStr) {
            A.showToast("请输入发票份数!");
            return false;
        }
        if (!/^\d+$/.test(validStr)) {
            A.showToast("发票份数格式不合法!");
            return false;
        }
        if (validStr.substr(0, 1) == '0') {
            A.showToast('领用份数不能以0开头');
            return;
        }
        if (!$.trim($("#zggpsl").html()) || !/^\d+$/.test($.trim($("#zggpsl").html()))) {
            A.showToast('请选择发票种类!');
            return;
        }
        if (validStr < 0 || parseInt(validStr) > parseInt($.trim($("#zggpsl").html()))) {
            A.showToast("发票份数超过可领范围!");
            return false;
        }

        var formType = $fply_add_section.find("#fply_add_lqfs option:selected").data("formtype");

        if (formType == "express") { //快递寄送
            validStr = $("#add_fply_form").find("#fply_panel_express  input[name='fply.gprxm']").val();
            if (!validStr) {
                A.showToast("请选择快递信息!");
                return false;
            }
            if (!/^[\u0391-\uFFE5]{2,8}$|^([A-Za-z]{1,10}\s?){1,3}$/.test(validStr)) {
                A.showToast("请输入2到8位中文，或英文名的收件人姓名!");
                return false;
            }

            validStr = $("#add_fply_form").find("#fply_panel_express  input[name='fply.gprlxdh']").val();
            if (!validStr) {
                A.showToast("请选择快递信息!");
                return false;
            }
            if (!/^1[3-9]\d{9}$/.test(validStr)) {
                A.showToast("手机号码格式不合法!");
                return false;
            }

            validStr = $("#add_fply_form").find("#fply_panel_express  input[name='fply.gprsfzjhm']").val();
            if (!validStr) {
                A.showToast("请选择快递信息!");
                return false;
            }
            if (!/^\d{6}(19|2\d)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)?$/.test(validStr)) {
                A.showToast("身份证号码不合法!");
                return false;
            }

            validStr = $("#add_fply_form").find("#fply_panel_express span[name='fply.gprdz']").html();
            if (!validStr) {
                A.showToast("请选择快递信息!");
                return false;
            }
            if (validStr.length > 55) {
                A.showToast("收货地址请勿超过55个字符!");
                return false;
            }
        }
        // else {
        //     validStr = $("#add_fply_form").find("#fply_panel_self  input[name='fply.gprxm']").val();
        //     if (!validStr) {
        //         A.showToast("请输入签收人姓名!");
        //         return false;
        //     }
        //     if (!/^[\u0391-\uFFE5]{2,8}$|^([A-Za-z]{1,10}\s?){1,3}$/.test(validStr)) {
        //         A.showToast("请输入2到8位中文，或英文名的签收人姓名!");
        //         return false;
        //     }
        //
        //     validStr = $("#add_fply_form").find("#fply_panel_self  input[name='fply.gprsfzjhm']").val();
        //     if (!validStr) {
        //         A.showToast("请输入身份证号码!");
        //         return false;
        //     }
        //     if (!/^\d{6}(19|2\d)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)?$/.test(validStr)) {
        //         A.showToast("身份证号码不合法!");
        //         return false;
        //     }
        //
        //     validStr = $("#add_fply_form").find("#fply_panel_self  input[name='fply.gprlxdh']").val();
        //     if (!validStr) {
        //         A.showToast("请输入手机号码!");
        //         return false;
        //     }
        //     if (!/^1[3-9]\d{9}$/.test(validStr)) {
        //         A.showToast("手机号码格式不合法!");
        //         return false;
        //     }
        //
        // }

        return true;
    };

    $.fn.serializeObject = function(e) {
        var o = {};
        var a = this.serializeArray();
        $.each(a, function() {
            if (o[this.name]) {
                if (!o[this.name].push) {
                    o[this.name] = [o[this.name]];
                }
                o[this.name].push(this.value || '');
            } else {
                var nameArr = this.name.split('.');
                if (nameArr.length > 1) {
                    if (o.hasOwnProperty(nameArr[0])) {
                        o[nameArr[0]][nameArr[1]] = this.value || '';
                    } else {
                        var b = {};
                        b[nameArr[1]] = this.value || '';
                        o[nameArr[0]] = b;
                    }
                } else {
                    o[this.name] = this.value || '';
                }
            }
        });
        return o;
    };

    var $fply_add_section = $('#fply_add_section');
    var condition = {
        wsztDm: '',
        fply: {
            djxh: "",
            wsid: "",
            gprxm: "",
            fs: "",
            fpzlDm: "",
            lyfs: ""
        },
        kd: {
            wsid: "",
            sjr: "",
            dhhm: "",
            yzbm: "",
            dz: "",
            kdgsDm: "",
            kdgsMc: "",
            uuid: ""
        }
    };

    var initBtnEvents = function(params) {

        $("#btn_fply_addr_add").off(A.options.clickEvent);
        $("#btn_fply_addr_add").on(A.options.clickEvent, function() {
            A.Controller.modal("#fply_select_addr_modal");
            A.Controller.modal("#fply_addr_add_modal");
        });

        $("#auto_fpyj_btn").off(A.options.clickEvent);
        $("#auto_fpyj_btn").on(A.options.clickEvent, function() {
            A.confirm('提示', '系统将会把您的发票信息自动验旧，您确认要自动验旧？',
                function() {
                    A.showMask("验旧中");
                    rest.post({
                        url: "/fp/ly/zdyj",
                        data: {}, //该接口必须加空map
                        success: function(data) {
                            if (typeof(data) == "object" && !$.isEmptyObject(data)) {
                                if (data.code == "000") {
                                    $("#zggpsl").html("");
                                    initForm(params);
                                    A.showToast("自动验旧成功!");
                                } else {
                                    A.hideMask();
                                    A.showToast(data.msg);
                                }
                            } else {
                                A.hideMask();
                                A.showToast('自动验旧失败!');
                            }
                        },
                        error: function() {
                            A.hideMask();
                            A.showToast('自动验旧失败!');
                        }
                    });
                });
        });

        $fply_add_section.find('.btn-add').off(A.options.clickEvent);
        $fply_add_section.find('.btn-add').on(A.options.clickEvent, function() {
            submitForm($(this).data('wsztdm'));
        });

        $fply_add_section.find('.btn-update').off(A.options.clickEvent);
        $fply_add_section.find('.btn-update').on(A.options.clickEvent, function() {
            var wsid = $(this).data('wsid');
            submitForm($(this).data('wsztdm'), wsid);
        });
    }

    var initForm = function(params) {
        if (params.type == 'update') {
            $fply_add_section.find('.title').html('发票领用修改');
            $fply_add_section.find('.btn-update').show().data('wsid', params.wsid);
            $fply_add_section.find('.btn-add').hide();
            queryFply(params.wsid);
        } else {
            $fply_add_section.find('.title').html('发票领用新增');
            $fply_add_section.find('.btn-update').hide();
            $fply_add_section.find('.btn-add').show();
            A.showMask();
            queryInitFply();
        }
    }

    $fply_add_section.on('sectionhide', function() {
        firstLoad = true;
        fply = {};
        $('#add_fply_form')[0].reset();
        $("#fply_panel_express span[name='fply.gprdz']").text("");
    });

    $fply_add_section.on('sectionshow', function() {
        var params = A.Component.params(this);
        lyfsParam.type = params.type;
        selectedAddr = params.addr;
        $fply_add_section.find('.nsrmc').html(sessionStorage.getItem("nsrmc"));
        $fply_add_section.find('.nsrsbh').html(localStorage.getItem("nsrsbh"));

        initBtnEvents(params);

        if (firstLoad)
            initForm(params);
    });

    var fpzlDmChgCallBack = function() {
        $("#fpzlDm").on("change", function() {
            $("#zggpsl").html($(this).find("option :selected").data("zggpsl"));
        });
    }

    var queryFply = function(wsid) {
        A.showMask();
        rest.get({
            url: '/fp/ly/select/{wsid}',
            urlParams: {
                wsid: wsid
            },
            success: function(result) {
                A.hideMask();
                if (result.code == '000' && result.fply) {
                    $.extend(true, fply, result.fply);

                    var data = fply;
                    $("#fply_add_fpzlsel_container").html(A.template('#fply_add_fpzlsel_tmpl').render(result));

                    fpzlDmChgCallBack();
                    var fplqfsFields = result.fplqfs.split(",");
                    var kdgsList = result.kdgsList;
                    var lqfsList = [];
                    var tmpProtocolHtmls;
                    for(var i in fplqfsFields){
                        switch (fplqfsFields[i]){
                            case "1": lqfsList.push({fplqfsDm:1,fplqfsmc:"办税厅自取",fplqfsForm:"self"});break;
                            case "3": lqfsList.push({fplqfsDm:3,fplqfsmc:"终端自取",fplqfsForm:"self"});break;
                            default : {
                                for(var j in kdgsList){
                                    if(fplqfsFields[i]==kdgsList[j].fplqfsDm){
                                        kdgsList[j].fplqfsForm = "express";
                                        lqfsList.push(kdgsList[j]);
                                        if(tmpProtocolHtmls){
                                            tmpProtocolHtmls = tmpProtocolHtmls.add($("<div></div>").attr("name","express_"+kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy));
                                        }else{
                                            tmpProtocolHtmls = $("<div></div>").attr("name","express_"+kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy);
                                        }
                                    }
                                }
                            };break;
                        }
                    }
                    $("#protocol_container").html(tmpProtocolHtmls);
                    A.Scroll("#fply_statement_article").refresh();
                    $("#fply_add_lqfs_container").html(A.template("#fply_add_lqfs_tmpl").render({lqfsList:lqfsList}));
                    $fply_add_section.find('#fply_add_lqfs').val(result.fply.lyfs);

                    $fply_add_section.find('#fply_add_lqfs').off("change");
                    $fply_add_section.find('#fply_add_lqfs').on("change", function() {
                        var formType = $(this).find("option:selected").data("formtype");
                        var selectedText = $(this).find("option:selected").html();
                        $("input[name='fply.lyfsMc']").val(selectedText);

                        if (formType == "express") {
                            $("#fply_panel_express").addClass("show_block");
                            $("#fply_panel_express").removeClass("show_none");
                            $("#fply_panel_self").addClass("show_none");
                            $("#fply_panel_self").removeClass("show_block");
                            $("#fply_panel_express").find("input").prop("disabled", false);
                            $("#fply_panel_self").find("input").prop("disabled", true);
                        } else {
                            $("#fply_panel_express").addClass("show_none");
                            $("#fply_panel_express").removeClass("show_block");
                            $("#fply_panel_self").addClass("show_block");
                            $("#fply_panel_self").removeClass("show_none");
                            $("#fply_panel_express").find("input").prop("disabled", true);
                            $("#fply_panel_self").find("input").prop("disabled", false);
                        }
                    });

                    $("#fpzlDm").val(result.fply.fpzlDm);
                    for (var i in result.fplyPzhdList) {
                        if (result.fplyPzhdList[i].fpzlDm == result.fply.fpzlDm) {
                            $("#zggpsl").html(result.fplyPzhdList[i].zggpsl);
                            break;
                        }
                    }
                    $("#fs").val(result.fply.fs);
                    var formType = $fply_add_section.find('#fply_add_lqfs option:selected').data("formtype");

                    if (formType != "express") {
                        rest.get({
                            url: "/fp/express/select",
                            success: function(data) {
                                A.hideMask();
                                if (!data || $.isEmptyObject(data) || !data.code || data.code != "000") {
                                    result.defaultAddr = {};
                                } else if (data.code == "000" && data.dataList instanceof Array && data.dataList.length > 0) {
                                    for (var i in data.dataList) {
                                        if (data.dataList[i].sfmrdz == 'Y') {
                                            result.defaultAddr = data.dataList[i];
                                            break;
                                        }
                                    }
                                    if (typeof(result.defaultAddr) == "undefined") {
                                        result.defaultAddr = {};
                                    }
                                } else {
                                    result.defaultAddr = {};
                                }
                                result.formType = formType;
                                A.template('#fply_panel_tmpl').renderReplace(result, function() {

                                    $("#fply_panel_self input[name='fply.gprxm']").val(result.fply.gprxm);
                                    $("#fply_panel_self input[name='fply.gprsfzjhm']").val(result.fply.gprsfzjhm);
                                    $("#fply_panel_self input[name='fply.gprlxdh']").val(result.fply.gprlxdh);

                                    $("#btn_open_addr").off(A.options.clickEvent);
                                    $("#btn_open_addr").on(A.options.clickEvent, function() {
                                        A.Controller.modal("#fply_select_addr_modal");
                                    });
                                });
                                A.hideMask();
                            },
                            error: function() {
                                A.hideMask();
                                result.defaultAddr = {};
                                A.template('#fply_panel_tmpl').renderReplace(result, function() {
                                    $("#btn_open_addr").off(A.options.clickEvent);
                                    $("#btn_open_addr").on(A.options.clickEvent, function() {
                                        A.Controller.modal("#fply_select_addr_modal");
                                    });
                                });
                            }
                        });
                    } else {
                        result.defaultAddr = {};
                        result.formType = formType;
                        A.template('#fply_panel_tmpl').renderReplace(result, function() {

                            $("#fply_panel_express input[name='fply.gprxm']").val(result.fply.gprxm);
                            $("#fply_panel_express input[name='fply.gprsfzjhm']").val(result.fply.gprsfzjhm);
                            $("#fply_panel_express input[name='fply.gprlxdh']").val(result.fply.gprlxdh);
                            $("#fply_panel_express span[name='fply.gprdz']").text(result.fply.gprdz);

                            $("#fply_panel_express input[name='fply.yzbm']").val(result.kd.yzbm);
                            $("#fply_panel_express input[name='fply.uuid']").val(result.kd.uuid);

                            $("#btn_open_addr").off(A.options.clickEvent);
                            $("#btn_open_addr").on(A.options.clickEvent, function() {
                                A.Controller.modal("#fply_select_addr_modal");
                            });
                        });
                    }

                } else {
                    A.showToast(result.msg);
                }
            },
            error: function(err) {
                A.showToast('查询失败');
                A.hideMask();
            }
        });
    }

    var queryInitFply = function() {
        rest.get({
            url: '/fp/ly/init',
            success: function(result) {
                if (result.code == '000') {
                    $("#fply_add_fpzlsel_container").html(A.template('#fply_add_fpzlsel_tmpl').render(result));
                    fpzlDmChgCallBack();

                    var fplqfsFields = result.fplqfs.split(",");
                    var kdgsList = result.kdgsList;
                    var lqfsList = [];
                    var tmpProtocolHtmls;
                    for(var i in fplqfsFields){
                        switch (fplqfsFields[i]){
                            case "1": lqfsList.push({fplqfsDm:1,fplqfsmc:"办税厅自取",fplqfsForm:"self"});break;
                            case "3": lqfsList.push({fplqfsDm:3,fplqfsmc:"终端自取",fplqfsForm:"self"});break;
                            default : {
                                for(var j in kdgsList){
                                    if(fplqfsFields[i]==kdgsList[j].fplqfsDm){
                                        kdgsList[j].fplqfsForm = "express";
                                        lqfsList.push(kdgsList[j]);
                                        if(tmpProtocolHtmls){
                                            tmpProtocolHtmls = tmpProtocolHtmls.add($("<div></div>").attr("name","express_"+kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy));
                                        }else{
                                            tmpProtocolHtmls = $("<div></div>").attr("name","express_"+kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy);
                                        }
                                    }
                                }
                            };break;
                        }
                    }
                    $("#protocol_container").html(tmpProtocolHtmls);
                    A.Scroll("#fply_statement_article").refresh();
                    $("#fply_add_lqfs_container").html(A.template("#fply_add_lqfs_tmpl").render({lqfsList:lqfsList}));
                    $fply_add_section.find('#fply_add_lqfs').off("change");
                    $fply_add_section.find('#fply_add_lqfs').on("change", function() {
                        var formType = $(this).find("option:selected").data("formtype");
                        var selectedText = $(this).find("option:selected").html();
                        $("input[name='fply.lyfsMc']").val(selectedText);
                        if (formType == "express") {
                            $("#fply_panel_express").addClass("show_block");
                            $("#fply_panel_express").removeClass("show_none");
                            $("#fply_panel_self").addClass("show_none");
                            $("#fply_panel_self").removeClass("show_block");
                            $("#fply_panel_express").find("input").prop("disabled", false);
                            $("#fply_panel_self").find("input").prop("disabled", true);
                        } else {
                            $("#fply_panel_express").addClass("show_none");
                            $("#fply_panel_express").removeClass("show_block");
                            $("#fply_panel_self").addClass("show_block");
                            $("#fply_panel_self").removeClass("show_none");
                            $("#fply_panel_express").find("input").prop("disabled", true);
                            $("#fply_panel_self").find("input").prop("disabled", false);
                        }
                    });
                    queryDefaultAddress();
                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('连接超时');
            }
        });
    }

    var queryDefaultAddress = function() {
        rest.get({
            url: "/fp/express/select",
            success: function(data) {
                A.hideMask();
                if (!data || $.isEmptyObject(data) || !data.code || data.code != "000") {
                    lyfsParam.defaultAddr = {};
                } else if (data.code == "000") {
                    if (data.dataList instanceof Array && data.dataList.length > 0) {
                        for (var i in data.dataList) {
                            if (data.dataList[i].sfmrdz == 'Y') {
                                lyfsParam.defaultAddr = data.dataList[i];
                                break;
                            }
                        }
                        if (typeof(lyfsParam.defaultAddr) == "undefined") {
                            lyfsParam.defaultAddr = {};
                        }

                    } else {
                        lyfsParam.defaultAddr = {};
                    }
                }

                var formType = $fply_add_section.find("#fply_add_lqfs option:selected").data("formtype");
                var selectedText = $fply_add_section.find("#fply_add_lqfs option:selected").html();
                $("input[name='fply.lyfsMc']").val(selectedText);
                lyfsParam.formType = formType;
                A.template('#fply_panel_tmpl').renderReplace(lyfsParam, function() {

                    if(formType=='express'){
                        $('#fply_panel_self').find('input').prop("disabled",true);
                        $('#fply_panel_express').find('input').prop("disabled",false);
                    }else{
                        $('#fply_panel_self').find('input').prop("disabled",false);
                        $('#fply_panel_express').find('input').prop("disabled",true);
                    }

                    $("#btn_open_addr").off(A.options.clickEvent);
                    $("#btn_open_addr").on(A.options.clickEvent, function() {
                        A.Controller.modal("#fply_select_addr_modal");
                    });
                });
                A.hideMask();
            },
            error: function() {
                A.hideMask();
                lyfsParam.defaultAddr = {};
                A.template('#fply_panel_tmpl').renderReplace(lyfsParam, function() {
                    $("#btn_open_addr").off(A.options.clickEvent);
                    $("#btn_open_addr").on(A.options.clickEvent, function() {
                        A.Controller.modal("#fply_select_addr_modal");
                    });
                });
            }
        });
    }

    var submitForm = function(wsztDm, wsid) {

        if (initFormValid()) {

            var $add_fply_form = $fply_add_section.find('#add_fply_form');

            A.showMask();

            var url;
            var _dataFrom = $add_fply_form.serializeObject();
            if(!$("#gprdz").prop("disabled"))
                _dataFrom.fply.gprdz = $("#gprdz").html();

            var _data = $.extend(true, {}, condition, _dataFrom);

            _data.fply.djxh = sessionStorage.getItem("djxh");
            _data.wsztDm = wsztDm;

            var formType = $fply_add_section.find("#fply_add_lqfs option:selected").data("formtype");
            if (formType=="express") { //快递寄送
                _data.kd.sjr = _data.fply.gprxm;
                _data.kd.dhhm = _data.fply.gprlxdh;
                _data.kd.dz = _data.fply.gprdz;
                _data.kd.sfzjhm = _data.fply.gprsfzjhm;
                _data.kd.kdgsDm = $fply_add_section.find("#fply_add_lqfs option:selected").data("kdgsdm")+"";
                _data.kd.kdgsMc = $fply_add_section.find("#fply_add_lqfs option:selected").html();
                _data.kd.yzbm = $("#fply_lqfs input[name='fply.yzbm']").val();
                _data.kd.uuid = $("#fply_lqfs input[name='fply.uuid']").val();
            }

            if (wsid) {
                url = '/fp/ly/edit/' + wsid;
                _data.fply.wsid = wsid;
                _data.kd.wsid = wsid;
            } else {
                url = '/fp/ly/add';
            }
            if (formType=="express") {
                A.hideMask();

                $("#protocol_container").find("div[name^='express']").hide();
                var lyfsId = $fply_add_section.find("#fply_add_lqfs").val();
                var tarNode = $("#protocol_container").find("div[name='express_"+lyfsId+"']");
                tarNode.show();

                A.Controller.modal("#fply_statement_modal");
                reqUrl = url;
                reqData = _data;
            } else {
                rest.post({
                    url: url,
                    data: _data,
                    success: function(result) {
                        if (result.code == '000') {
                            firstLoad = true;
                            A.hideMask();
                            A.showToast('操作成功');
                            A.Controller.back();
                        } else {
                            A.hideMask();
                            A.showToast(result.msg);
                        }
                    },
                    error: function() {
                        A.hideMask();
                        A.showToast('连接超时');
                    }
                });
            }
        }
    };

    $("#fply_statement_modal").on("modalshow", function() {
        firstLoad = false;
        $("#btn_confirm").off(A.options.clickEvent);
        $("#btn_confirm").on(A.options.clickEvent, function() {

            if (!reqUrl && !reqData) {
                A.showToast("保存失败,请稍后");
                A.Controller.modal("#fply_statement_modal");
                return;
            }

            var tmpUrl = reqUrl;
            var tmpData = reqData;
            A.Controller.modal("#fply_statement_modal");

            A.showMask();
            rest.post({
                url: tmpUrl,
                data: tmpData,
                success: function(result) {
                    A.hideMask();
                    if (result.code == '000') {
                        A.showToast('操作成功');
                        A.Controller.back();
                    } else if (result.code == "109") {
                        A.showToast(result.msg);
                        A.Controller.back();
                    } else {
                        A.showToast(result.msg);
                    }
                },
                error: function() {
                    A.hideMask();
                    A.showToast('连接超时');
                }
            });

        });

        $("#btn_cancel").on(A.options.clickEvent, function() {
            A.Controller.modal("#fply_statement_modal");
        });

    });

    $("#fply_statement_modal").on("modalhide", function() {
        $("#btn_confirm").off(A.options.clickEvent);
        $("#btn_cancel").off(A.options.clickEvent);
        reqUrl = null;
        reqData = null;
    });

    $("#fply_select_addr_modal").on("modalshow", function() {
        $("#btn_select_addr_back").off(A.options.clickEvent);
        $("#btn_select_addr_back").on(A.options.clickEvent, function() {
            A.Controller.modal("#fply_select_addr_modal");
        });
        firstLoad = false;
        initAddrList();
    });

    $("#fply_addr_add_modal").on("modalshow",function(){
        firstLoad = false;
        initAddrAddPage();
    });

    var initAddrAddPage = function(){
        getDistrict(1);

        $("#fply_addr_add_article button[name='submit_addr']").off(A.options.clickEvent);
        $("#fply_addr_add_article button[name='submit_addr']").on(A.options.clickEvent,function(){
            var reqParam = {};
            $("#fply_addr_add_article").find("input,select").each(function(){
                if($(this).prop("name")=="sfmrdz"){
                    if($(this).is(":checked")){
                        reqParam.sfmrdz="Y";
                    }else{
                        reqParam.sfmrdz="N";
                    }
                }else if($(this).get(0).tagName=="SELECT"){
                    reqParam[$(this).prop("name")] = $(this).val();
                    reqParam[$(this).prop("name")+"Name"] = $(this).find("option:selected").html();
                }else {
                    reqParam[$(this).prop("name")] = $(this).val();
                }
            });
            reqParam.djxh = sessionStorage.getItem("djxh");
            reqParam.roleid = sessionStorage.getItem("roleId");
            if(!reqParam.xm){
                A.showToast("请输入姓名!");
                return;
            }
            if(!/^[\u0391-\uFFE5]{2,8}$|^([A-Za-z]{1,10}\s?){1,3}$/.test(reqParam.xm)){
                A.showToast("姓名不合法!");
                return;
            }

            if(!reqParam.dh){
                A.showToast("请输入电话号码!");
                return;
            }
            if(!/^1[3-9]\d{9}$/.test(reqParam.dh)){
                A.showToast("手机号码格式不合法!");
                return;
            }

            if(!reqParam.sfzhm){
                A.showToast("请输入身份证号码!");
                return;
            }

            if(!/^\d{6}(19|2\d)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)?$/.test(reqParam.sfzhm)){
                A.showToast("身份证号码格式不合法!");
                return;
            }

            if(!reqParam.province){
                A.showToast("请选择省/直辖市!");
                return;
            }
            if(!reqParam.city){
                A.showToast("请选择市!");
                return;
            }
            if(!reqParam.county){
                A.showToast("请选择区/县!");
                return;
            }
            if(!reqParam.address){
                A.showToast("请输入街道地址!");
                return;
            }
            if(reqParam.address.length>32){
                A.showToast("街道地址不能超过32个字符!");
                return;
            }

            if(!reqParam.yzbm){
                A.showToast("请输入邮政编码!");
                return;
            }
            if(reqParam.yzbm.length!=6){
                A.showToast("邮政编码格式不合法!");
                return;
            }
            A.showMask();
            rest.post({
                url : "/fp/express/insert",
                data : reqParam,
                success : function(data){
                    A.hideMask();
                    if(!data || $.isEmptyObject(data)){
                        A.showToast("保存收货地址失败!");
                    }else if(data.code!="000" && data.msg){
                        A.showToast(data.msg);
                    }else if(data.code=="000" && data.msg){
                        A.showToast(data.msg);

                        $("#fply_panel_express").show();
                        $("#fply_panel_self").hide();

                        var gprxm = reqParam.xm;
                        var gprlxdh = reqParam.dh;
                        var gprdz = reqParam.provinceName + reqParam.countyName + reqParam.cityName + reqParam.address;
                        var gprsfzjhm = reqParam.sfzhm;
                        var yzbm = reqParam.yzbm;
                        var uuid = data.uuid;
                        $("#fply_panel_express input[name='fply.gprxm']").val(gprxm);
                        $("#fply_panel_express input[name='fply.gprlxdh']").val(gprlxdh);
                        $("#fply_panel_express span[name='fply.gprdz']").html(gprdz);
                        $("#fply_panel_express input[name='fply.gprsfzjhm']").val(gprsfzjhm);
                        $("#fply_panel_express input[name='fply.yzbm']").val(yzbm);
                        $("#fply_panel_express input[name='fply.uuid']").val(uuid);

                        A.Controller.modal("#fply_addr_add_modal");
                    }else{
                        A.showToast("保存收货地址失败!");
                    }
                },
                error : function(){
                    A.hideMask();
                    A.showToast("保存收货地址失败!");
                }
            });
        });

        $("#fply_addr_add_article select[name='province']").off("change");
        $("#fply_addr_add_article select[name='province']").on("change",function(){
            A.showMask();
            getDistrict(2,function(){A.hideMask();});
            $("#county").html(A.template('#tmpl_county').render({}));
        });

        $("#fply_addr_add_article select[name='city']").off("change");
        $("#fply_addr_add_article select[name='city']").on("change",function(){
            A.showMask();
            getDistrict(3,function(){A.hideMask();});
        });
    };

    var getDistrict = function(districtType,callBack){
        if(!districtType){
            A.showToast("获取行政区域信息失败!");
            return;
        }

        var params = {};
        var url = "/fp/express/init?xzqhjc={xzqhjc}";
        params.xzqhjc = districtType;
        if(districtType=="2"){
            params.sjxzqhszDm = $("#fply_addr_add_article select[name='province']").val();
            url += "&sjxzqhszDm={sjxzqhszDm}";
        }else if(districtType=="3"){
            params.sjxzqhszDm = $("#fply_addr_add_article select[name='city']").val();
            url += "&sjxzqhszDm={sjxzqhszDm}";
        }

        rest.get({
            url : url,
            urlParams : params,
            success : function(data){
                var html;
                if(districtType==1) {
                    html = A.template('#tmpl_fply_province').render(data, function () {});
                    $("#fply_addr_add_article select[name='province']").html(html);
                }else if(districtType==2){
                    html = A.template('#tmpl_fply_city').render(data, function () {});
                    $("#fply_addr_add_article select[name='city']").html(html);
                }else if(districtType==3){
                    html = A.template('#tmpl_fply_county').render(data, function () {});
                    $("#fply_addr_add_article select[name='county']").html(html);
                }
                if(callBack) callBack();
            },
            error : function(){
                A.hideMask();
                A.showToast("获取行政区域信息失败!");
            }
        });
    };

    var initAddrList = function() {
        A.showMask();
        rest.get({
            url: "/fp/express/select",
            success: function(data) {
                A.hideMask();
                if (!data || $.isEmptyObject(data) || !data.code || data.code != "000") {
                    A.showToast(data.msg || "查询收货地址失败!");
                } else if (data.code == "000") {
                    if (!data.dataList || data.dataList.length <= 0) {
                        A.showToast('请在"我的->收货地址管理"模块中添加收货地址!');
                    }
                    A.template("#tmpl_fply_addr").renderReplace(data, function() { initAddrEvent(); });
                } else {
                    A.showToast("查询收货地址失败!");
                }
            },
            error: function() {
                A.hideMask();
                A.showToast("查询收货地址失败!");
            }
        });
    }

    var initAddrEvent = function() {
        $("#fply_select_addr_modal button[name='submit_btn']").off(A.options.clickEvent);
        $("#fply_select_addr_modal button[name='submit_btn']").on(A.options.clickEvent, function() {
            var uuid = $(this).parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            A.showMask();
            rest.get({
                url: "/fp/express/selectOne/{uuid}",
                urlParams: {
                    uuid: uuid
                },
                success: function(data) {
                    A.hideMask();
                    if (!data || $.isEmptyObject(data) || !data.code || data.code != "000") {
                        A.showToast("查询收货地址失败!");
                    } else if (data.code == "000") {
                        $("#fply_panel_express input[name='fply.gprxm']").val(data.data.xm);
                        $("#fply_panel_express input[name='fply.gprlxdh']").val(data.data.dh);
                        $("#fply_panel_express input[name='fply.gprsfzjhm']").val(data.data.sfzhm);
                        $("#fply_panel_express span[name='fply.gprdz']").html(data.data.provinceName + data.data.countyName + data.data.cityName + data.data.address);
                        $("#fply_panel_express input[name='fply.yzbm']").val(data.data.yzbm);
                        $("#fply_panel_express input[name='fply.uuid']").val(data.data.uuid);
                        A.Controller.modal("#fply_select_addr_modal");
                    } else {
                        A.showToast("查询收货地址失败!");
                    }
                },
                error: function() {
                    A.hideMask();
                    A.showToast("查询收货地址失败!");
                }
            });
        });
    };

});