/**
 * Created by Li Hongwei on 2016-03-10.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var $fply_section = $('#fply_section');
    var count;//总页数


    /**
     * 查询条件
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        wszlDm:'15013',
        wsztDm:'',
        sqrqq:'',
        sqrqz:'',
        wsid:'',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    function resetCondition() {
        var $fply_search_modal = $('#fply_search_modal');
        $fply_search_modal.find('.sqrqq_label').html('请选择时间');
        $fply_search_modal.find('.sqrqz_label').html('请选择时间');
        $fply_search_modal.find('.sqrqq').val('');
        $fply_search_modal.find('.sqrqz').val('');
        $fply_search_modal.find('.wsztDm option[value=""]').prop('selected','selected');
        condition.sqrqq = $fply_search_modal.find('.sqrqq').val();
        condition.sqrqz = $fply_search_modal.find('.sqrqz').val();
        $fply_search_modal.find('.wsztDm option').removeAttr('selected');
        condition.wsztDm = '';
        condition.wszlDm = '15013';
        condition.wsid = '';
        condition.minNum =  1;
        condition.maxNum =  10;
    }


    /**
     * 刷新
     */ 
    function doRefresh() {
        A.showMask();
        rest.get({
            url: '/ws/querylist?minNum={minNum}&maxNum={maxNum}&wszlDm={wszlDm}&wsztDm={wsztDm}&sqrqq={sqrqq}&sqrqz={sqrqz}&wsid={wsid}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#fply_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            del();
                            var refresh = A.Refresh('#fply_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.list.length +'条记录');
                            }
                            nextPage();
                            initCljgPopover();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#fply_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    function doRefreshFirst() {
        condition.minNum = 1;
        condition.maxNum = 10;
        doRefresh();
    }

    function del() {
        $fply_section.find('.btn-del').on(A.options.clickEvent, function(){
            var wsid = $(this).data('wsid');
            A.confirm('提示','确认要删除该条信息？',
                function(){
                    rest.del({
                        url: '/fp/ly/delete/{wsid}',
                        urlParams : {wsid : wsid},
                        success: function(result) {
                            if(result.code == '000') {
                                A.showToast('删除成功！');
                                doRefreshFirst();
                            } else {
                                A.showToast(result.msg);
                            }
                            A.hideMask();
                        },
                        error: function() {
                            A.showToast('连接超时');
                            A.hideMask();
                        }
                    });
                },
                function(){
                    //A.alarmToast('你选择了“取消”');
                });
            return false;
        });
    }




    function initCljgPopover() {
        $('.cljg_popover').on(A.options.clickEvent, function(e){
            A.popover([{text :$(e.target).data('cueinfo')}], this);
            return false;
        });
    }

    /**
     * 页面初始加载
     */
    $fply_section.on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        doRefreshFirst();
    });

    /**
     * 滑动监听
     */
    $('#fply_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            doRefreshFirst();
        });
    });

    function initSeach(_this) {
        if(condition.sqrqq) {
            _this.find(".sqrqq_label").html(condition.sqrqq);
            _this.find(".sqrqq").val(condition.sqrqq);
        }
        if(condition.sqrqz) {
            _this.find(".sqrqz_label").html(condition.sqrqz);
            _this.find(".sqrqz").val(condition.sqrqz);
        }
        if(condition.wsztDm) {
            _this.find('.wsztDm option[value="' + condition.wsztDm +'"]').attr('selected','selected');
        }
    }

    /**
     * 查询按钮
     */
    $('#fply_search').on(A.options.clickEvent,function(e){

        var $popup = new A.Popup({
            html: $('#fply_search_modal').html(),
            pos : 'top'
        }).on('popupopen', function(){
                var _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                    condition.sqrqq = _this.find(".sqrqq").val();
                    condition.sqrqz = _this.find(".sqrqz").val();
                    condition.wsztDm = _this.find(".wsztDm option").not(function () {return !this.selected;}).val();
                    _this.find('.wsztDm option[value="' + condition.wsztDm +'"]').attr('selected','selected');
                    doRefreshFirst();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
        return false;
    });




});