define(function(require,exports,module){

    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var type;
    var wsid;

    $("#fply_select_addr_section").on("sectionshow",function(){
        var params = A.Component.params(this);
        type = params.type;
        wsid = params.wsid;
        initAddrList();
    });

    var initAddrList = function(){
        A.showMask();
        rest.get({
            url : "/fp/express/select",
            success : function(data){
                A.hideMask();
                if(!data || $.isEmptyObject(data) || !data.code || data.code!="000"){
                    A.showToast(data.msg||"查询收货地址失败!");
                }else if(data.code=="000"){
                    if(!data.dataList || data.dataList.length<=0){
                        A.showToast('请在"我的->收货地址管理"模块中添加收货地址!');
                    }
                    A.template("#tmpl_fply_addr").renderReplace(data,function(){initAddrEvent();});
                }else{
                    A.showToast("查询收货地址失败!");
                }
            },
            error : function(){
                A.hideMask();
                A.showToast("查询收货地址失败!");
            }
        });
    }

    var initAddrEvent = function(){
        $("#fply_select_addr_section button[name='submit_btn']").on(A.options.clickEvent,function(){
            var uuid = $(this).parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            A.showMask();
            rest.get({
                url : "/fp/express/selectOne/{uuid}",
                urlParams : {
                    uuid : uuid
                },
                success : function(data){
                    A.hideMask();
                    if(!data || $.isEmptyObject(data) || !data.code || data.code!="000"){
                        A.showToast("查询收货地址失败!");
                    }else if(data.code=="000"){
                        var addr = JSON.stringify(data.data);
                        A.Controller.section("tax/fply/fply_add_section.html?addr="+addr+"&type="+type+"&wsid="+wsid);
                    }else{
                        A.showToast("查询收货地址失败!");
                    }
                },
                error : function(){
                    A.hideMask();
                    A.showToast("查询收货地址失败!");
                }
            });
        });
    };

})