/**
 * Created by Li Hongwei on 2016/2/16.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var count;//总页数


    /**
     * 查询条件
     * 15007专票
     * 15008普票
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        wszlDm:'15007,15008',
        wsztDm:'',
        sqrqq:'',
        sqrqz:'',
        wsid:'',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    var resetCondition = function() {
        var $fppzhd_search_modal = $('#fppzhd_search_modal');
        $fppzhd_search_modal.find('.sqrqq_label').html('请选择时间');
        $fppzhd_search_modal.find('.sqrqz_label').html('请选择时间');
        $fppzhd_search_modal.find('.sqrqq').val('');
        $fppzhd_search_modal.find('.sqrqz').val('');
        $fppzhd_search_modal.find('.wsztDm option[value=""]').prop('selected','selected');
        $fppzhd_search_modal.find('.wsztDm option').removeAttr('selected');
        $fppzhd_search_modal.find('.wszlDm option[value=""]').prop('selected','selected');
        $fppzhd_search_modal.find('.wszlDm option').removeAttr('selected');
        condition.sqrqq = $fppzhd_search_modal.find('.sqrqq').val();
        condition.sqrqz = $fppzhd_search_modal.find('.sqrqz').val();
        condition.wsid = '';
        condition.wszlDm='15007,15008';
        condition.minNum =  1;
        condition.maxNum =  10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        A.showMask();
        rest.get({
            url: '/ws/querylist?minNum={minNum}&maxNum={maxNum}&wszlDm={wszlDm}&wsztDm={wsztDm}&sqrqq={sqrqq}&sqrqz={sqrqz}&wsid={wsid}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#fppzhd_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#fppzhd_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.list.length +'条记录');
                            }
                            nextPage();
                            initCljgPopover();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#fppzhd_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };


    var initCljgPopover = function() {
        $('.cljg_popover').on(A.options.clickEvent, function(e){
            A.popover([{text :$(e.target).data('cueinfo')}], this);
            return false;
        });
    };

    /**
     * 页面初始加载
     */
    $('#fppzhd_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        A.showMask();
        doRefresh();

        //rest.get({
        //    url: '/ws/querylist?minNum={minNum}&maxNum={maxNum}&wszlDm={wszlDm}&wsztDm={wsztDm}&sqrqq={sqrqq}&sqrqz={sqrqz}&wsid={wsid}',
        //    urlParams : condition,
        //    success: function(result) {
        //        if(result.code == '000') {
        //            if(result.list && result.list.length != 0) {
        //                A.template('#fppzhd_tmpl').renderReplace(result, function() {
        //                    nextPage();
        //                    initCljgPopover();
        //                });
        //            } else {
        //                A.showToast('未查询到相关记录');
        //            }
        //
        //        } else {
        //            A.showToast(result.msg);
        //        }
        //        A.hideMask();
        //    },
        //    error: function() {
        //        A.showToast('连接超时');
        //        A.hideMask();
        //    }
        //});
    });

    /**
     * 滑动监听
     */
    $('#fppzhd_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

    var initSeach = function(_this) {
        if(condition.sqrqq) {
            _this.find(".sqrqq").val(condition.sqrqq);
            _this.find(".sqrqq_label").html(condition.sqrqq);
        }
        if(condition.sqrqz) {
            _this.find(".sqrqz").val(condition.sqrqz);
            _this.find(".sqrqz_label").html(condition.sqrqz);
        }
        if(condition.wsztDm) {
            _this.find('.wsztDm option[value="' + condition.wsztDm +'"]').attr('selected','selected');
        }
        if(condition.wszlDm) {
            _this.find('.wszlDm option[value="' + condition.wszlDm +'"]').attr('selected','selected');
        }

    };

    /**
     * 查询按钮
     */
    $('#fppzhd_search').on(A.options.clickEvent,function(e){
        //var $fppzhd_search_modal = $('#fppzhd_search_modal');
        //$fppzhd_search_modal.find('.search_btn').off(A.options.clickEvent);
        //$fppzhd_search_modal.find('.search_btn').on(A.options.clickEvent, function(){
        //    condition.wsztDm = $fppzhd_search_modal.find('.wsztDm').val();
        //    condition.sqrqq = $fppzhd_search_modal.find('.sqrqq').val();
        //    condition.sqrqz = $fppzhd_search_modal.find('.sqrqz').val();
        //    condition.minNum = 1;
        //    condition.maxNum = 10;
        //    A.Controller.modal('#fppzhd_search_modal');
        //});
        //A.Controller.modal('#fppzhd_search_modal');


        var $popup = new A.Popup({
            html: $('#fppzhd_search_modal').html(),
            pos : 'top'
        }).on('popupopen', function(){
                var _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                    condition.sqrqq = _this.find(".sqrqq").val();
                    condition.sqrqz = _this.find(".sqrqz").val();
                    condition.wsztDm = _this.find(".wsztDm option").not(function () {return !this.selected;}).val();
                    _this.find('.wsztDm option[value="' + condition.wsztDm +'"]').attr('selected','selected');
                    condition.wszlDm = _this.find(".wszlDm option").not(function () {return !this.selected;}).val();
                    _this.find('.wszlDm option[value="' + condition.wszlDm +'"]').attr('selected','selected');
                    condition.minNum = 1;
                    condition.maxNum = 10;
                    //$('#fppzhd_search_modal').html(_this.html());
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
        return false;
    });

});