/**
 * Created by Li Hongwei on 2016-03-10.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var wszlDm = '15003';
    var count; //总页数

    var $fpyj_section = $('#fpyj_section');

    /**
     * 查询条件
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        wszlDm: wszlDm,
        wsztDm: '',
        sqrqq: '',
        sqrqz: '',
        wsid: '',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    var resetCondition = function() {
        var $fpyj_search_modal = $('#fpyj_search_modal');
        $fpyj_search_modal.find('.sqrqq_label').html('请选择时间');
        $fpyj_search_modal.find('.sqrqz_label').html('请选择时间');
        $fpyj_search_modal.find('.sqrqq').val('');
        $fpyj_search_modal.find('.sqrqz').val('');
        $fpyj_search_modal.find('.wsztDm option[value=""]').prop('selected', 'selected');
        condition.sqrqq = $fpyj_search_modal.find('.sqrqq').val();
        condition.sqrqz = $fpyj_search_modal.find('.sqrqz').val();
        $fpyj_search_modal.find('.wsztDm option').removeAttr('selected');
        condition.wsztDm = '';
        condition.wszlDm = wszlDm;
        condition.wsid = '';
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        A.showMask();
        rest.get({
            url: '/ws/querylist?minNum={minNum}&maxNum={maxNum}&wszlDm={wszlDm}&wsztDm={wsztDm}&sqrqq={sqrqq}&sqrqz={sqrqz}&wsid={wsid}',
            urlParams: condition,
            success: function(result) {
                if (result.code == '000') {
                    if (condition.minNum <= result.count) {
                        A.template("#fpyj_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function() {

                            modifyRecord();
                            del();
                            var refresh = A.Refresh('#fpyj_article');
                            refresh.refresh();
                            count = result.count;
                            if (condition.minNum > 1) {
                                A.showToast('新加载' + result.list.length + '条记录');
                            }
                            nextPage();
                            initCljgPopover();
                        });
                    } else {
                        if (condition.minNum == 1) { //加载为首页时清空
                            A.template('#fpyj_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else {
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    var doRefreshFirst = function() {
        condition.minNum = 1;
        condition.maxNum = 10;
        doRefresh();
    };

    var initCljgPopover = function() {
        $('.cljg_popover').on(A.options.clickEvent, function(e) {
            A.popover([{ text: $(e.target).data('cueinfo') }], this);
            return false;
        });
    };

    var modifyRecord = function() {
        $fpyj_section.find('.btn-update').on(A.options.clickEvent, function() {
            var wsid = $(this).data('wsid');
            var condition = {
                wsid: wsid
            };
            rest.get({
                url: '/fp/fpyj/{wsid}',
                urlParams: condition,
                success: function(result) {
                    if (result.code == '000') {
                        if (result.fpyjList && result.fpyjList.length > 0) {
                            sessionStorage.setItem("fpyj.jjyjList", JSON.stringify(result.fpyjList));
                            //doRefash();
                        }
                        // if (result.fpzfList && result.fpzfList.length > 0) {
                        // sessionStorage.setItem("fpyj.fpzfList", JSON.stringify(result.fpzfList));
                        //dozfRefash();
                        // }
                        A.Controller.section('tax/fpyj/fpyj_add_section.html?type=update&wsid=' + wsid);
                    } else {
                        // A.hideMask();
                        A.showToast(result.msg);
                    }
                },
                error: function() {
                    //A.hideMask();
                    A.showToast('连接超时');
                }
            });
            return false;
        });
    };

    var del = function() {
        $fpyj_section.find('.btn-del').on(A.options.clickEvent, function() {
            var wsid = $(this).data('wsid');
            A.confirm('提示', '确认要删除该条信息？',
                function() {
                    rest.del({
                        url: '/fp/fpyj/delete/{wsid}',
                        urlParams: { wsid: wsid },
                        success: function(result) {
                            if (result.code == '000') {
                                A.showToast('删除成功！');
                                doRefreshFirst();
                            } else {
                                A.showToast(result.msg);
                            }
                            A.hideMask();
                        },
                        error: function() {
                            A.showToast('连接超时');
                            A.hideMask();
                        }
                    });
                },
                function() {});
            return false;
        });
    };

    /**
     * 页面初始加载
     */
    $('#fpyj_section').on('sectionshow', function() {
        var params = A.Component.params(this);
        if (params.type == '1') { //从主页来的
            resetCondition();
        }
        doRefreshFirst();
        if (sessionStorage.getItem("fpyj.jjyjList")) {
            sessionStorage.removeItem("fpyj.jjyjList");
        }
        if (sessionStorage.getItem("fpyj.fpzfList")) {
            sessionStorage.removeItem("fpyj.fpzfList");
        }
    });

    /**
     * 滑动监听
     */
    $('#fpyj_article').on('refreshInit', function() {
        var refresh = A.Refresh(this);
        refresh.on('pullup', function() {
            doRefresh();
        });
        refresh.on('pulldown', function() {
            doRefreshFirst();
        });
    });

    var initSeach = function(_this) {
        if (condition.sqrqq) {
            _this.find(".sqrqq_label").html(condition.sqrqq);
            _this.find(".sqrqq").val(condition.sqrqq);
        }
        if (condition.sqrqz) {
            _this.find(".sqrqz_label").html(condition.sqrqz);
            _this.find(".sqrqz").val(condition.sqrqz);
        }
        if (condition.wsztDm) {
            _this.find('.wsztDm option[value="' + condition.wsztDm + '"]').attr('selected', 'selected');
        }
    };

    /**
     * 查询按钮
     */
    $('#fpyj_search').on(A.options.clickEvent, function(e) {
        var $popup = new A.Popup({
            html: $('#fpyj_search_modal').html(),
            pos: 'top'
        }).on('popupopen', function() {
            var _this = this.popup;
            A.Component.datetime(_this);
            initSeach(_this);
            _this.find('.search_btn').off(A.options.clickEvent);
            _this.find('.search_btn').on(A.options.clickEvent, function() {
                condition.sqrqq = _this.find(".sqrqq").val();
                condition.sqrqz = _this.find(".sqrqz").val();
                condition.wsztDm = _this.find(".wsztDm option").not(function() { return !this.selected; }).val();
                _this.find('.wsztDm option[value="' + condition.wsztDm + '"]').attr('selected', 'selected');
                doRefreshFirst();
                $popup.close();
            });
        }).on('popupclose', function() {}).open(function() {});
        return false;
    });

    /**
     * 查询按钮
     */
    $('#fpyj_add').on(A.options.clickEvent, function(e) {
        var $popup = new A.Popup({
            html: $('#fpyj_add_modal').html(),
            pos: 'top'
        }).on('popupopen', function() {
            var _this = this.popup;
            A.Component.datetime(_this);
        }).on('popupclose', function() {}).open(function() {});
        return false;
    });
});