/**
 * Created by Li Hongwei on 2016-03-10.
 */
define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var $fpyj_info_section = $('#fpyj_info_section');

    $fpyj_info_section.on('sectionload', function() {
        A.Slider('#fpyj_info_slider', {
            dots: 'hide'
        });
    });

    $('#page1').on('scrollInit', function() {
        var scroll = A.Scroll(this);
        $(document).on('accordionshow accordiononeshow', function() {
            setTimeout(function() {
                scroll.refresh();
            }, 100);
        });
    });

    $fpyj_info_section.on('sectionshow', function() {
        var params = A.Component.params(this);
        var condition = {
            wsid: params.wsid
        };
        rest.get({
            url: '/fp/fpyj/{wsid}',
            urlParams: condition,
            success: function(result) {
                if (result.code == '000') {
                    A.template('#fpyj_info_tmpl').renderReplace(result, function() {
                        A.Scroll('#page1').refresh();
                        A.hideMask();
                    });
                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('连接超时');
            }
        });

        rest.get({
            url: '/ws/spls/{wsid}',
            urlParams: condition,
            success: function(result) {
                if (result.code == '000') {
                    A.template('#fpyj_lc_tmpl').renderReplace(result, function() {
                        A.Scroll('#page2').refresh();
                        A.hideMask();
                    });
                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('连接超时');
            }
        });
    });
});