/**
 * Created by Li Hongwei on 2016/1/25.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var utils = require('utils');

    var $sbmmdl_popup;
    var $jysb_section = $('#jysb_section');

    var tbrq;//填表日期
    var sbmm = '';

    /**
     * 获取当前日期
     * @returns {string}
     */
    var getNowFormatDate = function () {
        var date = new Date();
        var seperator1 = "";
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = "0" + month;
        }
        if (strDate >= 0 && strDate <= 9) {
            strDate = "0" + strDate;
        }
        var currentdate = year + seperator1 + month + seperator1 + strDate;
        return currentdate;
    };

    /**
     * 附加信息
     * @param value
     */
    var addInfo = function (value) {
        value.tbrq = tbrq;
        value.sbmm = sbmm;
    };

    /**
     * 获取核定信息
     */
    var getHdxx = function () {
        A.showMask('获取中');
        var data = {
            nsrsbh: localStorage.getItem('nsrsbh'),
            tbrq: tbrq
        };
        var itemlist = $jysb_section.find('.listitem');
        itemlist.empty();

        rest.get({
            url: '/dzsb/jysbhdxx?nsrsbh={nsrsbh}&tbrq={tbrq}',
            urlParams: data,
            success: function (result) {
                A.hideMask();
                if (result.code == '000') {
                    if (result.jysbxxlist.length > 0) {
                        result.jysbxxlist.map(addInfo);

                        $.each(result.jysbxxlist, function(index, item) {
                            itemlist.append('<div class="outer">' +
                                '<div class="accordionbar">所属期：' + item.sssqq + ' 至 ' + item.sssqz + '</div>' +
                                '<ul class="listitem">' +
                                '<li><div class="text">申报期限：' + item.sbqx + '</div></li>' +
                                '<li><div class="text">申报日期：' + item.sbrq + '</div></li>' +
                                '<li><div class="text">申报金额：' + nullOrEmpty(item.bqybtse) + '</em> 元</div></li>');

                            if (item.sbzt=='0') {
                                itemlist.append('<li><div class="text">申报状态：<span class="sliver">未申报</span></div></li>');
                            } else if (item.sbzt=='1') {
                                itemlist.append('<li><div class="text">申报状态：<span class="nephritis">申报成功</span></div></li>');
                            } else if (item.sbzt=='2') {
                                itemlist.append('<li><div class="text">申报状态：<span class="alizarin">申报失败</span></div></li>');
                            } else if (item.sbzt=='3') {
                                itemlist.append('<li><div class="text">申报状态：<span class="alizarin">无法申报</span></div></li>');
                            } else {
                                itemlist.append('<li><div class="text">申报状态：<span class="sliver">状态未知</span></div></li>');
                            }

                            if (item.sblx && item.sblx=='03') {
                                itemlist.append('<li class="ui-border-t t-a-r" style="padding: 8px;">暂不支持混征类型的申报</li>');
                            } else {
                                itemlist.append('<li class="ui-border-t t-a-r" style="padding: 8px;">');
                                sessionStorage.setItem('jysb.info', JSON.stringify(item));
                                if (item.sbzt=='0') {
                                    itemlist.append('<button data-toggle="section" class="operbtn" href="tax/jysb/jysb_js_section.html">申报</button>');
                                } else if (item.sbzt=='1') {
                                    itemlist.append('<button class="outline" class="operbtn" data-toggle="section" href="tax/jysb/jysb_info_section.html">详情</button>');
                                } else if (item.sbzt=='2') {
                                    itemlist.append('<button data-toggle="section" class="operbtn" href="tax/jysb/jysb_js_section.html">重新申报</button>');
                                } else if (item.sbzt=='3') {
                                    itemlist.append('<button class="outline" class="operbtn" data-toggle="section" href="tax/jysb/jysb_js_section.html">原因</button>');
                                } else {
                                    itemlist.append('状态未知，请联系');
                                }
                                itemlist.append('</li>');
                            }
                            itemlist.append('</ul></div>');
                        });
                        if ($sbmmdl_popup) {
                            $sbmmdl_popup.close();
                        }
                    } else {
                        if ($sbmmdl_popup) {
                            $sbmmdl_popup.close();
                        }
                        A.showToast('未查询到需要申报的记录');
                    }

                } else if (result.code == '501') {
                    A.showToast(result.msg);
                } else if (result.code == '514') {
                    A.showToast(result.msg);
                } else if (result.code == '513') {//密码错误
                    $('#sbmmdl_popup').find('.sbmm').val('');
                    A.showToast(result.msg);
                } else {
                    $('#sbmmdl_popup').find('.sbmm').val('');
                    A.showToast(result.msg);
                }
            },
            error: function () {
                A.hideMask('网络异常');
            }
        });
    };

    var nullOrEmpty = function (str) {
        return str ? str : '';
    };

    $jysb_section.on('sectionshow', function () {
        sessionStorage.removeItem('jysb.info');


        tbrq = getNowFormatDate();

        var params = A.Component.params(this);
        //console.log('params.type:' + params.type)
        //console.log('sbmm:' + sbmm)

        getHdxx();
        // if (!localStorage.getItem('isFirstFrom') || localStorage.getItem('isFirstFrom') == 'true') {//从主页来的
        //     localStorage.setItem('isFirstFrom', 'false');
        //     sbmm = '';
        //     $sbmmdl_popup = A.popup({
        //         html: $('#sbmmdl_template').html(),
        //         css: {width: 'auto'},
        //         pos: 'center',
        //         isBlock: true
        //     });
        //
        //     $sbmmdl_popup.popup.find('button').on(A.options.clickEvent, function () {
        //         if ($('#sbmmdl_popup').find('.sbmm').val().length < 6) {
        //             A.showToast('申报密码不能小于6位');
        //             return;
        //         }
        //         sbmm = $('#sbmmdl_popup').find('.sbmm').val();
        //
        //         getHdxx();
        //     });
        // } else {
        //     getHdxx();
        // }
        //
        // $('#sbmmdl_popup').find('.nsrmc').html(sessionStorage.getItem('nsrmc'));

    });

    $jysb_section.on('sectionhide', function () {
        A.template('#jysb_tmpl').renderReplace();
        if ($sbmmdl_popup) {
            $sbmmdl_popup.close();
        }
    });


});

