define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var QRCode = require('qrcode');

    $("#msdkfp_info_section").live('sectionload',function(){
        var params = A.Component.params(this);
        var condition = {
            wsid:params.wsid
        };

        A.showMask();
        rest.get({
            url: '/fp/zrrdk/select/{wsid}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    A.hideMask();
                    A.template('#msdkfp_info_tmpl').renderReplace(result);
                    try{
                        new QRCode('msdkfp_qrcode',{
                            text: "/fp/zrrdk/select/"+condition.wsid,
                            width: 300,
                            height: 300,
                            colorDark : '#000000',
                            colorLight : '#ffffff',
                            correctLevel : QRCode.CorrectLevel.H
                        });
                        A.Scroll("#msdkfp_info_article").refresh();
                    }catch(e){
                        A.hideMask();
                        A.showToast("生成二维码失败");
                        A.Controller.back();
                    }

                    // //文书审批历史信息
                    // rest.get({
                    //     url: '/ws/spls/{wsid}',
                    //     urlParams : condition,
                    //     success: function(result) {
                    //         if(result.code == '000') {
                    //             A.template('#msdkfp_lc_tmpl').renderReplace(result, function() {
                    //                 A.hideMask();
                    //             });
                    //         } else {
                    //             A.hideMask();
                    //             A.showToast(result.msg);
                    //         }
                    //     },
                    //     error: function() {
                    //         A.hideMask();
                    //         A.showToast('连接超时');
                    //     }
                    // });

                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('连接超时');
            }
        });

    })

});