define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require("agile");
    var rest = require("rest");
    var reqParam;

    $("#msdkfp_list_section").on("sectionshow",function(){
        reqParam = A.Component.params(this);

        if(!reqParam.sfzjhm||!reqParam.sjhm){
            A.showToast("身份证号码或手机号码不能为空");
            A.Controller.back();
            return;
        }

        queryData(reqParam.sfzjhm,reqParam.sjhm,reqParam.wsztDm);
    });

    var queryData = function(sfzjhm,sjhm,wszt){
        A.showMask();
        rest.get({
            url: "/fp/zrrdk/zrrdklist?sfzjhm="+sfzjhm+"&sjhm="+sjhm+"&wsztDm="+wszt,
            success: function (result) {
                A.hideMask();
                A.template("#msdkfp_list_tmpl").renderReplace(result,function(){
                    if(!result.list || result.list.length<=0){
                        A.showToast("未查询到发票代开信息");
                    }
                    initBtnEvent();
                });
            },
            error: function () {
                A.hideMask();
                A.showToast("查询失败");
            }
        });
    }

    var initBtnEvent = function(){
        $("#msdkfp_list_article button[name='btn-del']").off(A.options.clickEvent);
        $("#msdkfp_list_article button[name='btn-del']").on(A.options.clickEvent,function(){

            var wsid = $(this).data('wsid');
            if(!wsid){
                A.showToast("删除失败,请稍后再试");
                A.Controller.back();
            }

            A.showMask();
            rest.del({
                url: '/fp/zrrdk/delete/{wsid}',
                urlParams : {wsid : wsid},
                success: function(result) {
                    if(result.code == '000') {
                        A.showToast('删除成功！');
                        queryData(reqParam.sfzjhm,reqParam.sjhm,reqParam.wszt);
                    } else {
                        A.showToast(result.msg);
                    }
                    A.hideMask();
                },
                error: function() {
                    A.showToast('连接超时');
                    A.hideMask();
                }
            });

        });
    }
});