/**
 * Created by Li Hongwei on 2016/1/19.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var utils = require('utils');

    var $sfxyjs_js_section = $('#sfxyjs_js_section');

    $.fn.serializeObject = function (e) {
        var o = {};
        var a = this.serializeArray();
        $.each(a, function () {
            if (o[this.name]) {
                //if(this.name.split('.').length)
                if (!o[this.name].push) {
                    o[this.name] = [o[this.name]];
                }
                o[this.name].push(this.value || '');
            } else {
                var nameArr = this.name.split('.');
                if(nameArr.length > 1) {
                    if(o.hasOwnProperty(nameArr[0])) {
                        o[nameArr[0]][nameArr[1]] = this.value || '';
                    } else {
                        var b = {};
                        b[nameArr[1]] = this.value || '';
                        o[nameArr[0]] = b;
                    }
                } else {
                    o[this.name] = this.value || '';
                }
            }
        });
        return o;
    };

    $sfxyjs_js_section.on('sectionshow', function() {
        var params = A.Component.params(this);
        var nsrsbh = localStorage.getItem('nsrsbh');
        var nsrmc = sessionStorage.getItem('nsrmc');

        //详细信息
        var info = JSON.parse(params.info);
        info.nsrsbh = nsrsbh;
        info.nsrmc = nsrmc;
        A.template('#sfxyjs_info_tmpl').renderReplace(info,function() {
        });

        //三方协议信息
        var data = JSON.parse(sessionStorage.getItem('sfxyjs.sfxy'));
        data.nsrsbh=nsrsbh;
        data.yzpzxh = info.yzpzxh;//应征凭证序号
        data.kkje = info.ybtse;	//扣款金额
        A.template('#sfxy_tmpl').renderReplace(data,function() {
        });
    });

    /**
     * 缴税
     */
    $sfxyjs_js_section.find('.btn-sfxyjs').on(A.options.clickEvent, function() {
        A.confirm('提示','确定缴税?',
            function(){
                A.showMask();
                var condition =$sfxyjs_js_section.find('#sfxyjs_js_form').serializeObject();
                rest.get({
                    /*
                     nsrsbh	纳税人识别号
                     yzpzxh	应征凭证序号
                     sfxyh	三方协议号
                     kkje	扣款金额
                     */
                    url: '/dzjs/sfxyjs?nsrsbh={nsrsbh}&yzpzxh={yzpzxh}&sfxyh={sfxyh}&kkje={kkje}',
                    urlParams : condition,
                    success: function(result) {
                        if(result.code == '000') {
                        } else {
                            A.showToast(result.msg);
                        }
                        A.hideMask();
                    },
                    error: function() {
                        A.hideMask();
                        A.showToast('连接失败');
                    }
                });
            },
            function(){
                //取消事件
            });
        return false;
    });


});

