/**
 * Created by Li Hongwei on 2016/1/23.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');


    var count;//总页数

    /**
     * 查询条件
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        dzsphm : '',
        jkrqq:  '',
        jkrqz:  '',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    var resetCondition = function() {
        var $ssjkpz_search_modal = $('#ssjkpz_search_modal');

        $ssjkpz_search_modal.find('.jkrqq_label').html('请选择时间');
        $ssjkpz_search_modal.find('.jkrqz_label').html('请选择时间');
        $ssjkpz_search_modal.find('.dzsphm').attr('value','');
        $ssjkpz_search_modal.find('.jkrqq').val('');
        $ssjkpz_search_modal.find('.jkrqz').val('');
        condition.dzsphm = $ssjkpz_search_modal.find('.dzsphm').val();
        condition.jkrqq = $ssjkpz_search_modal.find('.jkrqq').val();
        condition.jkrqz = $ssjkpz_search_modal.find('.jkrqz').val();
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function() {
        A.showMask();
        rest.get({
            url: '/jkpz/list?minNum={minNum}&maxNum={maxNum}&dzsphm={dzsphm}&jkrqq={jkrqq}&jkrqz={jkrqz}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#ssjkpz_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#ssjkpz_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.list.length +'条记录');
                            }
                            nextPage();
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.showToast('未查询到相关记录');
                            A.template('#ssjkpz_tmpl').renderReplace();
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };



    /**
     * 页面初始加载
     */
    $('#ssjkpz_section').on('sectionshow', function(){
        var params = A.Component.params(this);
        if(params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        A.showMask();
        doRefresh();
        //rest.get({
        //    url: '/jkpz/list?minNum={minNum}&maxNum={maxNum}&dzsphm={dzsphm}&jkrqq={jkrqq}&jkrqz={jkrqz}',
        //    urlParams : condition,
        //    success: function(result) {
        //        if(result.code == '000') {
        //            A.template('#ssjkpz_tmpl').renderReplace(result, function() {
        //                nextPage();
        //            });
        //        } else {
        //            A.showToast(result.msg);
        //        }
        //        A.hideMask();
        //    },
        //    error: function() {
        //        A.showToast('连接超时');
        //        A.hideMask();
        //    }
        //});
    });

    /**
     * 滑动监听
     */
    $('#ssjkpz_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

    var initSeach = function(_this) {
        if(condition.jkrqq) {
            _this.find(".jkrqq").val(condition.jkrqq);
            _this.find(".jkrqq_label").html(condition.jkrqq);
        }
        if(condition.jkrqz) {
            _this.find(".jkrqz").val(condition.jkrqz);
            _this.find(".jkrqz_label").html(condition.jkrqz);
        }
        if(condition.dzsphm) {
            _this.find(".dzsphm").val(condition.dzsphm);
        }
    };

    /**
     * 查询按钮
     */
    $('#ssjkpz_search').on(A.options.clickEvent,function(e){
        //$ssjkpz_search_modal.find('.search_btn').off(A.options.clickEvent);
        //$ssjkpz_search_modal.find('.search_btn').on(A.options.clickEvent, function(){
        //    condition.dzsphm = $ssjkpz_search_modal.find('.dzsphm').val();
        //    condition.skssqq = $ssjkpz_search_modal.find('.jkrqq').val();
        //    condition.skssqz = $ssjkpz_search_modal.find('.jkrqz').val();
        //    condition.minNum = 1;
        //    condition.maxNum = 10;
        //    A.Controller.modal('#ssjkpz_search_modal');
        //});
        //A.Controller.modal('#ssjkpz_search_modal');


        var $popup = new A.Popup({
            html: $('#ssjkpz_search_modal').html(),
            pos : 'top'
        }).on('popupopen', function(){
                var _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                    condition.dzsphm = _this.find('.dzsphm').val();
                    _this.find('.dzsphm').attr('value',condition.dzsphm);
                    condition.jkrqq = _this.find('.jkrqq').val();
                    condition.jkrqz = _this.find('.jkrqz').val();
                    condition.minNum = 1;
                    condition.maxNum = 10;
                    //$('#ssjkpz_search_modal').html(_this.html());
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
        return false;
    });

});