/**
 * Created by Li Hongwei on 2016/2/16.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var count;//总页数

    /**
     * 查询条件
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        wszlDm: '10019',
        wsztDm: '',
        sqrqq: '',
        sqrqz: '',
        wsid: '',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function () {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    var resetCondition = function () {
        var $ssyhzgba_search_modal = $('#ssyhzgba_search_modal');
        $ssyhzgba_search_modal.find('.sqrqq_label').html('请选择时间');
        $ssyhzgba_search_modal.find('.sqrqz_label').html('请选择时间');
        $ssyhzgba_search_modal.find('.sqrqq').val('');
        $ssyhzgba_search_modal.find('.sqrqz').val('');
        $ssyhzgba_search_modal.find('.wsztDm option[value=""]').prop('selected', 'selected');
        condition.sqrqq = $ssyhzgba_search_modal.find('.sqrqq').val();
        condition.sqrqz = $ssyhzgba_search_modal.find('.sqrqz').val();
        $ssyhzgba_search_modal.find('.wsztDm option').removeAttr('selected');
        condition.wsztDm = '';
        condition.wszlDm = '10019';
        condition.wsid = '';
        condition.minNum = 1;
        condition.maxNum = 10;
    };

    /**
     * 刷新
     */
    var doRefresh = function () {
        A.showMask();
        rest.get({
            url: '/ws/querylist?minNum={minNum}&maxNum={maxNum}&wszlDm={wszlDm}&wsztDm={wsztDm}&sqrqq={sqrqq}&sqrqz={sqrqz}&wsid={wsid}',
            urlParams: condition,
            success: function (result) {
                if (result.code == '000') {
                    if (condition.minNum <= result.count) {
                        A.template("#ssyhzgba_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            var refresh = A.Refresh('#ssyhzgba_article');
                            refresh.refresh();
                            count = result.count;
                            if (condition.minNum > 1) {
                                A.showToast('新加载' + result.list.length + '条记录');
                            }
                            nextPage();
                            initCljgPopover();
                        });
                    } else {
                        if (condition.minNum == 1) {//加载为首页时清空
                            A.template('#ssyhzgba_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else {
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function () {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };


    var initCljgPopover = function () {
        $('.cljg_popover').on(A.options.clickEvent, function (e) {
            A.popover([{text: $(e.target).data('cueinfo')}], this);
            return false;
        });
    };

    /**
     * 页面初始加载
     */
    $('#ssyhzgba_section').on('sectionshow', function () {
        var params = A.Component.params(this);
        if (params.type == '1') {//从主页来的
            resetCondition();
        }
        condition.minNum = 1;
        condition.maxNum = 10;
        doRefresh();
    });

    /**
     * 滑动监听
     */
    $('#ssyhzgba_article').on('refreshInit', function () {
        var refresh = A.Refresh(this);
        refresh.on('pullup', function () {
            doRefresh();
        });
        refresh.on('pulldown', function () {
            condition.minNum = 1;
            condition.maxNum = 10;
            doRefresh();
        });
    });

    var initSeach = function (_this) {
        if (condition.sqrqq) {
            _this.find(".sqrqq_label").html(condition.sqrqq);
            _this.find(".sqrqq").val(condition.sqrqq);
        }
        if (condition.sqrqz) {
            _this.find(".sqrqz_label").html(condition.sqrqz);
            _this.find(".sqrqz").val(condition.sqrqz);
        }
        if (condition.wsztDm) {
            _this.find('.wsztDm option[value="' + condition.wsztDm + '"]').attr('selected', 'selected');
        }
    };

    /**
     * 查询按钮
     */
    $('#ssyhzgba_search').on(A.options.clickEvent, function (e) {
        var $popup = new A.Popup({
            html: $('#ssyhzgba_search_modal').html(),
            pos: 'top'
        }).on('popupopen', function () {
                var _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function () {
                    condition.sqrqq = _this.find(".sqrqq").val();
                    condition.sqrqz = _this.find(".sqrqz").val();
                    condition.wsztDm = _this.find(".wsztDm option").not(function () {
                        return !this.selected;
                    }).val();
                    _this.find('.wsztDm option[value="' + condition.wsztDm + '"]').attr('selected', 'selected');
                    condition.minNum = 1;
                    condition.maxNum = 10;
                    doRefresh();
                    $popup.close();
                });
            }).on('popupclose', function () {
            }).open(function () {
            });
        return false;
    });

});