/**
 * Created by ljun on 2016/07/27.
 */
define(function (require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var utils = require('utils');

    var $yjlsb_section = $('#yjlsb_section');
    var btn_yjsb = $('#btn_yjsb');
    var ssqq = $('#ssqq');
    var ssqz = $('#ssqz');
    var tip = $('#tip');
    var tbrq;//填表日期

    /**
     * 获取当前日期
     * @returns {string}
     */
    var getNowFormatDate = function () {
        var date = new Date();
        var seperator1 = "";
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = "0" + month;
        }
        if (strDate >= 0 && strDate <= 9) {
            strDate = "0" + strDate;
        }
        var currentdate = year + seperator1 + month + seperator1 + strDate;
        return currentdate;
    };

    /**
     * 获取核定信息
     */
    var getHdxx = function () {
        A.showMask('获取中');
        var data = {
            nsrsbh: localStorage.getItem('nsrsbh'),
            tbrq: tbrq,
            flag: '1' // 一键零申报标志
        };
        rest.get({
            url: '/dzsb/jysbhdxx?nsrsbh={nsrsbh}&tbrq={tbrq}&flag={flag}',
            urlParams: data,
            success: function (result) {
                //console.log(result)
                A.hideMask();
                if (result.code == '000') {
                    if (result.jysbxxlist.length > 0 && result.yjsbxxVo) {
                        var jysbxx = result.jysbxxlist[0];
                        ssqq.val(formatDateStr(jysbxx.sssqq));
                        ssqz.val(formatDateStr(jysbxx.sssqz));

                        var yjsbxxVo = result.yjsbxxVo;
                        if (jysbxx.sbzt && jysbxx.sbzt == 1) {
                            tip.html('提示：您在税款所属期 ' + formatDateStr(jysbxx.sssqq) + ' 至 ' + formatDateStr(jysbxx.sssqz) + ' 已经申报，请勿重复申报！');
                        } else if (jysbxx.sbzt && jysbxx.sbzt == 2 || jysbxx.sbzt && jysbxx.sbzt == 3) {
                            tip.html('提示：您上期存在异常申报情况，请到办税大厅进行申报！');
                        } else {
                            yjsbxxVo.sssqq = jysbxx.sssqq;
                            yjsbxxVo.sssqz = jysbxx.sssqz;
                            yjsbxxVo.tbrq = data.tbrq;
                            yjsbxxVo.sblx = jysbxx.sblx;
                            sessionStorage.setItem('yjlsb.info', JSON.stringify(yjsbxxVo));
                            btn_yjsb.show();
                            tip.html('提示：请您确认税款所属期 ' + formatDateStr(yjsbxxVo.sssqq) + ' 至 ' + formatDateStr(yjsbxxVo.sssqz) + ' 申报数据都为0，如有申报差错责任自负！');
                        }
                    } else {
                        A.showToast('未查询到需要申报的记录');
                        A.Controller.back();
                    }
                } else {
                    A.showToast(result.msg);
                    A.Controller.back();
                }
            },
            error: function () {
                A.hideMask();
                A.showToast("获取数据失败，请重试!");
                A.Controller.back();
            }
        });
    };

    $yjlsb_section.on('sectionload', function () {
        tip.html('');
        ssqq.val('');
        ssqz.val('');
    });

    $yjlsb_section.on('sectionshow', function () {
        btn_yjsb.hide();
        sessionStorage.removeItem('yjlsb.info');
        tbrq = getNowFormatDate();
        var params = A.Component.params(this);
        getHdxx();
    });

    $yjlsb_section.on('sectionhide', function () {
        tip.html('');
        ssqq.val('');
        ssqz.val('');
    });

    // listen yjsb button clickEvent
    btn_yjsb.on(A.options.clickEvent, function () {
        var data = sessionStorage.getItem('yjlsb.info');
        data = JSON.parse(data);
        if (data) {
            var nsrsbh = localStorage.getItem('nsrsbh').toString();
            if (checkData(data) && checkFpkpRecord(nsrsbh, data.sssqq, data.sssqz)) {
                A.showMask('处理中');
                var dataJysb = {
                    nsrsbh: nsrsbh,
                    nsrmc: sessionStorage.getItem('nsrmc'),
                    sbmm: data.sbmm,
                    tbrq: data.tbrq,
                    sssqq: data.sssqq,
                    sssqz: data.sssqz
                };

                rest.post({
                    url: '/dzsb/jysbjs',
                    data: {
                        nsrsbh: nsrsbh, sssqq: data.sssqq, sssqz: data.sssqz, yzzzsbhsxse: '0', skqjkjdptfpbhsxse: '0',
                        xwqymsxse: '0', wdqzdxse: '0', qtmsxse: '0', bqynsejze: '0'
                    },
                    success: function (result) {
                        if (result.code == '000') {
                            doJysb(dataJysb);
                        } else {
                            A.hideMask();
                            A.showToast(result.msg);
                            A.Controller.back();
                        }
                    },
                    error: function () {
                        A.hideMask();
                        A.showToast('零申报计算错误！');
                        A.Controller.back();
                    }
                });
            } else {
                btn_yjsb.hide();
                tip.html('提示：您本期不符合申报条件，请使用简易申报或电子申报软件进行申报！');
            }
        }
    });

    // do yjlsb
    var doJysb = function (dataJysb) {
        rest.post({
            url: '/dzsb/jysb',
            data: dataJysb,
            success: function (result) {
                A.hideMask();
                btn_yjsb.hide();
                var set_yjlsb_complete_section = function() {
                    var _controllers = A.Controller.get();
                    var _history = _controllers.section.history;
                    _history.length = 0;
                    //var html_yjlsb_section = {"url":"yjlsb_section.html","hash":"#yjlsb_section","tag":"#yjlsb_section","query":"","param":{"":''}}
                    var html_index_section = {"url":"index_section.html","hash":"#index_section","tag":"#index_section","query":"","param":{"":''}}
                    //_history.push(html_yjlsb_section);
                    _history.push(html_index_section);
                };

                set_yjlsb_complete_section();

                if(result.code == '000') {
                    A.Controller.section("tax/yjlsb/yjlsb_complete_section.html?info=" + A.JSON.stringify(result));
                }else {
                    A.Controller.section("tax/yjlsb/yjlsb_complete_section.html?info=" + A.JSON.stringify(result));
                }
            },
            error: function () {
                A.hideMask();
                A.showToast('零申报错误！');
                A.Controller.back();
            }
        });
    };

    // validate sb data
    var checkData = function (data) {
        if ((data.skskjyhbz == 'N' && data.sqczbdcqmye == 0 && data.sqfzjgqmye == 0
            && data.sqxsbdcqmye == 0 && data.sqzzsskxtqmye == 0 && data.ysfwzzszyfpbqs3 == 0
            && data.ysfwzzszyfpbqs5 == 0 && data.ysfwbqyj == 0 && data.yshwjlwzzszyfpbqs == 0
            && data.yshwjlwbqs == 0) && (data.sblx == '01' || data.sblx == '02')) {
            return true;
        } else {
            return false;
        }
    };

    // validate fpkp record
    var checkFpkpRecord = function (nsrsbh, skssqq, skssqz) {
        A.showMask('处理中');
        var flag = false;
        rest.get({
            url: '/dzsb/check?nsrsbh={nsrsbh}&skssqq={skssqq}&skssqz={skssqz}',
            urlParams: {nsrsbh: nsrsbh, skssqq: skssqq, skssqz: skssqz},
            async: false,
            success: function (result) {
                A.hideMask();
                if (result.code == '000') {
                    flag = true;
                }
            },
            error: function () {
                A.showMask();
            }
        });
        return flag;
    };

    var formatDateStr = function(str) {
        if(str && str.length == 8){
            return str = str.substring(0, 4) + "-" + str.substring(4, 6) + "-" + str.substring(6, 8);
        }else{
            return str;
        }
    }
});

