/**
 * Created by liyaoyan on 16/6/27.
 */
define(function(require,exports,module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    var $zpdk_section = $('#zpdk_section');

    var $zpdk_search=$zpdk_section.find('#zpdk_search');

    var count;//总页数

    /**
     * 查询条件
     * @type {{dzsphm: string, jkrqq: string, jkrqz: string, minNum: number, maxNum: number}}
     */
    var condition = {
        wszlDm:'15010',
        wsztDm:'',
        sqrqq:'',
        sqrqz:'',
        sbdh:'',
        minNum: 1,
        maxNum: 10
    };

    /**
     * 加载下一页
     */
    var nextPage = function() {
        condition.minNum += 10;
        condition.maxNum += 10;
    };

    /**
     * 重置查询条件
     */
    function resetCondition() {
        var $zpdk_search_modal = $('#zpdk_search_modal');
        $zpdk_search_modal.find('.sqrqq_label').html('请选择时间');
        $zpdk_search_modal.find('.sqrqz_label').html('请选择时间');
        $zpdk_search_modal.find('.sqrqq').val('');
        $zpdk_search_modal.find('.sqrqz').val('');
        $zpdk_search_modal.find('.wsztDm option[value=""]').prop('selected','selected');
        condition.sqrqq = $zpdk_search_modal.find('.sqrqq').val();
        condition.sqrqz = $zpdk_search_modal.find('.sqrqz').val();
        $zpdk_search_modal.find('.wsztDm option').removeAttr('selected');
        condition.wsztDm = '';
        condition.wszlDm = '15010';
        condition.sbdh = '';
        condition.minNum =  1;
        condition.maxNum =  10;
    }


    /**
     * 刷新
     */
    function doRefresh() {
        A.showMask();
        rest.get({
            url: '/fp/fpdk/list?minNum={minNum}&maxNum={maxNum}&wszlDm={wszlDm}&wsztDm={wsztDm}&sqrqq={sqrqq}&sqrqz={sqrqz}&sbdh={sbdh}',
            urlParams : condition,
            success: function(result) {
                if(result.code == '000') {
                    if(condition.minNum <= result.count) {
                        A.template("#zpdk_tmpl")[condition.minNum == 1 ? 'renderReplace' : 'renderAfter'](result, function () {
                            del();
                            var refresh = A.Refresh('#zpdk_article');
                            refresh.refresh();
                            count = result.count;
                            if(condition.minNum > 1) {
                                A.showToast('新加载' + result.wsList.length +'条记录');
                            }
                            nextPage();
                            initCljgPopover();

                            $("#zpdk_article button[name='btn_paytax']").off(A.options.clickEvent).on(A.options.clickEvent,function(){
                               var wsid = $(this).data("wsid");
                                sessionStorage.setItem("curwsid",wsid);
                                A.Controller.modal("#zpdk_list_yjsk_modal");
                            });
                        });
                    } else {
                        if(condition.minNum==1) {//加载为首页时清空
                            A.template('#zpdk_tmpl').renderReplace();
                            A.showToast('未查询到相关记录');
                        } else{
                            A.showToast('没有更多的信息了');
                        }
                    }
                } else {
                    A.showToast(result.msg);
                }
                A.hideMask();
            },
            error: function() {
                A.showToast('连接超时');
                A.hideMask();
            }
        });
    };

    function doRefreshFirst() {
        condition.minNum = 1;
        condition.maxNum = 10;
        doRefresh();
    }

    function del() {
        $zpdk_section.find('.btn-del').on(A.options.clickEvent, function(){
            var wsid = $(this).data('wsid');
            A.confirm('提示','确认要删除该条信息？',
                function(){
                    rest.del({
                        url: '/fp/fpdk/zzs/delete/{wsid}',
                        urlParams : {wsid : wsid},
                        success: function(result) {
                            if(result.code == '000') {
                                A.showToast('删除成功！');
                                doRefreshFirst();
                            } else {
                                A.showToast(result.msg);
                            }
                            A.hideMask();
                        },
                        error: function() {
                            A.showToast('连接超时');
                            A.hideMask();
                        }
                    });
                },
                function(){
                    //A.alarmToast('你选择了“取消”');
                });
            return false;
        });
    }




    function initCljgPopover() {
        $('.cljg_popover').on(A.options.clickEvent, function(e){
            A.popover([{text :$(e.target).data('cueinfo')}], this);
            return false;
        });
    }

    $zpdk_section.on('sectionhide',function(){
        sessionStorage.removeItem("curwsid");

        A.template('#zpdk_tmpl').renderReplace();
    });

    $zpdk_section.on('sectionshow',function () {

        $zpdk_search.off(A.options.clickEvent).on(A.options.clickEvent,function(e){

            var $popup = new A.Popup({
                html: $('#zpdk_search_modal').html(),
                pos : 'top'
            }).on('popupopen', function(){
                var _this = this.popup;
                A.Component.datetime(_this);
                initSeach(_this);
                _this.find('.search_btn').off(A.options.clickEvent);
                _this.find('.search_btn').on(A.options.clickEvent, function(){
                     condition.sqrqq = _this.find(".sqrqq").val();
                     condition.sqrqz = _this.find(".sqrqz").val();
                     condition.wsztDm = _this.find(".wsztDm option").not(function () {return !this.selected;}).val();
                     _this.find('.wsztDm option[value="' + condition.wsztDm +'"]').attr('selected','selected');
                     doRefreshFirst();
                    $popup.close();
                });
            }).on('popupclose', function(){
            }).open(function(){
            });
            return false;
        });

        doRefreshFirst();
        
    });


    /**
     * 滑动监听
     */
    $('#zpdk_article').on('refreshInit', function(){
        var refresh = A.Refresh(this);
        refresh.on('pullup', function(){
            doRefresh();
        });
        refresh.on('pulldown', function(){
            doRefreshFirst();
        });
    });

    function initSeach(_this) {
        if(condition.sqrqq) {
            _this.find(".sqrqq_label").html(condition.sqrqq);
            _this.find(".sqrqq").val(condition.sqrqq);
        }
        if(condition.sqrqz) {
            _this.find(".sqrqz_label").html(condition.sqrqz);
            _this.find(".sqrqz").val(condition.sqrqz);
        }
        if(condition.wsztDm) {
            _this.find('.wsztDm option[value="' + condition.wsztDm +'"]').attr('selected','selected');
        }
    }

    $("#zpdk_list_yjsk_modal").off('modalshow').on('modalshow',function () {

        var wsid = sessionStorage.getItem("curwsid");

        A.showMask();
        rest.get({
            url: '/fp/fpdk/zzs/select/{wsid}',
            urlParams: {
                wsid : wsid
            },
            success: function (result) {
                if(!$.isEmptyObject(result) && result.code=='000'){
                    var query = {
                        djxh: result.utWsInfo.djxh,
                        hjje: result.utFpFpdkZzs.hjje,
                        zspmDm: result.zspmDm
                    };
                    rest.get({
                        url: '/fp/fpdk/ynsk?djxh={djxh}&hjje={hjje}&zspmDm={zspmDm}',
                        urlParams: query,
                        success: function (result) {
                            A.hideMask();
                            if (result.code == '000') {
                                A.template('#zpdk_list_yjsk_tmpl').renderReplace(result);
                                A.Scroll("#zpdk_list_yjsk_article").refresh();
                                $("#zpdk_list_requestdk").off(A.options.clickEvent).on(A.options.clickEvent,function(){
                                    A.showMask();
                                    A.Controller.modal("#zpdk_list_yjsk_modal");
                                    setTimeout(function(){
                                        A.hideMask();
                                        A.Controller.section("tax/zpdk/zpdk_sfxyxx_section.html?wsid="+wsid);
                                    },500);

                                });
                            }
                        },
                        error: function () {
                            A.showToast('连接超时');
                            A.hideMask();
                        }
                    });
                }else{
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error : function(err){
                A.hideMask();
                A.showToast('查询失败');
            }
        });

    });

    // $("#zpdk_sfxyxx_list_modal").on("modalshow",function(){
    //
    //     A.showMask();
    //     rest.get({
    //         url: "/sssearch/sfxyxx",
    //         success: function (data) {
    //             A.hideMask();
    //             if(!$.isEmptyObject(data) && data.code=="000") {
    //                 if (data.sfxyxxList && data.sfxyxxList.length > 0) {
    //                     A.template("#zpdk_sfxyxx_list_tmpl").renderReplace(data, function () {
    //                         $("#zpdk_sfxyxx_list_article button[name='zpdk_set_default_btn']").off(A.options.clickEvent);
    //                         $("#zpdk_sfxyxx_list_article button[name='zpdk_set_default_btn']").on(A.options.clickEvent, function () {
    //                             var wsid = sessionStorage.getItem("wsid");
    //                             var sfxyh = $(this).data("sfxyh");
    //                             A.showMask();
    //                             rest.post({
    //                                 url: "/fp/fpdk/js/sfxy/{wsid}",
    //                                 urlParams: {
    //                                     wsid: wsid,
    //                                     sfxyh: sfxyh
    //                                 },
    //                                 success: function (data) {
    //                                     A.hideMask();
    //                                     if (!$.isEmptyObject(data) && data.code == "000") {
    //                                         A.showToast("缴税成功");
    //                                     } else {
    //                                         A.showToast("缴税失败");
    //                                     }
    //                                 },
    //                                 error: function (err) {
    //                                     A.hideMask();
    //                                     A.showToast("缴税失败");
    //                                 }
    //                             });
    //                         });
    //                     });
    //                 } else {
    //                     A.showToast("尚未签订三方协议");
    //                 }
    //             }else{
    //                 A.showToast(result.msg);
    //             }
    //         },
    //         error: function (err) {
    //             A.hideMask();
    //             A.showToast("查询失败");
    //         }
    //     });
    // });
});
