/**
 * Created by liyaoyan on 16/6/27.
 */

define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');
    var jQuery = require('jquery');
    var abcUtils = require('abc.utils');
    var math = require('math');

    var $zpdk_first_add_section = $('#zpdk_first_add_section');

    var validBuyerAndSellerForm = function() {
        var result;

        result = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwswdjh']").val();
        if (!$.trim(result)) {
            A.showToast("请输入购货方税务登记号");
            return false;
        } else if (!/^([0-9a-zA-Z]){15,20}$/.test(result)) {
            A.showToast("购货方税务登记号只能是15到20位数字或字母");
            return false;
        }
        result = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwmc']").val();
        if (!$.trim(result)) {
            A.showToast("请输入购货方名称");
            return false;
        }else if(!/^[\u0391-\uFFE5]{1,100}$/.test(result)){
            A.showToast("购货方名称只能为汉字，长度为1-100个字符");
            return false;
        }

        result = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwdz']").val();
        if (!$.trim(result)) {
            A.showToast("请输入购货方地址");
            return false;
        }else if(!/^[\u0391-\uFFE5A-Za-z0-9]{1,100}$/.test(result)){
            A.showToast("购货方地址只能为汉字字母或英文，长度为1-100个字符");
            return false;
        }

        result = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwdhhm']").val();
        if (!$.trim(result)) {
            A.showToast("请输入购货方电话");
            return false;
        } else if (!/^[0-9-]{8,15}$/.test(result)) {
            A.showToast("请填写正确的购货方座机或手机号码");
            return false;
        }

        result = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwyhkh']").val();
        if (!$.trim(result)) {
            A.showToast("请输入购货方银行账号");
            return false;
        } else if (!/^([0-9]){8,32}$/.test(result)) {
            A.showToast("购货方银行账号只能是8到32位数字");
            return false;
        }

        result = $("#zpdk_ghdwxx_info_form select[name='fpdk.ghdwyhdm']").val();
        if(!$.trim(result)){
            A.showToast("请选择购货方开户银行");
            return false;
        }

        result = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwkhyh']").val();
        if(!$.trim(result)){
            A.showToast("请输入购货方银行网点名称");
            return false;
        }else if(result.length>30){
            A.showToast("购货方银行网点名称不能超过30个字符");
            return false;
        }

        var showGoodsTransportation = $("#zpdk_ghdwxx_info_form div[name='a_hyxx']").find("input").val();
        if ($.trim(showGoodsTransportation) == '1') {
            result = $("#zpdk_ghdwxx_info_form input[name='hwysxx.qyd']").val();
            if (!$.trim(result)) {
                A.showToast("请输入购货方起运地");
                return false;
            }else if (!/^[\u0391-\uFFE5A-Za-z0-9]{1,100}$/.test(result)) {
                A.showToast("购货方起运地只能为汉字字母或英文，长度为1-100个字符");
                return false;
            }
            result = $("#zpdk_ghdwxx_info_form input[name='hwysxx.jyd']").val();
            if (!$.trim(result)) {
                A.showToast("请输入购货方经由地");
                return false;
            }else if (!/^[\u0391-\uFFE5A-Za-z0-9]{1,100}$/.test(result)) {
                A.showToast("购货方经由地只能为汉字字母或英文，长度为1-100个字符");
                return false;
            }

            result = $("#zpdk_ghdwxx_info_form input[name='hwysxx.ddd']").val();
            if (!$.trim(result)) {
                A.showToast("请输入购货方到达地");
                return false;
            }else if (!/^[\u0391-\uFFE5A-Za-z0-9]{1,100}$/.test(result)) {
                A.showToast("购货方到达地只能为汉字字母或英文，长度为1-100个字符");
                return false;
            }

            result = JSON.parse(sessionStorage.getItem("hyclList"));
            if (!result || !result.length || result.length <= 0) {
                A.showToast("请输入购请选择购货方车辆信息");
                return false;
            }
        }

        result = $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwkhyh']").val();
        if(!$.trim(result)){
            A.showToast("请选择销货方银行网点");
            return false;
        }
        result = $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwyhkh']").val();
        if(!$.trim(result)){
            A.showToast("请选择销货方开户账号");
            return false;
        }

        return true;
    }

    var validGoodsServicesForm = function() {
        var result;
        result = $("#zpdk_hwlwfwxx_form input[name='zspmDm']").val();
        if (!$.trim(result)) {
            A.showToast("请填写货物劳务服务信息");
            return false;
        }
        result = $("#zpdk_hwlwfwxx_form input[name='zspmmc']").val();
        if (!$.trim(result)) {
            A.showToast("请填写货物劳务服务信息");
            return false;
        }

        result = $("#zpdk_hwlwfwxx_form input[name='fpdk.hjse']").val();
        if (!$.trim(result)) {
            A.showToast("请选择货物劳务服务品目");
            return false;
        }

        result = $("#zpdk_hwlwfwxx_form input[name='fpdk.hjje']").val();
        if (!$.trim(result)) {
            A.showToast("请选择货物劳务服务品目");
            return false;
        }

        result = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
        if(!result || result.length<=0){
            A.showToast("请选择货物劳务服务品目");
            return false;
        }

        return true;
    }

    var validLqfsForm = function(){

        var lyfs = $("#lyfs_select").val();
        var result;
        if (lyfs != "1" && lyfs != "3") {
            result = $("#zpdk_panel_express input[name='kd.sjr']").val();
            if(!$.trim(result)){
                A.showToast("请输入选择发票快递地址");
                return false;
            }

            result = $("#zpdk_panel_express input[name='kd.dhhm']").val();
            if(!$.trim(result)){
                A.showToast("请输入选择发票快递地址");
                return false;
            }

            result = $("#zpdk_panel_express input[name='kd.dz']").val();
            if(!$.trim(result)){
                A.showToast("请输入选择发票快递地址");
                return false;
            }

            result = $("#zpdk_panel_express input[name='kd.sfzjhm']").val();
            if(!$.trim(result)){
                A.showToast("请输入选择发票快递地址");
                return false;
            }

        }
        return true;
    }

    var autoCalculate = function($target){

        var hwsl = $("#zpdk_hwys_add_article input[name='hwsl']").val()||1;
        var zsl = $("#zpdk_hwys_add_article input[name='zsl']").val();
        var hsdj = $("#zpdk_hwys_add_article input[name='hsdj']").val()||0;
        var hsje = $("#zpdk_hwys_add_article input[name='hsje']").val()||0;


        if(hwsl&&zsl){
            var pHwsl = parseFloat(hwsl);
            var pZsl = parseFloat(zsl);

            var pHsdj = parseFloat(hsdj);
            var pHsje = parseFloat(hsje);

            var pBhsdj,pBhsje,pSe;

            if($target.prop('name')=='hwsl'||$target.prop('name')=='hsdj'){
                pHsje = math.round(math.chain(pHwsl).multiply(pHsdj).done(),8);
                $("#zpdk_hwys_add_article input[name='hsje']").val(pHsje);
            }else if($target.prop('name')=='hsje'){
                pHsdj = math.round(math.chain(pHsje).divide(pHwsl).done(),8);
                if($("#zpdk_hwys_add_modal input[name='hwsl']").val())
                    $("#zpdk_hwys_add_article input[name='hsdj']").val(pHsdj);
            }else{
                return;
            }
            pBhsdj = math.round(math.chain(pHsdj).divide((math.add(1,pZsl))).done(),8);
            pBhsje = math.round(math.multiply(pHwsl,pBhsdj),8);//不含税销售额
            pSe = math.round(math.multiply(pBhsje,pZsl),2);

            $("#zpdk_hwys_add_article input[name='bhsdj']").val(pBhsdj);
            $("#zpdk_hwys_add_article input[name='bhsje']").val(pBhsje);
            $("#zpdk_hwys_add_article input[name='se']").val(pSe);
        }
    }

    var initXHFinfo = function(data) {

        $("#zpdk_xhdwxx_info_form input").each(function(){
            $(this).val(data.xhdwxx[$(this).data("initname")]);
        });

        var bankList = data.yhxxList;
        if(bankList && bankList.length>0){

            A.template("#zpdk_add_gmfyhxx_tmpl").renderReplace({yhxxList: bankList});
            A.template('#zpdk_add_yhhbsel_tmpl').renderReplace(data);
            $("#zpdk_xhdwxx_info_form select[name='fpdk.xhdwyhdm']").off("change").on("change", function () {

                var selectedVal = $(this).find("option:selected").val();
                if(!selectedVal){
                    $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwkhyh']").prop("readonly",false);
                    $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwyhkh']").prop("readonly",false);
                }else{
                    $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwkhyh']").prop("readonly",true);
                    $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwyhkh']").prop("readonly",true);
                }

                var yhzh = $(this).find("option:selected").data("yhzh");
                var yhwdmc = $(this).find("option:selected").data("yhwdmc");
                $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwkhyh']").val(yhwdmc);
                $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwyhkh']").val(yhzh);
            });
            if(bankList.length==1) {
                $("#zpdk_xhdwxx_info_form select[name='fpdk.xhdwyhdm']").val(bankList[0].yhhbDm);
                $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwkhyh']").val(bankList[0].yhyywdmc);
                $("#zpdk_xhdwxx_info_form input[name='fpdk.xhdwyhkh']").val(bankList[0].yhzh);
            }

            return true;
        }else{
            return false;
        }

    };

    var initModalEvent = function(){

        $("#zpdk_hyclxx_list_modal").on("modalshow", function() {
            initHyclxx()
        });

        $("#zpdk_hyclxx_list_modal").on("modalhide", function() {
            var sumTons = 0;
            var hyclList = JSON.parse(sessionStorage.getItem("hyclList"));
            for (var i in hyclList) {
                sumTons += hyclList[i].cldw * 100;
            }
            $("#zpdk_first_add_article input[name='hwysxx.ccdwhj']").val(sumTons / 100);
        });

        $("#zpdk_addr_add_modal").on("modalshow",function(){
            firstLoad = false;
            initAddrAddPage();
        });

        $("#zpdk_hwys_modal").on("modalshow",function(){
            var result ;
            try{
                result = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
            }catch(e){
                result = {}
                sessionStorage.removeItem("zpdk_hwys");
            }
            A.template("#zpdk_hwys_tmpl").renderReplace({hwysList:result});

        });

        $("#zpdk_hwys_modal").on("modalhide",function(){
            parseHwlwysList();
        });

        $("#zpdk_hyclxx_edit_modal").on("modalhide", function() {
            $("#zpdk_hyclxx_edit_article input").val("");
        });

        $('#zpdk_yjsk_modal').on('modalshow', function() {

            var hjse = $("#zpdk_hwlwfwxx_form input[name='fpdk.hjse']").val();
            var bhsje = $("#zpdk_hwlwfwxx_form input[name='fpdk.bhsje']").val();
            var zspmDm = $("#zpdk_hwlwfwxx_form input[name='zspmDm']").val();
            var djxh = sessionStorage.getItem('djxh');

            var hwysList = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
            var ssbm = hwysList[0].ssbm;

            var query = {
                djxh: djxh,
                hjje: bhsje,
                zspmDm: zspmDm,
                ssbm: ssbm
            };

            A.showMask();
            rest.get({
                url: '/fp/fpdk/ynsk?djxh={djxh}&hjje={hjje}&zspmDm={zspmDm}&&ssbm={ssbm}',
                urlParams: query,
                success: function(result) {
                    A.hideMask();
                    A.template("#zpdk_yjsk_tmpl").renderReplace(result)
                    A.Scroll("#zpdk_yjsk_article").refresh();

                    var totalTax = 0;
                    if (result.code == '000') {
                        for(var i in result.ynskList){
                            totalTax += parseFloat(result.ynskList[i].ynse);
                        }
                        sessionStorage.setItem("totalTax",totalTax.toFixed(2));
                    }
                },
                error: function() {
                    A.showToast('连接超时');
                    A.hideMask();
                }
            });

        });
        
        $("#zpdk_select_addr_modal").on("modalshow",function () {
            A.showMask();
            rest.get({
                url: '/fp/express/select',
                success: function (expressData) {
                    A.hideMask();
                    if(expressData && expressData.code=='000')
                        A.template("#tmpl_zpdk_addr").renderReplace(expressData);
                    else
                        A.showToast(expressData.msg);
                },
                error : function(){
                    A.hideMask();
                    A.showToast("查询快递信息失败");
                }
            });
        });

        $("#zpdk_hwys_add_modal").on("modalhide",function(){
            $("#zpdk_hwys_add_form").get(0).reset();
            $("#zpdk_hwys_add_form span[name='mc']").text("");
            $("#zpdk_hwys_add_modal input[name='hwsl']").prop("readonly",true).prop("placeholder","请选择劳务货物信息");
            $("#zpdk_hwys_add_modal input[name='hsdj']").prop("readonly",true).prop("placeholder","请选择劳务货物信息");
            $("#zpdk_hwys_add_modal input[name='hsje']").prop("readonly",true).prop("placeholder","请选择劳务货物信息");
        });

        $("#zpdk_hwys_add_modal").on("modalshow",function(){
            if($("#zpdk_hwys_add_modal input[name='ssbm']").val()){
                $("#zpdk_hwys_add_modal input[name='hwsl']").prop("readonly",false).prop("placeholder","请填写数量");
                $("#zpdk_hwys_add_modal input[name='hsdj']").prop("readonly",false).prop("placeholder","请填写单价");
                $("#zpdk_hwys_add_modal input[name='hsje']").prop("readonly",false).prop("placeholder","请输入含税销售额");
            }
        });

        $("#zpdk_hwys_list_modal").on("modalhide",function(){
            A.template("#zpdk_hwys_list_tmpl").renderReplace({});
            $("#zpdk_hwys_list_modal input[name='zpdk_query_hwys_text']").val("");
        });

        // $("#zpdk_intro_modal").on("modalhide",function(){
        //     if($("#zpdk_ghdwxx_info_form input[name='zpdk_agree_intro']").val()=="0"){
        //         A.Controller.back();
        //     }
        // });

    }

    var initInputEvent = function() {

        $("#zpdk_hwys_article button[name='hwys_update_btn']").live(A.options.clickEvent,function(){

            var hwysUUID = $(this).data("hwysuuid");

            var hwysList = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
            var target;
            for(var i in hwysList){
                if(hwysUUID==hwysList[i].hwysUUID){
                    target = hwysList[i];
                    break;
                }
            }
            if(!target){
                return;
            }

            $("#zpdk_hwys_add_article").find("input,select").each(function(){
                $(this).val(target[$(this).prop("name")]);
            });
            $("#zpdk_hwys_add_article span[name='mc']").text(target.mc);
            $("#zpdk_hwys_add_article input[name='exeType']").val("update");

            A.Controller.modal("#zpdk_hwys_add_modal");
        });

        $("#zpdk_hwys_modal button[name='hwys_del_btn']").live(A.options.clickEvent,function(){
            A.confirm("提示", "属否删除货物劳务应税信息", function() {
                A.showMask();
                var targetParentNode = $(this).parents(".hwys-block");
                var hwysUUID = $(this).data("hwysuuid");

                var hwysList = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
                for(var i in hwysList){
                    if(hwysUUID==hwysList[i].hwysUUID){
                        hwysList.splice(i,1);
                        break;
                    }
                }
                sessionStorage.setItem("zpdk_hwys",JSON.stringify(hwysList));
                A.template("#zpdk_hwys_tmpl").renderReplace({hwysList:hwysList});

                setTimeout(function(){
                    targetParentNode.remove();
                    A.showToast("删除成功");
                    A.hideMask();
                },500);
            });
        });

        $("#zpdk_hwys_add_article input[name='hwsl'],#zpdk_hwys_add_article input[name='hsdj'],#zpdk_hwys_add_article input[name='hsje']").off('input').on('input',function(){
            autoCalculate($(this));
        });

        $("#zpdk_hwys_add_article button[name='btn_saveHwys']").off(A.options.clickEvent).on(A.options.clickEvent,function(){

            if(!validHwysxx()){
                return;
            }
            if($("#zpdk_hwys_add_article input[name='hwysUUID']").val()){
                updateHwysxx();
            }else{
                saveHwysxx();
            }

        });

        $("#zpdk_btn_open_addr").off(A.options.clickEvent).on(A.options.clickEvent,function(){
            A.Controller.modal("#zpdk_select_addr_modal");
            A.Controller.modal("#zpdk_addr_add_modal");
        });

        $("#zpdk_query_nsrxx_btn").off(A.options.clickEvent).on(A.options.clickEvent, function() {
            var nsrsbh = $("#zpdk_ghdwxx_info_form input[name='fpdk.ghdwswdjh']").val();
            A.showMask();
            rest.get({
                url: "/fp/fpdk/nsrxx/{nsrsbh}",
                urlParams: {
                    nsrsbh: nsrsbh
                },
                success: function(data) {
                    A.hideMask();
                    if (!$.isEmptyObject(data) && data.code == "000") {
                        $("#zpdk_ghdwxx_info_form").find("input[data-queryval],select[data-queryval]").each(function(){
                            $(this).val(data.nsrxx[$(this).data("queryval")]);
                        });
                    } else {
                        A.showToast(data.msg);
                    }
                },
                error: function(err) {
                    A.hideMask();
                    A.showToast('查询纳税人信息');
                }
            });
        });

        $("#zpdk_btn_confirm").off(A.options.clickEvent).on(A.options.clickEvent, function(){
            A.Controller.modal("#post_service_protocol_modal");
            A.Controller.modal("#zpdk_yjsk_modal");
        });

        $("#zpdk_btn_cancel").off(A.options.clickEvent).on(A.options.clickEvent, function(){
            A.Controller.modal("#post_service_protocol_modal");
        });

        $("#hyxx-btn-container div[name='a_hyxx']").on("datachange", function() {
            var val = $(this).find("input").val();
            if (val != "1") {
                $("#hyxx-container").show();
            } else {
                $("#hyxx-container").hide();
            }
            A.Scroll("#zpdk_first_add_article").refresh();
        });

        $("#btn_save_hyclxx").on(A.options.clickEvent, function() {
            var clzlNode = $("#zpdk_hyclxx_edit_article select[name='clzlDm']");
            var clzlDm = $.trim(clzlNode.val());
            var clzlmc = $.trim(clzlNode.find("option").eq(clzlNode.attr("selectedIndex")).html());
            var clpzhm = $.trim($("#zpdk_hyclxx_edit_article input[name='clpzhm']").val());
            var cldw = $.trim($("#zpdk_hyclxx_edit_article input[name='cldw']").val());
            var id = $.trim($("#zpdk_hyclxx_edit_article input[name='id']").val());

            if (!clzlDm) {
                A.showToast('请选择车辆代码');
                return;
            } else if (clzlDm.length != 2) {
                A.showToast('车辆代码只能为2位');
                return;
            }
            if (!clpzhm) {
                A.showToast('请输入车辆牌照');
                return;
            } else if (clpzhm.length > 10) {
                A.showToast('车辆牌照不能超过10位');
                return;
            }
            if (!cldw) {
                A.showToast('请输入车辆吨位');
                return;
            } else if (!/(^([1-9][0-9]+)$|^([0-9]+\.[0-9]{1,2})$)/.test(cldw)) {
                A.showToast('车辆吨位必须为数字,不能超过两位小数');
                return;
            } else if (cldw > 500) {
                A.showToast('车辆吨位必须小于500');
                return;
            }

            var tmpObj;
            if (!id) {
                tmpObj = {
                    id: abcUtils.getUUID(8, 10),
                    clzlDm: clzlDm,
                    clpzhm: clpzhm,
                    cldw: cldw,
                    clzlmc: clzlmc
                };
            } else {
                tmpObj = {
                    id: id,
                    clzlDm: clzlDm,
                    clpzhm: clpzhm,
                    cldw: cldw,
                    clzlmc: clzlmc
                };
            }

            var hyclList;
            try {
                hyclList = JSON.parse(sessionStorage.getItem("hyclList"));
                if ($.isEmptyObject(hyclList)) {
                    hyclList = [];
                }
            } catch (e) { hyclList = []; }
            if (!id)
                hyclList.push(tmpObj);
            else {
                for (var i in hyclList) {
                    if (hyclList[i].id == id) {
                        hyclList[i].clzlDm = tmpObj.clzlDm;
                        hyclList[i].clpzhm = tmpObj.clpzhm;
                        hyclList[i].cldw = tmpObj.cldw;
                        hyclList[i].clzlmc = tmpObj.clzlmc;
                    }
                }
            }
            sessionStorage.setItem("hyclList", JSON.stringify(hyclList));
            A.Controller.modal("#zpdk_hyclxx_edit_modal");
        });

        $("#btn_open_hyclxx").on(A.options.clickEvent, function() {
            A.Controller.modal("#zpdk_hyclxx_list_modal");
        });

        $("#zpdk_hwys_list_modal button[name='zpdk_query_hwys_btn']").on(A.options.clickEvent,function(){

            var hwysText = $("#zpdk_hwys_list_modal input[name='zpdk_query_hwys_text']").val();

            if(!hwysText||hwysText.length<2){
                A.showToast("请输入两个以上的汉字进行查询");
                return;
            }

            A.showMask();
            rest.get({
                url : '/fp/fpdk/hwlw/{hwmc}',
                urlParams : {
                    hwmc : hwysText
                },
                success : function(queryData){
                    A.hideMask();
                    A.template("#zpdk_hwys_list_tmpl").renderReplace(queryData);
                    $("#zpdk_hwys_list_article li[name='zpdk_hwys_singleitem']").off(A.options.clickEvent).on(A.options.clickEvent,function(){

                        var savedHwys = JSON.parse(sessionStorage.getItem("zpdk_hwys"))||[];
                        if(savedHwys.length>0){
                            var curZspmmc = $(this).data("zspmmc");
                            var curZspmDm = $(this).data("zspmdm");
                            var curZsl = $(this).data("zsl");

                            var exeType = $("#zpdk_hwys_add_article input[name='exeType']").val();
                            if((curZspmmc!=savedHwys[0].zspmmc || curZspmDm!=savedHwys[0].zspmDm || curZsl!=savedHwys[0].zsl) && (savedHwys.length!=1 || exeType!="update")){
                                A.showToast("新增的货物或应税劳务、服务名称对应的征收品目与第一条的征收品目不符，请分别提交代开发票申请单。");
                                return;
                            }

                        }

                        $("#zpdk_hwys_add_article span[name='mc']").text($(this).text());
                        $("#zpdk_hwys_add_article input[name='zspmmc']").val($(this).data("zspmmc"));
                        $("#zpdk_hwys_add_article input[name='zspmDm']").val($(this).data("zspmdm"));
                        $("#zpdk_hwys_add_article input[name='zsl']").val($(this).data("zsl"));
                        $("#zpdk_hwys_add_article input[name='ssbm']").val($(this).data("hwbm"));

                        autoCalculate($("#zpdk_hwys_add_modal input[name='hwsl']"));

                        A.Controller.modal("#zpdk_hwys_list_modal");
                    });
                },
                error : function(){
                    A.hideMask();
                    A.showToast("查询货物劳务服务失败");
                }
            });

        });

        $("#lyfs_select").on("change",function(){
            var selectedVal = $(this).find("option:selected").val();

            // if (data.sfqyhtsp == '1') { //启用后台审批
            //     $("#zpdk_requestdk").text("申请代开");
            // } else {
            //     if (selectedVal != 3) {
            //         $("#zpdk_requestdk").text("提交并缴税");
            //     } else {
            //         $("#zpdk_requestdk").text("提交");
            //     }
            // }

            var formType = $(this).find("option:selected").data("formtype");
            if (formType == 'self') {
                $("#zpdk_panel_express").hide().find("input[name='fpdk.qprxm'],input[name='fpdk.sfzjhm'],input[name='fpdk.yddh']").prop("disabled",true);
                $("#zpdk_panel_self").show().find("input[name='fpdk.qprxm'],input[name='fpdk.sfzjhm'],input[name='fpdk.yddh']").prop("disabled",false);
            } else if(formType == 'express') {
                $("#zpdk_panel_express").show().find("input[name='fpdk.qprxm'],input[name='fpdk.sfzjhm'],input[name='fpdk.yddh']").prop("disabled",false);
                $("#zpdk_panel_self").hide().find("input[name='fpdk.qprxm'],input[name='fpdk.sfzjhm'],input[name='fpdk.yddh']").prop("disabled",true);
            }
            A.Scroll("#zpdk_first_add_article").refresh();

        }).trigger("change");

        $("#zpdk_select_addr_modal button[name='submit_btn']").live(A.options.clickEvent, function() {

            var uuid = $(this).parent().siblings("div[name=hidden-val]").find("input[name=uuid]").val();
            A.showMask();
            rest.get({
                url: "/fp/express/selectOne/{uuid}",
                urlParams: {
                    uuid: uuid
                },
                success: function(data) {
                    A.hideMask();
                    if (!data || $.isEmptyObject(data) || !data.code || data.code != "000") {
                        A.showToast("查询收货地址失败!");
                    } else if (data.code == "000") {

                        $("#lyfs_select").trigger("change");

                        var gprxm = data.data.xm;
                        var gprlxdh = data.data.dh;
                        var gprdz = data.data.provinceName + data.data.cityName + data.data.countyName + data.data.address;
                        var gprsfzjhm = data.data.sfzhm;
                        var yzbm = data.data.yzbm;
                        $("#zpdk_panel_express input[name='kd.sjr']").val(gprxm);
                        $("#zpdk_panel_express input[name='fpdk.qprxm']").val(gprxm);
                        $("#zpdk_panel_express input[name='kd.dhhm']").val(gprlxdh);
                        $("#zpdk_panel_express input[name='fpdk.yddh']").val(gprlxdh);
                        $("#zpdk_panel_express input[name='kd.dz']").val(gprdz);
                        $("#zpdk_panel_express input[name='kd.sfzjhm']").val(gprsfzjhm);
                        $("#zpdk_panel_express input[name='fpdk.sfzjhm']").val(gprsfzjhm);
                        $("#zpdk_panel_express input[name='kd.yzbm']").val(yzbm);
                        A.Controller.modal("zpdk_select_addr_modal");
                    } else {
                        A.showToast("查询收货地址失败!");
                    }
                },
                error: function() {
                    A.hideMask();
                    A.showToast("查询收货地址失败!");
                }
            });
        });

        $("#zpdk_btn_container button[name='zpdk_save_btn']").off(A.options.clickEvent).on(A.options.clickEvent,function(){

            if(!validBuyerAndSellerForm()||!validGoodsServicesForm()||!validLqfsForm())
                return;

            var wsztDm = $(this).data("wsztdm");
            var wsid = $("#zpdk_ghdwxx_info_form input[name='fpdk.wsid']").val();

            if(wsztDm=='A'){
                serializeFormAndSubmit(wsztDm,wsid);
                return;
            }

            $("#zpdk_requestdk").data("wsztdm",wsztDm).data("wsid",wsid);

            var lyfs = $("#lyfs_select").val();
            if(lyfs=='1' || lyfs=='3'){
                A.Controller.modal("#zpdk_yjsk_modal");
            }else{
                $("#zpdk_protocol_container>div").hide();
                $("#zpdk_protocol_container div[name='express_"+lyfs+"']").show();
                A.Scroll("#post_service_protocol_article").refresh();
                A.Controller.modal("#post_service_protocol_modal");
            }


        });

        $("#zpdk_requestdk").off(A.options.clickEvent).on(A.options.clickEvent, function() {
            var wsztDm = $(this).data("wsztdm");
            var wsid = $(this).data("wsid");
            serializeFormAndSubmit(wsztDm,wsid);
            A.Controller.modal("#zpdk_yjsk_modal");
        });

        $("#zpdk_intro_modal button[name='zpdk_intro_confirm']").off(A.options.clickEvent).on(A.options.clickEvent,function(){
            // $("#zpdk_ghdwxx_info_form input[name='zpdk_agree_intro']").val("1");
            A.Controller.modal("#zpdk_intro_modal");
        });

        // $("#zpdk_intro_modal button[name='zpdk_intro_cancel']").off(A.options.clickEvent).on(A.options.clickEvent,function(){
        //
        //     $("#zpdk_ghdwxx_info_form input[name='zpdk_agree_intro']").val("0")
        //
        //     A.Controller.modal("#zpdk_intro_modal");
        //     A.Controller.back();
        // });

        $("#zpdk_hyclxx_list_modal button[name='btn-clxx-edit']").live(A.options.clickEvent, function() {

            var id = $(this).siblings("input[name='hyclxxId']").val();
            var hyclList = JSON.parse(sessionStorage.getItem("hyclList"));
            for (var i in hyclList) {
                if (hyclList[i].id == id) {
                    $("#zpdk_hyclxx_edit_modal select[name='clzlDm']").val(hyclList[i].clzlDm);
                    $("#zpdk_hyclxx_edit_modal input[name='clpzhm']").val(hyclList[i].clpzhm);
                    $("#zpdk_hyclxx_edit_modal input[name='cldw']").val(hyclList[i].cldw);
                    $("#zpdk_hyclxx_edit_modal input[name='id']").val(hyclList[i].id);
                    A.Controller.modal("#zpdk_hyclxx_edit_modal");
                    break;
                }
            }

        });
        $("#zpdk_hyclxx_list_modal button[name='btn-clxx-del']").live(A.options.clickEvent, function() {
            var that = this;
            A.confirm("删除", "属否删除车辆信息", function() {
                $(that).parents(".hyxx-list-block").remove();
                var id = $(that).siblings("input[name='hyclxxId']").val();
                var hyclList = JSON.parse(sessionStorage.getItem("hyclList"));
                for (var i in hyclList) {
                    if (hyclList[i].id == id) {
                        hyclList.splice(i, 1);
                        break;
                    }
                }
                sessionStorage.setItem("hyclList", JSON.stringify(hyclList));
                initHyclxx();
            });
        });

    }

    $zpdk_first_add_section.live('sectionload', function() {
        var params = A.Component.params(this);
        sessionStorage.removeItem("zpdk_hwys");
        sessionStorage.removeItem("hyclList");
        A.Controller.modal("#zpdk_intro_modal");
        initProcess(params);
    });

    var initProcess = function (params) {

        if (params.type == 'update') {
            updateProcess(params.wsid);
        } else {
            addProcess();
        }
    }

    var updateProcess = function(wsid){

        A.showMask();
        rest.get({
            url: '/common/code/jldw',
            success: function(jldwResult) {
                if(jldwResult && jldwResult.code=='000'){
                    rest.get({
                        url: '/fp/express/select',
                        success: function(expressData) {
                            if (!$.isEmptyObject(expressData) && expressData.code == '000') {
                                rest.get({
                                    url: '/fp/fpdk/zzs/init',
                                    success: function(initResult){
                                        if(initResult && initResult.code=='000'){
                                            rest.get({
                                                url: '/fp/fpdk/zzs/select/{wsid}',
                                                urlParams: {
                                                    wsid : wsid
                                                },
                                                success: function(queryResult) {
                                                    if(queryResult && queryResult.code=='000'){
                                                        loadData(jldwResult,initResult,expressData,queryResult);
                                                    }else{
                                                        A.showToast(queryResult.msg);
                                                        A.Controller.back();
                                                    }
                                                },
                                                error: function(){

                                                },
                                                complete: function(){
                                                    A.hideMask();
                                                }
                                            });
                                        }else{
                                            A.hideMask();
                                            A.showToast(initResult.msg);
                                            A.Controller.back();
                                        }
                                    },
                                    error: function(){
                                        A.hideMask();
                                        A.showToast("初始化表单失败");
                                        A.Controller.back();
                                    }
                                });
                            } else {
                                A.hideMask();
                                A.showToast('初始化快递信息信息失败');
                                A.Controller.back();
                            }
                        },
                        error:function(){
                            A.hideMask();
                            A.showToast("查询快递信息失败");
                            A.Controller.back();
                        }
                    });
                }else{
                    A.hideMask();
                    A.showToast(jldwResult.msg);
                    A.Controller.back();
                }
            },
            error: function(){
                A.hideMask();
                A.showToast("查询计量单位失败");
                A.Controller.back();
            }
        });
    }

    var loadData = function(jldwResult,initResult,expressData,queryResult){
        if ('Y' == initResult.fpdkbz) {
            var bankCheck = initXHFinfo(initResult);
            if(!bankCheck) {
                A.showToast("未查询到有效的三方协议，不能网上在线缴税，请先到大厅签订税库银三方协议，如需填写代开申请请继续!");
            }
            var fplqfsFields = typeof(initResult.fplqfs)==="string"&&initResult.fplqfs.split(",")||[];
            var kdgsList = initResult.kdgsList;
            var lqfsList = [];
            var tmpProtocolHtmls;
            for (var i in fplqfsFields) {
                switch (fplqfsFields[i]) {
                    case "1":
                        lqfsList.push({ fplqfsDm: 1, fplqfsmc: "办税厅自取", fplqfsForm: "self" });
                        break;
                    case "3":
                        lqfsList.push({ fplqfsDm: 3, fplqfsmc: "终端自取", fplqfsForm: "self" });
                        break;
                    default:
                    {
                        for (var j in kdgsList) {
                            if (fplqfsFields[i] == kdgsList[j].fplqfsDm) {
                                kdgsList[j].fplqfsForm = "express";
                                lqfsList.push(kdgsList[j]);
                                if (tmpProtocolHtmls) {
                                    tmpProtocolHtmls = tmpProtocolHtmls.add($("<div></div>").attr("name", "express_" + kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy));
                                } else {
                                    tmpProtocolHtmls = $("<div></div>").attr("name", "express_" + kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy);
                                }
                            }
                        }
                    };
                        break;
                }
            }
            $("#zpdk_protocol_container").html(tmpProtocolHtmls);
            A.template("#zpdk_lyfs_select_tmpl").renderReplace({ lqfsList: lqfsList });
            $("#lyfs_select").trigger("change");
            A.template("#clzlDm_tmpl").renderReplace(initResult);

            $("#zpdk_ghdwxx_info_form").find("input,select").each(function(){
                var loadfield = $(this).data("loadfield");
                var loadsubfield = $(this).data("loadsubfield");
                if(queryResult[loadfield]){
                    $(this).val(queryResult[loadfield][loadsubfield]);
                }
            });
            if(queryResult.hwysxx && queryResult.hwysxx.qyd && queryResult.hwysxx.jyd && queryResult.hwysxx.ddd){
                A.Component.toggle("div[name='a_hyxx']");
                $("#hyxx-container").show();
            }


            $("#zpdk_hwlwfwxx_form").find("input,textarea").each(function(){
                var loadfield = $(this).data("loadfield");
                var loadsubfield = $(this).data("loadsubfield");
                if(!loadfield){
                    if(queryResult[loadsubfield]){
                        if($(this).get(0).tagName=="INPUT")
                            $(this).val(queryResult[loadsubfield]);
                        else
                            $(this).text(queryResult[loadsubfield]);
                    }
                    return;
                }
                if(queryResult[loadfield]){
                    if($(this).get(0).tagName=="INPUT")
                        $(this).val(queryResult[loadfield][loadsubfield]);
                    else
                        $(this).text(queryResult[loadfield][loadsubfield]);
                }
            });

            var lyfs = queryResult.utFpFpdkZzs.lqfs;
            $("#zpdk_lyfs_info_form select[name='fpdk.lqfs']").val(lyfs);

            for (var i in expressData.dataList) {
                if (expressData.dataList[i].sfmrdz == "Y") {
                    $("#zpdk_panel_express [name='kd.sjr']").val(expressData.dataList[i].xm);
                    $("#zpdk_panel_express [name='fpdk.qprxm']").val(expressData.dataList[i].xm);
                    $("#zpdk_panel_express [name='kd.dhhm']").val(expressData.dataList[i].dh);
                    $("#zpdk_panel_express [name='fpdk.yddh']").val(expressData.dataList[i].dh);
                    $("#zpdk_panel_express [name='kd.dz']").val(expressData.dataList[i].provinceName + expressData.dataList[i].cityName + expressData.dataList[i].countyName + expressData.dataList[i].address);
                    $("#zpdk_panel_express [name='kd.sfzjhm']").val(expressData.dataList[i].sfzhm);
                    $("#zpdk_panel_express [name='fpdk.sfzjhm']").val(expressData.dataList[i].sfzhm);
                    $("#zpdk_panel_express [name='kd.yzbm']").val(expressData.dataList[i].yzbm);
                }
            }
            A.template("#tmpl_zpdk_addr").renderReplace(expressData);

            if(lyfs=="1" || lyfs=="3"){
                $("#zpdk_panel_self").find("input,select").each(function(){
                    var loadfield = $(this).data("loadfield");
                    var loadsubfield = $(this).data("loadsubfield");
                    if(queryResult[loadfield]){
                        $(this).val(queryResult[loadfield][loadsubfield]);
                    }
                });
            }else{
                $("#zpdk_panel_express").find("input,select").each(function(){
                    var loadfield = $(this).data("loadfield");
                    var loadsubfield = $(this).data("loadsubfield");
                    if(queryResult[loadfield]){
                        $(this).val(queryResult[loadfield][loadsubfield]);
                    }
                });
            }

            var hwysList = queryResult.utFpFpdkZzsHwList;
            for (var i in hwysList) {
                hwysList[i].hwysUUID = abcUtils.getUUID(8, 2);
                hwysList[i].zspmmc = queryResult.zspmmc;
            }
            sessionStorage.setItem("zpdk_hwys",JSON.stringify(hwysList));

            var hyclList = queryResult.hwysList;
            for (var i in hyclList) {
                hyclList[i].id = abcUtils.getUUID(8, 2);
            }
            sessionStorage.setItem("hyclList",JSON.stringify(hyclList));

            initInputEvent();
            initModalEvent();

        }else{
            A.showToast("您无权代开发票");
            A.Controller.back();
        }
    }

    var queryInitData = function(){
        rest.get({
            url: '/fp/fpdk/zzs/init',
            success: function(data) {
                A.hideMask();
                if (!$.isEmptyObject(data) && data.code == '000') {
                    if ('Y' == data.fpdkbz) {
                        // if (data.sfqyhtsp == '1') { //启用后台审批
                        //     $("#zpdk_requestdk").text("申请代开");
                        // } else {
                        //     $("#zpdk_requestdk").text("保存并缴税");
                        // }
                        var bankCheck = initXHFinfo(data);
                        if(!bankCheck) {
                            A.showToast("未查询到有效的三方协议，不能网上在线缴税，请先到大厅签订税库银三方协议，如需填写代开申请请继续!");
                        }

                        var fplqfsFields = typeof(data.fplqfs)==="string"&&data.fplqfs.split(",")||[];
                        var kdgsList = data.kdgsList;
                        var lqfsList = [];
                        var tmpProtocolHtmls;

                        for (var i in fplqfsFields) {
                            switch (fplqfsFields[i]) {
                                case "1":
                                    lqfsList.push({ fplqfsDm: 1, fplqfsmc: "办税厅自取", fplqfsForm: "self" });
                                    break;
                                case "3":
                                    lqfsList.push({ fplqfsDm: 3, fplqfsmc: "终端自取", fplqfsForm: "self" });
                                    break;
                                default:
                                {
                                    for (var j in kdgsList) {
                                        if (fplqfsFields[i] == kdgsList[j].fplqfsDm) {
                                            kdgsList[j].fplqfsForm = "express";
                                            lqfsList.push(kdgsList[j]);
                                            if (tmpProtocolHtmls) {
                                                tmpProtocolHtmls = tmpProtocolHtmls.add($("<div></div>").attr("name", "express_" + kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy));
                                            } else {
                                                tmpProtocolHtmls = $("<div></div>").attr("name", "express_" + kdgsList[j].fplqfsDm).html(kdgsList[j].fwxy);
                                            }
                                        }
                                    }
                                };
                                    break;
                            }
                        }
                        $("#zpdk_protocol_container").html(tmpProtocolHtmls);
                        A.template("#zpdk_lyfs_select_tmpl").renderReplace({ lqfsList: lqfsList });
                        $("#lyfs_select").trigger("change");
                        A.template("#clzlDm_tmpl").renderReplace(data);
                        initInputEvent();
                        initModalEvent();
                    } else {
                        A.showToast('您目前无权代开发票');
                        A.Controller.back();
                    }
                } else {
                    A.showToast(data.msg);
                    A.Controller.back();
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('初始化专票代开失败');
                A.Controller.back();
            }
        });
    }

    var addProcess = function(){
        A.showMask();
        rest.get({
            url: '/common/code/jldw',
            success: function(jldwData) {
                if (!$.isEmptyObject(jldwData) && jldwData.code == '000') {
                    A.template('#zpdk_add_jldwsel_tmpl').renderReplace(jldwData);
                    A.template('#zpdk_hwys_jldw_tmpl').renderReplace(jldwData);

                    rest.get({
                        url: '/fp/express/select',
                        success: function(expressData) {
                            if (!$.isEmptyObject(expressData) && expressData.code == '000') {
                                for (var i in expressData.dataList) {
                                    if (expressData.dataList[i].sfmrdz == "Y") {
                                        $("#zpdk_panel_express [name='kd.sjr']").val(expressData.dataList[i].xm);
                                        $("#zpdk_panel_express [name='fpdk.qprxm']").val(expressData.dataList[i].xm);
                                        $("#zpdk_panel_express [name='kd.dhhm']").val(expressData.dataList[i].dh);
                                        $("#zpdk_panel_express [name='fpdk.yddh']").val(expressData.dataList[i].dh);
                                        $("#zpdk_panel_express [name='kd.dz']").val(expressData.dataList[i].provinceName + expressData.dataList[i].cityName + expressData.dataList[i].countyName + expressData.dataList[i].address);
                                        $("#zpdk_panel_express [name='kd.sfzjhm']").val(expressData.dataList[i].sfzhm);
                                        $("#zpdk_panel_express [name='fpdk.sfzjhm']").val(expressData.dataList[i].sfzhm);
                                        $("#zpdk_panel_express [name='kd.yzbm']").val(expressData.dataList[i].yzbm);
                                    }
                                }
                                A.template("#tmpl_zpdk_addr").renderReplace(expressData);
                                queryInitData();

                            } else {
                                A.hideMask();
                                A.showToast('初始化快递信息信息失败');
                                A.Controller.back();
                            }
                        },
                        error: function() {
                            A.hideMask();
                            A.showToast('初始化快递信息信息失败');
                            A.Controller.back();
                        }
                    });
                } else {
                    A.hideMask();
                    A.showToast('初始化计量单位信息失败');
                    A.Controller.back();
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('初始化计量单位信息失败');
                A.Controller.back();
            }
        });


    }

    var initAddrAddPage = function(){
        getDistrict(1);

        $("#zpdk_addr_add_article button[name='submit_addr']").off(A.options.clickEvent).on(A.options.clickEvent,function(){
            var reqParam = {};
            $("#zpdk_addr_add_article").find("input,select").each(function(){
                // if($(this).prop("name")=="sfmrdz"){
                //     if($(this).is(":checked")){
                //         reqParam.sfmrdz="Y";
                //     }else{
                //         reqParam.sfmrdz="N";
                //     }
                // }else
                if($(this).get(0).tagName=="SELECT"){
                    reqParam[$(this).prop("name")] = $(this).val();
                    reqParam[$(this).prop("name")+"Name"] = $(this).find("option:selected").html();
                }else {
                    reqParam[$(this).prop("name")] = $(this).val();
                }
            });

            reqParam.sfmrdz = $("#zpdk_addr_add_modal div[name='sfmrdz'] input").val()==0?"N":"Y";

            reqParam.djxh = sessionStorage.getItem("djxh");
            reqParam.roleid = sessionStorage.getItem("roleId");
            if(!reqParam.xm){
                A.showToast("请输入姓名!");
                return;
            }
            if(!/^[\u0391-\uFFE5]{2,8}$|^([A-Za-z]{1,10}\s?){1,3}$/.test(reqParam.xm)){
                A.showToast("姓名不合法!");
                return;
            }

            if(!reqParam.dh){
                A.showToast("请输入电话号码!");
                return;
            }
            if(!/^1[3-9]\d{9}$/.test(reqParam.dh)){
                A.showToast("手机号码格式不合法!");
                return;
            }

            if(!reqParam.sfzhm){
                A.showToast("请输入身份证号码!");
                return;
            }

            if(!/^\d{6}(19|2\d)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)?$/.test(reqParam.sfzhm)){
                A.showToast("身份证号码格式不合法!");
                return;
            }

            if(!reqParam.province){
                A.showToast("请选择省/直辖市!");
                return;
            }
            if(!reqParam.city){
                A.showToast("请选择市!");
                return;
            }
            if(!reqParam.county){
                A.showToast("请选择区/县!");
                return;
            }
            if(!reqParam.address){
                A.showToast("请输入街道地址!");
                return;
            }
            if(reqParam.address.length>32){
                A.showToast("街道地址不能超过32个字符!");
                return;
            }

            if(!reqParam.yzbm){
                A.showToast("请输入邮政编码!");
                return;
            }
            if(reqParam.yzbm.length!=6){
                A.showToast("邮政编码格式不合法!");
                return;
            }
            A.showMask();
            rest.post({
                url : "/fp/express/insert",
                data : reqParam,
                success : function(data){
                    A.hideMask();
                    if(!data || $.isEmptyObject(data)){
                        A.showToast("保存收货地址失败!");
                    }else if(data.code!="000" && data.msg){
                        A.showToast(data.msg);
                    }else if(data.code=="000" && data.msg){
                        A.showToast(data.msg);

                        $("#lyfs_select").trigger("change");

                        $("#zpdk_panel_express [name='kd.sjr']").val(reqParam.xm);
                        $("#zpdk_panel_express [name='fpdk.qprxm']").val(reqParam.xm);
                        $("#zpdk_panel_express [name='kd.dhhm']").val(reqParam.dh);
                        $("#zpdk_panel_express [name='fpdk.yddh']").val(reqParam.dh);
                        $("#zpdk_panel_express [name='kd.dz']").val(reqParam.provinceName + reqParam.countyName + reqParam.cityName + reqParam.address);
                        $("#zpdk_panel_express [name='kd.sfzjhm']").val(reqParam.sfzhm);
                        $("#zpdk_panel_express [name='fpdk.sfzjhm']").val(reqParam.sfzhm);
                        $("#zpdk_panel_express [name='kd.yzbm']").val(reqParam.yzbm);

                        A.Controller.modal("#zpdk_addr_add_modal");
                    }else{
                        A.showToast("保存收货地址失败!");
                    }
                },
                error : function(){
                    A.hideMask();
                    A.showToast("保存收货地址失败!");
                }
            });
        });

        $("#zpdk_addr_add_article select[name='province']").off("change");
        $("#zpdk_addr_add_article select[name='province']").on("change",function(){
            A.showMask();
            getDistrict(2,function(){A.hideMask();});
            $("#county").html(A.template('#tmpl_county').render({}));
        });

        $("#zpdk_addr_add_article select[name='city']").off("change");
        $("#zpdk_addr_add_article select[name='city']").on("change",function(){
            A.showMask();
            getDistrict(3,function(){A.hideMask();});
        });
    }

    var getDistrict = function(districtType,callBack){
        if(!districtType){
            A.showToast("获取行政区域信息失败!");
            return;
        }

        var params = {};
        var url = "/fp/express/init?xzqhjc={xzqhjc}";
        params.xzqhjc = districtType;
        if(districtType=="2"){
            params.sjxzqhszDm = $("#zpdk_addr_add_article select[name='province']").val();
            url += "&sjxzqhszDm={sjxzqhszDm}";
        }else if(districtType=="3"){
            params.sjxzqhszDm = $("#zpdk_addr_add_article select[name='city']").val();
            url += "&sjxzqhszDm={sjxzqhszDm}";
        }

        rest.get({
            url : url,
            urlParams : params,
            success : function(data){
                if(districtType==1) {
                    A.template('#tmpl_zpdk_province').renderReplace(data);
                }else if(districtType==2){
                    A.template('#tmpl_zpdk_city').renderReplace(data);
                }else if(districtType==3){
                    A.template('#tmpl_zpdk_county').renderReplace(data);
                }
                if(callBack) callBack();
            },
            error : function(){
                A.hideMask();
                A.showToast("获取行政区域信息失败!");
            }
        });
    };

    var initHyclxx = function() {
        var hyclxx = {
            hyclList: JSON.parse(sessionStorage.getItem("hyclList"))
        }
        A.template("#zpdk_hyclxx_list_tmpl").renderReplace(hyclxx);
    }

    var validHwysxx = function(){
        var val = $("#zpdk_hwys_add_article span[name='mc']").text();
        if(!val){
            A.showToast("货物劳务名称不能为空");
            return false;
        }
        if(val.length>25){
            A.showToast("货物劳务名称不能超过25个字符");
            return false;
        }

        val = $("#zpdk_hwys_add_article input[name='ggxh']").val();
        if(val&&val.length>10){
            A.showToast("规格型号不能超过10个字符");
            return false;
        }

        val = $("#zpdk_hwys_add_article input[name='hwsl']").val();

        if(val && !/(^[0-9]{1,11}\.\d{4}$)|(^[0-9]{1,12}\.\d{3}$)|(^[0-9]{1,13}\.\d{2}$)|(^[0-9]{1,13}\.\d$)|(^[0-9]{1,15}$)/.test(val)){
            A.showToast("数量位数不能超过15位，小数不能超过4位");
            return false;
        }

        val = $("#zpdk_hwys_add_article input[name='hsdj']").val();
        if(val && !/^[0-9]{1,15}\.\d{1,8}$|^[0-9]{1,15}$/.test(val) || ((val.indexOf(".")>=0 && val.length<17) && (val.indexOf(".")<0 && val.length<16))){
            A.showToast("含税单价需小于15位的整数或整数加1-8位小数");
            return false;
        }

        val = $("#zpdk_hwys_add_article input[name='hsje']").val();
        if(!val){
            A.showToast("含税销售额不能为空");
            return false;
        }
        if(!/^[0-9]{1,15}\.\d{1,8}$|^[0-9]{1,15}$/.test(val) || ((val.indexOf(".")>=0 && val.length<17) && (val.indexOf(".")<0 && val.length<16))){
            A.showToast("含税销售额需小于15位的整数或整数加1-8位小数");
            return false;
        }
        return true;

    }

    var saveHwysxx = function(){
        A.showMask();
        var hwysUUID = abcUtils.getUUID(8, 10);

        var hwysParam = {wsid : '', mc : '', ggxh : '', jldw : '', hwsl : '', hsdj : '', bhsdj : '', bhsje : '', zsl : '', se : '', zspmDm : '', hwysUUID:''};

        var formField = {};
        $("#zpdk_hwys_add_article input,#zpdk_hwys_add_article select").each(function(){
            formField[$(this).prop('name')] = $(this).val();
        });
        //名称
        formField.mc = $("#zpdk_hwys_add_article span[name='mc']").text();
        //计量单位名称
        if(formField.jldw)
            formField.jldwmc = $("#zpdk_hwys_add_article select[name=jldw] option:selected").text();
        else
            formField.jldwmc = "";
        //临时唯一标识
        formField.hwysUUID = hwysUUID;
        $.extend(true,hwysParam,formField);

        var storedHwys = JSON.parse(sessionStorage.getItem("zpdk_hwys"))||[];
        storedHwys.push(hwysParam);
        sessionStorage.setItem("zpdk_hwys",JSON.stringify(storedHwys));
        A.showToast("保存完成");
        A.Controller.modal("#zpdk_hwys_add_modal");
        A.hideMask();
    }

    var updateHwysxx = function(){
        A.showMask();
        var hwysUUID = abcUtils.getUUID(8, 10);
        var hwysParam = {wsid : '', mc : '', ggxh : '', jldw : '', hwsl : '', hsdj : '', bhsdj : '', bhsje : '', zsl : '', se : '', zspmDm : '', hwysUUID:hwysUUID};

        var formField = {};
        $("#zpdk_hwys_add_modal input,#zpdk_hwys_add_modal select").each(function(){
            formField[$(this).prop('name')] = $(this).val();
        });

        //名称
        formField.mc = $("#zpdk_hwys_add_modal span[name='mc']").text();
        //计量单位名称
        if(formField.jldw)
            formField.jldwmc = $("#zpdk_hwys_add_modal select[name=jldw] option:selected").text();
        else
            formField.jldwmc = "";
        $.extend(true,hwysParam,formField);
        var storedHwys = JSON.parse(sessionStorage.getItem("zpdk_hwys"))||[];
        for(var i=0;i<storedHwys.length;i++){
            if(hwysParam.hwysUUID==storedHwys[i].hwysUUID){
                storedHwys.splice(i,1);
                break;
            }
        }
        storedHwys.push(hwysParam);
        sessionStorage.setItem("zpdk_hwys",JSON.stringify(storedHwys));
        A.showToast("保存完成");
        A.Controller.modal("#zpdk_hwys_add_modal");
        A.hideMask();
    }

    var parseHwlwysList = function(){
        var hwysList = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
        var sumSe = 0,sumSjhj=0,sumBhsje=0,zspmdm,zspmmc;
        for(var i in hwysList){
            zspmdm = hwysList[i].zspmDm;
            zspmmc = hwysList[i].zspmmc;
            sumSe = math.add(sumSe,hwysList[i].se);
            sumSjhj = math.add(sumSjhj,hwysList[i].hsje);
            sumBhsje = math.add(sumBhsje,hwysList[i].bhsje);
        }
        sumSjhj = math.round(sumSjhj,2);
        sumSe = math.round(sumSe,2);
        sumBhsje = math.round(sumBhsje,2);
        $("#zpdk_hwlwfwxx_form input[name='fpdk.hjje']").val(sumSjhj);
        $("#zpdk_hwlwfwxx_form input[name='fpdk.hjse']").val(sumSe);
        $("#zpdk_hwlwfwxx_form input[name='fpdk.bhsje']").val(sumBhsje);
        $("#zpdk_hwlwfwxx_form input[name='zspmDm']").val(zspmdm);
        $("#zpdk_hwlwfwxx_form input[name='zspmmc']").val(zspmmc);
    }

    var serializeFormAndSubmit = function(wsztDm, wsid){

        if(!wsztDm){
            A.showToast("表单加载有误，请退出重新填写表单")
            return;
        }

        $.fn.serializeObject = function(e) {
            var o = {};
            var a = this.serializeArray();
            $.each(a, function() {
                if (o[this.name]) {
                    if (!o[this.name].push) {
                        o[this.name] = [o[this.name]];
                    }
                    o[this.name].push(this.value || '');
                } else {
                    var nameArr = this.name.split('.');
                    if (nameArr.length > 1) {
                        if (o.hasOwnProperty(nameArr[0])) {
                            o[nameArr[0]][nameArr[1]] = this.value || '';
                        } else {
                            var b = {};
                            b[nameArr[1]] = this.value || '';
                            o[nameArr[0]] = b;
                        }
                    } else {
                        o[this.name] = this.value || '';
                    }
                }
            });
            return o;
        };

        var requestParam = {
            fpdk : {},
            hwList : [],
            kd : {},
            wsztDm : wsztDm,
            hwysxx : {},
            hwysList : [],
            zspmDm : ""
        };

        var gmfFormObject,xhfFormObject,hwysFormObject,lyfsFormObject;
        gmfFormObject = $("#zpdk_ghdwxx_info_form").serializeObject();
        delete gmfFormObject.a_hyxx;
        xhfFormObject = $("#zpdk_xhdwxx_info_form").serializeObject();
        hwysFormObject = $("#zpdk_ghxx_info_form").serializeObject();
        lyfsFormObject = $("#zpdk_lyfs_info_form").serializeObject();

        $.extend(true,requestParam,gmfFormObject,xhfFormObject,hwysFormObject,lyfsFormObject);

        requestParam.hwList = JSON.parse(sessionStorage.getItem("zpdk_hwys"));
        requestParam.hwysList = JSON.parse(sessionStorage.getItem("hyclList"));

        // console.log(requestParam);

        A.showMask();
        var url;
        if (wsid) {
            url = '/fp/fpdk/zzs/edit/' + wsid;

        } else {
            url = '/fp/fpdk/zzs/add';
        }
        rest.post({
            url: url,
            data: requestParam,
            success: function(result) {
                if (result.code == '000') {
                    if (wsztDm == "B") {
                        var lyfs = $("#lyfs_select").val();
                        if (lyfs != 3) {
                            A.hideMask();
                            var totalTax = sessionStorage.getItem("totalTax");
                            if (totalTax <= 1) {
                                A.hideMask();
                                A.showToast("应纳税额不足1元，无需缴税");
                                A.Controller.back();
                            } else {
                                A.Controller.section("tax/zpdk/zpdk_sfxyxx_section.html?wsid=" + result.wsid);
                            }
                        } else {
                            A.showToast('操作成功，请到办税厅自助终端机办理发票代开业务');
                            A.Controller.back();
                        }
                    }else{
                        A.showToast('保存草稿成功');
                        A.Controller.back();
                    }
                    // if (wsztDm == "B") {
                    //     var totalTax = sessionStorage.getItem("totalTax");
                    //     if (lyfs != 3) {
                    //         A.showToast('操作成功');
                    //         if(totalTax<=1){
                    //             A.showToast("应纳税额不足1元，无需缴税");
                    //             A.Controller.modal("#zpdk_yjsk_modal");
                    //             A.Controller.back();
                    //         } else {
                    //             rest.get({
                    //                 url: "/sssearch/sfxyxx",
                    //                 success: function(data) {
                    //                     if (!$.isEmptyObject(data) && data.code == "000") {
                    //                         if (data.sfxyxxList && data.sfxyxxList.length > 0) {
                    //                             A.template("#sfxyxx_list_tmpl").renderReplace(data, function() {
                    //                                 A.Controller.modal("#sfxyxx_list_modal");
                    //                             });
                    //                         } else {
                    //                             A.showToast("尚未签订三方协议");
                    //                             A.Controller.modal("#zpdk_yjsk_modal");
                    //                             A.Controller.back();
                    //                         }
                    //                     } else {
                    //                         A.showToast(result.msg);
                    //                         A.Controller.modal("#zpdk_yjsk_modal");
                    //                         A.Controller.back();
                    //                     }
                    //                 },
                    //                 error: function(err) {
                    //                     A.hideMask();
                    //                     A.showToast(result.msg);
                    //                     A.Controller.modal("#zpdk_yjsk_modal");
                    //                     A.Controller.back();
                    //                 }
                    //             });
                    //         }
                    //     } else {
                    //         A.showToast('操作成功，请到办税厅自助终端机办理发票代开业务');
                    //         A.Controller.modal("#zpdk_yjsk_modal");
                    //     }
                    // } else {
                    //     A.showToast('操作成功');
                    //     A.Controller.back();
                    // }
                } else {
                    A.hideMask();
                    A.showToast(result.msg);
                }
            },
            error: function() {
                A.hideMask();
                A.showToast('连接超时');
            }
        });

    }

});