define(function(require, exports, module) {
    var $ = require("zepto");
    var A = require('agile');
    var rest = require('rest');

    $("#zpdk_sfxyxx_section").live("sectionload",function(){
        var params = A.Component.params(this);
        initSfxyxx(params.wsid);
    });

    var initSfxyxx = function(wsid){
        if(!wsid){
            A.showToast("未查询到文书id，查询三方协议失败");
            return;
        }

        A.showMask();
        rest.get({
            url: "/sssearch/sfxyxx",
            success: function(data) {
                A.hideMask();
                if (!$.isEmptyObject(data) && data.code == "000") {
                    data.wsid = wsid;
                    if (data.sfxyxxList && data.sfxyxxList.length > 0) {
                        A.template("#zpdk_sfxyxx_list2_tmpl").renderReplace(data);
                        initBtnEvent();
                    } else {
                        A.showToast("尚未签订三方协议");
                    }
                } else {
                    A.showToast(result.msg);
                    A.Controller.modal("#zpdk_yjsk_modal");
                    A.Controller.back();
                }
            },
            error: function(err) {
                A.hideMask();
                A.showToast("查询三方协议失败");
            }
        });
    }

    var initBtnEvent = function(){
        $("#zpdk_sfxyxx_article button[name='zpdk_sfxyxx_paytax_btn']").off(A.options.clickEvent).on(A.options.clickEvent,function(){
            var sfxyh = $(this).data("sfxyh");
            var wsid = $(this).data("wsid");
            if(!sfxyh||!wsid){
                A.showToast("请选择三方协议");
                return;
            }
            A.showMask();
            rest.post({
                url: "/fp/fpdk/js/sfxy/{wsid}",
                urlParams: {
                    wsid: wsid,
                    sfxyh: sfxyh
                },
                success: function(data) {
                    A.hideMask();
                    if (!$.isEmptyObject(data) && data.code == "000") {
                        A.showToast("缴税成功");
                    } else {
                        A.showToast("缴税失败");
                    }
                    A.Controller.back();
                },
                error: function(err) {
                    A.hideMask();
                    A.showToast("缴税失败");
                }
            });
        });
    }

});