/**
 * Created by Li Hongwei on 2016/1/24.
 */
define(function(require, exports, module) {
    var rest = require('rest');

    module.exports = {
        isFromIndex: isFromIndex,
        setFromIndex: setFromIndex,
        getFirstAndLastMonthDay: getFirstAndLastMonthDay,
        getNowDay: getNowDay,
        getLastYearFirstPreDay: getLastYearFirstPreDay,
        getPreDay: getPreDay,
        getLastPreDay: getLastPreDay,
        getFirstPreDay: getFirstPreDay,
        compareToDate: compareToDate,
        privateCode: privateCode
    };

    /**
     * 是否来自首页
     * @returns {boolean}
     */
    function isFromIndex() {
        if (!localStorage.getItem('isFirstFrom') || localStorage.getItem('isFirstFrom') == 'true') {
            localStorage.setItem('isFirstFrom', 'false');
            return true;
        }
        return false;
    }

    function setFromIndex() {
        localStorage.setItem('isFirstFrom', 'true');
    }

    function getNowDay() {
        var oNowDate = new Date();
        var sYear = oNowDate.getFullYear();
        var sMonth = oNowDate.getMonth() + 1;
        var sDate = oNowDate.getDate();
        sMonth = sMonth < 10 ? ('0' + sMonth) : sMonth;
        sDate = sDate < 10 ? ('0' + sDate) : sDate;
        return sYear + '-' + sMonth + '-' + sDate;
    }


    function getPreDay() {
        var oNowDate = new Date();
        var preDate = new Date(oNowDate.getFullYear(), oNowDate.getMonth() - 1, oNowDate.getDate()); //上个月
        var sYear = preDate.getFullYear();
        var sMonth = preDate.getMonth() + 1;
        var sDate = preDate.getDate();
        sMonth = sMonth < 10 ? ('0' + sMonth) : sMonth;
        sDate = sDate < 10 ? ('0' + sDate) : sDate;
        return sYear + '-' + sMonth + '-' + sDate;
    }

    function getFirstAndLastMonthDay(_isLast) {
        var oNowDate = new Date();
        var sYear = oNowDate.getFullYear();
        var sMonth = oNowDate.getMonth() + 1;
        var sDate;
        if (_isLast) {
            var oDay = new Date(sYear, sMonth, 0);
            sDate = sYear + '-' + sMonth + '-' + oDay.getDate();
        } else {
            sDate = sYear + '-' + sMonth + '-01';
        }
        return sDate;
    }

    function getFirstNowDay() {
        var oNowDate = new Date();
        var sYear = oNowDate.getFullYear();
        var sMonth = oNowDate.getMonth() + 1;
        var sDate = sYear + '-' + sMonth + '-01';
        return sDate;
    }


    function getLastYearFirstPreDay(str) {
        var _str = '-';
        if (arguments[0] != undefined) {
            _str = str;
        }
        var oNowDate = new Date();
        var preDate = new Date(oNowDate.getFullYear(), oNowDate.getMonth() - 1, oNowDate.getDate()); //上个月
        var sYear = preDate.getFullYear() - 1;
        var sMonth = preDate.getMonth() + 1;
        sMonth = sMonth < 10 ? ('0' + sMonth) : sMonth;
        return sYear + _str + sMonth + _str + '01';
    }

    function getFirstPreDay(str) {
        var _str = '-';
        if (arguments[0] != undefined) {
            _str = str;
        }
        var oNowDate = new Date();
        var preDate = new Date(oNowDate.getFullYear(), oNowDate.getMonth() - 1, oNowDate.getDate()); //上个月
        var sYear = preDate.getFullYear();
        var sMonth = preDate.getMonth() + 1;
        sMonth = sMonth < 10 ? ('0' + sMonth) : sMonth;
        return sYear + _str + sMonth + _str + '01';
    }

    function getLastNowDay() {
        var oNowDate = new Date();
        var sYear = oNowDate.getFullYear();
        var sMonth = oNowDate.getMonth() + 1;
        var oDay = new Date(sYear, sMonth, 0);
        var sDate = sYear + '-' + sMonth + '-' + oDay.getDate();
        return sDate;
    }

    function getLastPreDay(str) {
        var _str = '-';
        if (arguments[0] != undefined) {
            _str = str;
        }
        var oNowDate = new Date();
        var preDate = new Date(oNowDate.getFullYear(), oNowDate.getMonth() - 1, oNowDate.getDate()); //上个月
        var sYear = preDate.getFullYear();
        var sMonth = preDate.getMonth() + 1;

        var oDay = new Date(sYear, sMonth, 0);
        sMonth = sMonth < 10 ? ('0' + sMonth) : sMonth;
        var sDate = sYear + _str + sMonth + _str + oDay.getDate();
        return sDate;
    }

    // dateStr + n天与当前日期比较: 大于当前日期返回true, 否则返回false.
    function compareToDate(dateStr, n) {
        if (dateStr) {
            var vdate = new Date(dateStr);
            vdate.setDate(vdate.getDate() + n);
            return vdate >= new Date();
        } else {
            return false;
        }
    }

    function privateCode(str, num) {
        var subs = str.substring(0, num);
        for (var i = num; i < str.length; i++) {
            subs += '*';
        }
        return subs;
    }
});